package main

import (
	"bufio"
	"bytes"
	"compress/gzip"
	"encoding/json"
	"fmt"
	"path"

	//"html"
	"html/template"
	"io"
	"io/fs"
	"log"
	"math"
	"math/rand"
	"net/http"
	"net/url"
	"os"
	"path/filepath"
	"regexp"
	"sort"
	"strconv"
	"strings"
	"time"

	"golang.org/x/net/html"
	"golang.org/x/net/html/charset"
	"golang.org/x/text/encoding/simplifiedchinese"
	"golang.org/x/text/transform"
)

// 初始化数据
func chushihua() {
	//初始化全局变量
	// 读取配置文件 如果失败初始化默认配置
	if !getconfig() {
		port = "18088"           //监听端口
		safeurl = "yibaocms"     // 后台安全地址
		safeuser = "yibaocms"    // 后台用户名
		safepass = "yibaocms123" // 后台密码
	} //读取配置文件

	var ok = true
	var chushihua = false
	allshuju, err := os.ReadFile("./backup/db/db.json")
	if err != nil {
		chushihua = true
	} else {
		//解压
		var buf bytes.Buffer
		buf.Write(allshuju)
		gr, err := gzip.NewReader(&buf)
		if err != nil {
			ok = false
		}
		defer gr.Close()
		allshujus, err := io.ReadAll(gr)
		if err != nil {
			ok = false
		}
		if ok {
			var backsj Backjson
			err := json.Unmarshal(allshujus, &backsj)
			if err != nil {
				chushihua = true
			} else {
				//恢复数据
				for k, v := range backsj.ChannelFieldData {
					channelfield.W(k, v)
				}
				for k, v := range backsj.ArticleFieldData {
					articlefield.W(k, v)
				}
				for k, v := range backsj.PostFieldData {
					postfield.W(k, v)
				}
				for k, v := range backsj.ChannelData {
					channel.W(k, v)
				}
				for k, v := range backsj.ArticleData {
					article.W(k, v)
				}
				for k, v := range backsj.PostData {
					post.W(k, v)
				}
				webfield.W("1", backsj.WebFieldData)
				friendlinks.W("1", backsj.FriendLinksData)
				miscellaneous.W("1", backsj.MiscellaneousData)
				topchannel.W("1", backsj.TopchannelData)
				toppost.W("1", backsj.ToppostData)
				tuisong.W("1", backsj.TuisongData)
				newarticle.W("1", backsj.NewarticleData)
				tag.W("1", backsj.TagData)
				pageview.W("1", backsj.PageviewData)
			}
		} else {
			chushihua = true
		}
	}
	if chushihua {
		//初始化数据库
		webfield.W("1", webzd)
		channelfield.W("1", channelzd)
		channelfield.W("2", channelzd)
		channelfield.W("3", channelzd)
		channelfield.W("4", channelzd)
		channelfield.W("5", channelzd)
		channelfield.W("6", channelzd)
		channelfield.W("7", channelzd)
		channelfield.W("8", channelzd)
		channelfield.W("9", channelzd)
		channelfield.W("10", channelzd)
		articlefield.W("1", articlezd)
		articlefield.W("2", articlezd)
		articlefield.W("3", articlezd)
		articlefield.W("4", articlezd)
		articlefield.W("5", articlezd)
		articlefield.W("6", articlezd)
		articlefield.W("7", articlezd)
		articlefield.W("8", articlezd)
		articlefield.W("9", articlezd)
		articlefield.W("10", articlezd)
		miscellaneous.W("1", zaxiangzd)
		tuisong.W("1", tuisonglist)
		pageview.W("1", 0)
		createDirectory("./static/qrcode/c")
		createDirectory("./static/qrcode/a")
		copydir("./init/templates/default", "./templates/index/default") //复制模板
		fs, _ := listFiles("./templates/index/default")
		for _, v := range fs {
			fileName := filepath.Base(v)
			data, _ := os.ReadFile(v)
			newdata := `{{define "index/default/` + fileName + `"}}<!--模板标识 请勿删除这行-->\n`
			newdata += string(data)
			newdata += `\n{{end}}<!--模板标识结束 请勿删除这行-->`
			newdata = strings.Replace(newdata, "\\n", "\n", -1)
			newdata = strings.ReplaceAll(newdata, "{{head}}", `{{template "index/default/head.htm".}}`)
			newdata = strings.ReplaceAll(newdata, "{{footer}}", `{{template "index/default/footer.htm".}}`)
			os.WriteFile("./templates/index/default/"+fileName, []byte(newdata), 0666)
		}
		updateTemplate() //更新模板
	}
}

// 获取配置
func getconfig() bool {
	// 打开文件
	file, err := os.Open("config.txt")
	if err != nil {
		return false
	}
	defer file.Close()
	scanner := bufio.NewScanner(file) // 创建一个扫描器用于逐行读取文件
	// 逐行读取并处理
	for scanner.Scan() {
		line := scanner.Text()
		parts := strings.SplitN(line, "=", 2) // 分割每行，最多分为两部分
		if len(parts) != 2 {
			continue // 跳过格式不正确的行
		}
		key := parts[0]
		value := parts[1]
		switch key {
		case "port":
			port = value
		case "safeurl":
			safeurl = value
		case "safeuser":
			safeuser = value
		case "safepass":
			safepass = value
		}
	}
	return true
}

// 保存数据到json
func savedata() {
	channels := make(map[string]map[string]string)
	articles := make(map[string]map[string]string)
	posts := make(map[string]map[string]string)
	channelzd := make(map[string][]Ziduan)
	articlezd := make(map[string][]Ziduan)
	postzd := make(map[string]PostfieldaddData)
	//历遍栏目
	channel.data.Range(func(key, value interface{}) bool {
		channels[key.(string)] = value.(map[string]string)
		return true
	})
	//历遍文章
	article.data.Range(func(key, value interface{}) bool {
		articles[key.(string)] = value.(map[string]string)
		return true
	})
	//历遍表单
	post.data.Range(func(key, value interface{}) bool {
		posts[key.(string)] = value.(map[string]string)
		return true
	})
	//历遍栏目字段
	channelfield.data.Range(func(key, value interface{}) bool {
		channelzd[key.(string)] = value.([]Ziduan)
		return true
	})
	//历遍文章字段
	articlefield.data.Range(func(key, value interface{}) bool {
		articlezd[key.(string)] = value.([]Ziduan)
		return true
	})
	//历遍表单字段
	postfield.data.Range(func(key, value interface{}) bool {
		postzd[key.(string)] = value.(PostfieldaddData)
		return true
	})
	var backsj = Backjson{
		WebFieldData:      webfield.R("1"),
		ChannelFieldData:  channelzd,
		ArticleFieldData:  articlezd,
		PostFieldData:     postzd,
		ChannelData:       channels,
		ArticleData:       articles,
		MiscellaneousData: miscellaneous.R("1"),
		FriendLinksData:   friendlinks.R("1"),
		PostData:          posts,
		TopchannelData:    topchannel.R("1"),
		ToppostData:       toppost.R("1"),
		TuisongData:       tuisong.R("1"),
		NewarticleData:    newarticle.R("1"),
		TagData:           tag.R("1"),
		PageviewData:      pageview.R("1"),
	}
	b, _ := json.Marshal(backsj)
	var buf bytes.Buffer
	gz := gzip.NewWriter(&buf) //开启压缩
	defer gz.Close()           // 确保压缩流关闭
	var ok = true
	if _, err := gz.Write(b); err != nil {
		ok = false
	}
	// 确保所有数据都被写入缓冲区
	if err := gz.Flush(); err != nil {
		ok = false
	}
	//关闭压缩
	if err := gz.Close(); err != nil {
		ok = false
	}
	if ok {
		savefile("./backup/db/db.json", buf.Bytes())
	}
}

// 备份数据
func backup_data() string {
	now := time.Now().Format("2006-01-02_15-04-05")
	backupFile := "./backup/back/" + now + ".json"
	channels := make(map[string]map[string]string)
	articles := make(map[string]map[string]string)
	posts := make(map[string]map[string]string)
	channelzd := make(map[string][]Ziduan)
	articlezd := make(map[string][]Ziduan)
	postzd := make(map[string]PostfieldaddData)
	//历遍栏目
	channel.data.Range(func(key, value interface{}) bool {
		channels[key.(string)] = value.(map[string]string)
		return true
	})
	//历遍文章
	article.data.Range(func(key, value interface{}) bool {
		articles[key.(string)] = value.(map[string]string)
		return true
	})
	//历遍表单
	post.data.Range(func(key, value interface{}) bool {
		posts[key.(string)] = value.(map[string]string)
		return true
	})
	//历遍栏目字段
	channelfield.data.Range(func(key, value interface{}) bool {
		channelzd[key.(string)] = value.([]Ziduan)
		return true
	})
	//历遍文章字段
	articlefield.data.Range(func(key, value interface{}) bool {
		articlezd[key.(string)] = value.([]Ziduan)
		return true
	})
	//历遍表单字段
	postfield.data.Range(func(key, value interface{}) bool {
		postzd[key.(string)] = value.(PostfieldaddData)
		return true
	})
	var backsj = Backjson{
		WebFieldData:      webfield.R("1"),
		ChannelFieldData:  channelzd,
		ArticleFieldData:  articlezd,
		PostFieldData:     postzd,
		ChannelData:       channels,
		ArticleData:       articles,
		MiscellaneousData: miscellaneous.R("1"),
		FriendLinksData:   friendlinks.R("1"),
		PostData:          posts,
		TopchannelData:    topchannel.R("1"),
		ToppostData:       toppost.R("1"),
		TuisongData:       tuisong.R("1"),
		NewarticleData:    newarticle.R("1"),
		TagData:           tag.R("1"),
		PageviewData:      pageview.R("1"),
	}
	b, _ := json.Marshal(backsj)
	var buf bytes.Buffer
	gz := gzip.NewWriter(&buf) //开启压缩
	defer gz.Close()           // 确保压缩流关闭
	var ok = true
	if _, err := gz.Write(b); err != nil {
		ok = false
	}
	// 确保所有数据都被写入缓冲区
	if err := gz.Flush(); err != nil {
		ok = false
	}
	//关闭压缩
	if err := gz.Close(); err != nil {
		ok = false
	}
	if ok {
		savefile(backupFile, buf.Bytes())
		return "新建备份成功！" + now + ".json<br>"
	} else {
		return "备份失败！"
	}
}

// 还原数据
func restore_data(filename string) string {
	data, err := os.ReadFile(filename)
	var ok = true
	if err != nil {
		ok = false
	}
	if len(data) >= 3 && data[0] == 0x1F && data[1] == 0x8B {
		//解压
		var buf bytes.Buffer
		buf.Write(data)
		gr, err := gzip.NewReader(&buf)
		if err != nil {
			ok = false
		}
		defer gr.Close()
		data, err = io.ReadAll(gr)
		if err != nil {
			ok = false
		}
	}
	if ok {
		var backsj Backjson
		err := json.Unmarshal(data, &backsj)
		if err == nil {
			webfield = &WebFieldData{}
			channelfield = &ChannelFieldData{}
			articlefield = &ArticleFieldData{}
			postfield = &PostFieldData{}
			channel = &ChannelData{}
			article = &ArticleData{}
			miscellaneous = &MiscellaneousData{}
			friendlinks = &FriendLinksData{}
			post = &PostData{}
			topchannel = &TopchannelData{}
			toppost = &ToppostData{}
			webfield.W("1", backsj.WebFieldData)
			miscellaneous.W("1", backsj.MiscellaneousData)
			friendlinks.W("1", backsj.FriendLinksData)
			topchannel.W("1", backsj.TopchannelData)
			toppost.W("1", backsj.ToppostData)
			tuisong.W("1", backsj.TuisongData)
			newarticle.W("1", backsj.NewarticleData)
			tag.W("1", backsj.TagData)
			pageview.W("1", backsj.PageviewData)
			for k, v := range backsj.ChannelData {
				channel.W(k, v)
			}
			for k, v := range backsj.ArticleData {
				article.W(k, v)
			}
			for k, v := range backsj.PostFieldData {
				postfield.W(k, v)
			}
			for k, v := range backsj.ChannelFieldData {
				channelfield.W(k, v)
			}
			for k, v := range backsj.ArticleFieldData {
				articlefield.W(k, v)
			}
			for k, v := range backsj.PostData {
				post.W(k, v)
			}
			return "还原数据成功！"
		}
	}
	return "还原数据失败！"
}

// 保存文件
func savefile(filename string, binaryData []byte) bool {
	// 确保目录存在
	dir := filepath.Dir("./" + filename)
	err := os.MkdirAll(dir, 0755)
	if err != nil {
		return false
	}
	// 打开或创建文件
	file, err := os.Create("./" + filename)
	if err != nil {
		return false
	}
	defer file.Close()
	// 将二进制数据写入文件
	_, err = file.Write([]byte(binaryData))
	if err != nil {
		return false
	}
	// 确保所有数据都被写入文件
	err = file.Sync()
	if err != nil {
		fmt.Println("保存文件失败:", err)
		return false
	}
	return true
}

// 删除切片中指定值
func removeString(s []string, v string) []string {
	l := []string{}
	for _, a := range s {
		if a != v {
			l = append(l, a)
		}
	}
	return l
}

// 获取字符串中指定字符后面部分
func removeBeforeAndInclude(str, target string) string {
	index := strings.Index(str, target)
	if index == -1 {
		return str
	}
	return str[index+len(target):]
}

// 删除字符串中指定字符a-b之间的字符(不包括b)
func removeBetweenIncludingStart(str, a, b string) string {
	start := strings.Index(str, a)
	if start == -1 {
		return str
	}
	end := strings.Index(str[start+len(a):], b)
	if end == -1 {
		return str
	}
	end += start + len(a)
	return str[:start] + str[end:]
}

// 删除非中文、字母和数字
func removeNonChineseAlphanumeric(s string) string {
	re := regexp.MustCompile(`[^\p{L}\p{N}]+`)
	return re.ReplaceAllStringFunc(html.EscapeString(s), func(r string) string {
		// 保留中文字符
		if len(r) == 1 && r >= "\u4e00" && r <= "\u9fff" {
			return r
		}
		// 移除非中文、字母和数字的字符
		return ""
	})
}

// 删除所有不是中文、字母和数字的字符
func removeInvalidChars(s string) string {
	re := regexp.MustCompile(`[^\p{Han}a-zA-Z0-9]`)      // 定义正则表达式，匹配所有非中文、字母和数字的字符
	return re.ReplaceAllString(html.EscapeString(s), "") // 使用正则表达式替换所有匹配的字符
}

// 删除所有不是字母和数字的字符
func removeNonAlphanumeric(s string) string {
	re := regexp.MustCompile(`[^a-zA-Z0-9]`)             // 定义正则表达式，匹配所有非字母和非数字的字符
	return re.ReplaceAllString(html.EscapeString(s), "") // 使用正则表达式替换所有匹配的字符
}

// 删除所有不是字母、数字和_的字符
func removeNonAlphanumericAndUnderscore(s string) string {
	re := regexp.MustCompile(`[^a-zA-Z0-9_]`)
	return re.ReplaceAllString(s, "")
}

// 删除所有不是数字的字符串
func removeNonNumeric(s string) string {
	re := regexp.MustCompile(`[^0-9]`)                // 定义正则表达式，匹配所有非数字的字符
	s = re.ReplaceAllString(html.EscapeString(s), "") // 使用正则表达式替换所有匹配的字符
	if len(s) == 0 {
		return ""
	}
	if s[0] == '0' {
		return ""
	}
	return s
}

// 删除所有不是数字和_的字符串
func removeNonNumericAnd_(s string) string {
	re := regexp.MustCompile(`[^0-9_]`)               // 定义正则表达式，匹配所有非数字和_的字符
	s = re.ReplaceAllString(html.EscapeString(s), "") // 使用正则表达式替换所有匹配的字符
	if len(s) == 0 {
		return ""
	}
	if s[0] == '0' {
		return ""
	}
	return s
}

// 删除所有不是中文、字母和数字的字符串 用于搜索
func removeNonChinese(s string) string {
	s = strings.ReplaceAll(html.EscapeString(s), " ", ",")
	s = strings.ReplaceAll(s, "，", ",")
	s = strings.ReplaceAll(s, "-", ",")
	re := regexp.MustCompile(`[^a-zA-Z0-9,_\p{Han}]+`)
	return re.ReplaceAllString(s, "")
}

// 判断网址是否有效
func isUrl(s string) bool {
	u, err := url.ParseRequestURI(s)
	if err != nil {
		return false
	}
	if u.Scheme == "" || u.Host == "" {
		return false
	}
	return true
}

// 获取网址协议 host 路径
func parseURL(s string) (string, string, string, error) {
	u, err := url.Parse(s)
	if err != nil {
		return "", "", "", err
	}
	scheme := u.Scheme
	host := u.Host
	path := u.Path
	return scheme, host, path, nil
}

// 创建目录
func createDirectory(dirName string) {
	os.MkdirAll(dirName, 0755)
}

// copyFile 拷贝单个文件
func copyfile(src, dst string) (int64, error) {
	sourceFileStat, err := os.Stat(src)
	if err != nil {
		return 0, err
	}

	// 如果源文件不存在
	if !sourceFileStat.Mode().IsRegular() {
		return 0, fmt.Errorf("%s is not a regular file", src)
	}

	source, err := os.Open(src)
	if err != nil {
		return 0, err
	}
	defer source.Close()

	destination, err := os.Create(dst)
	if err != nil {
		return 0, err
	}
	defer destination.Close()
	nBytes, err := io.Copy(destination, source)
	return nBytes, err
}

// copyDir 拷贝整个目录
func copydir(src string, dst string) error {
	srcInfo, err := os.Stat(src)
	if err != nil {
		return err
	}
	err = os.MkdirAll(dst, srcInfo.Mode())
	if err != nil {
		return err
	}
	dirEntries, err := os.ReadDir(src)
	if err != nil {
		return err
	}
	for _, entry := range dirEntries {
		srcPath := filepath.Join(src, entry.Name())
		dstPath := filepath.Join(dst, entry.Name())
		if entry.IsDir() {
			err = copydir(srcPath, dstPath)
			if err != nil {
				return err
			}
		} else {
			_, err = copyfile(srcPath, dstPath)
			if err != nil {
				return err
			}
		}
	}
	return nil
}

// 删除指定目录
func deleteDirectory(dir string) error {
	err := filepath.Walk(dir, func(path string, info os.FileInfo, err error) error {
		if err != nil {
			return err
		}
		if info.IsDir() {
			return nil
		}
		return os.Remove(path)
	})
	if err != nil {
		return err
	}
	return os.RemoveAll(dir)
}

// 获取指定目录及其子目录下的所有文件
func listFiles(dir string) ([]string, error) {
	var files []string
	// 使用 filepath.WalkDir 遍历目录
	err := filepath.WalkDir(dir, func(path string, d fs.DirEntry, err error) error {
		if err != nil {
			return err
		}
		if !d.IsDir() {
			files = append([]string{path}, files...)
		}
		return nil
	})
	if err != nil {
		return nil, err
	}
	return files, nil
}

// 获取文件尺寸
func getFileSize(filePath string) (float64, error) {
	fileInfo, err := os.Stat(filePath)
	if err != nil {
		return 0, err
	}
	fileSize := fileInfo.Size()
	// 转换为KB
	fileSizeInKB := float64(fileSize) / 1024.0

	// 返回保留两位小数的结果
	return fileSizeInKB, nil
}

// 获取指定目录下的子目录
func getSubDirectories(dirPath string) ([]string, error) {
	var subDirs []string
	entries, err := os.ReadDir(dirPath)
	if err != nil {
		return nil, err
	}
	for _, entry := range entries {
		if entry.IsDir() {
			subDirs = append(subDirs, entry.Name())
		}
	}
	return subDirs, nil
}

// 判断文件是否存在
func fileExists(filePath string) bool {
	_, err := os.Stat(filePath)
	if err == nil {
		return true
	}
	if os.IsNotExist(err) {
		return false
	}
	return false
}

// 删除栏目
func Deletechannel(channels []string) {
	//删除栏目
	for _, v := range channels {
		csj := channel.R(v)
		if csj["topid"] == "0" {
			tc := topchannel.R("1")
			for i, v2 := range tc {
				if v2 == v {
					tc = append(tc[:i], tc[i+1:]...)
				}
			}
			topchannel.W("1", tc) //保存删除后的顶级栏目列表
		} else {
			csj2 := channel.R(csj["topid"]) //获取顶级栏目
			if csj2 != nil {
				var subid2 = strings.Split(csj2["subid"], ",")
				if subid2[0] != "" {
					for i, v2 := range subid2 {
						if v2 == v {
							subid2 = append(subid2[:i], subid2[i+1:]...)
						}
					}
					csj2["subid"] = strings.Join(subid2, ",")
					channel.W(csj["topid"], csj2) //保存删除后的顶级栏目
				}
			}
		}
		var subid = strings.Split(csj["subid"], ",")
		if subid[0] != "" {
			Deletechannel(subid)
		}
		var artid = strings.Split(csj["artid"], ",")
		if artid[0] != "" {
			Deletecontent(artid, v)
		}
		channel.D(v) //删除栏目数据
		// 删除二维码
		if fileExists("./static/qrcode/c/" + v + ".png") {
			os.Remove("./static/qrcode/c/" + v + ".png")
		}
	}
}

// 删除文章
func Deletecontent(artid []string, cid string) {
	for _, v := range artid {
		delartid(v, cid)
		article.D(v)
		newarticle.Del("1", v)
		// 删除二维码
		if fileExists("./static/qrcode/a/" + v + ".png") {
			os.Remove("./static/qrcode/a/" + v + ".png")
		}
	}
}

// 将文章id递归删除
func delartid(aid, cid string) {
	//获取栏目信息
	csj := channel.R(cid)
	if csj["artid"] != "" {
		artid := strings.Split(csj["artid"], ",")
		for i, v := range artid {
			if v == aid {
				artid = append(artid[:i], artid[i+1:]...)
				csj["artid"] = strings.Join(artid, ",")
				channel.W(cid, csj) //更新栏目数据
				if csj["topid"] != "0" {
					delartid(aid, csj["topid"])
				}
				return
			}
		}
	}
}

// 将文章id递归添加到所属目录
func addartid(aid, cid string) {
	//获取栏目信息
	csj := channel.R(cid)
	if csj["artid"] == "" {
		csj["artid"] = aid
	} else {
		csj["artid"] = aid + "," + csj["artid"]
	}
	if csj["topid"] != "0" {
		addartid(aid, csj["topid"])
	}
	channel.W(cid, csj)
}

// 获取随机字符串
func getrand(length int) string {
	characters := "abcdefghijklmnopqrstuvwxyz0123456789"
	result := make([]byte, length)
	r := rand.New(rand.NewSource(time.Now().UnixNano()))
	for i := 0; i < length; i++ {
		result[i] = characters[r.Intn(len(characters))]
	}
	return string(result)
}

// 更新二维码
func upqrcode(url string) {
	createDirectory("./static/qrcode/c")
	createDirectory("./static/qrcode/a")
	generateqrcode2(url) //生成首页二维码
	channel.data.Range(func(key, value interface{}) bool {
		cid := key.(string)
		generateqrcode(url, "c", cid) //生成栏目二维码
		return true
	})
	lmlx := map[string]string{}
	article.data.Range(func(key, value interface{}) bool {
		aid := key.(string)
		asj := value.(map[string]string)
		if lmlx[asj["topid"]] == "" {
			csj := channel.R(asj["topid"])
			lmlx[asj["topid"]] = csj["lx"]
		}
		if lmlx[asj["topid"]] == "3" {
			generateqrcode3(url, asj["title"], aid) // 生成二维码
		} else {
			generateqrcode(url, "a", aid) //生成文章二维码
		}
		return true
	})
}

// 解压数据
func unzip(filename string) (string, string) {
	var ok = true
	fileN := path.Base(filename)
	data, err := os.ReadFile(filename)
	if err != nil {
		ok = false
	}
	if len(data) >= 3 && data[0] == 0x1F && data[1] == 0x8B {
		//解压
		var buf bytes.Buffer
		buf.Write(data)
		gr, err := gzip.NewReader(&buf)
		if err != nil {
			ok = false
		}
		defer gr.Close()
		data, err = io.ReadAll(gr)
		if err != nil {
			ok = false
		}
	}
	if ok {
		//将读取的内容转换为字符串
		content := string(data)
		return fileN, content
	}
	return "", ""
}

// 更新MAP
func upmap() {
	//获取dir link mlink
	var link string
	sj := webfield.R("1")
	//历遍sj
	for _, v := range sj {
		if v.K == "link" {
			link = v.V
		}
	}
	//更新txt
	var txt, xml, html string
	rq := time.Now().Format("2006-01-02")
	txt += link + "\n"
	xmltou := `<?xml version="1.0" encoding="utf-8"?>\n<urlset>\n`
	xmlhome := `<url>\n<loc>` + link + `</loc>\n<lastmod>` + rq + `</lastmod>\n<changefreq>daily</changefreq>\n<priority>1.0</priority>\n</url>\n`
	xmlwei := `</urlset>\n`
	html += `<!DOCTYPE html><html><head><meta charset="UTF-8"><meta name="viewport" content="width=device-width,initial-scale=1, minimum-scale=1, maximum-scale=1, user-scalable=no" /><title>网站地图</title></head><body>`
	html += `<p>首页：<a href="` + link + `">网站首页</a></p>`
	js := 0
	js2 := 0
	xml = ""
	txt = ""
	arrxml := []string{}
	arrtxt := []string{}
	jinyong := map[string]string{}
	//历遍栏目
	channel.data.Range(func(key, value interface{}) bool {
		js++
		cid := key.(string)
		csj := value.(map[string]string)
		if csj["lx"] == "3" {
			jinyong[cid] = "1"
			return true
		}
		txt += link + "/c/" + cid + "\n"
		xml += "<url>\n<loc>" + link + "/c/" + cid + "</loc>\n<lastmod>" + rq + "</lastmod>\n<changefreq>daily</changefreq>\n<priority>0.9</priority>\n</url>\n"
		html += `<p>目录：<a href="` + link + `/c/` + cid + `">` + csj["title"] + `</a></p>`
		if js == 500 {
			savefile(fmt.Sprintf(`./map/sitemap_c_%d.xml`, js2), []byte(strings.Replace(xmltou+xml+xmlwei, "\\n", "\n", -1)))
			savefile(fmt.Sprintf(`./map/sitemap_c_%d.txt`, js2), []byte(strings.Replace(txt, "\\n", "\n", -1)))
			arrxml = append(arrxml, fmt.Sprintf(`%s/sitemap_c_%d.xml`, link, js2))
			arrtxt = append(arrtxt, fmt.Sprintf(`%s/sitemap_c_%d.txt`, link, js2))
			js = 0
			js2++
			xml = ""
			txt = ""
		}
		return true
	})
	if xml != "" {
		savefile(fmt.Sprintf(`./map/sitemap_c_%d.xml`, js2), []byte(strings.Replace(xmltou+xml+xmlwei, "\\n", "\n", -1)))
		savefile(fmt.Sprintf(`./map/sitemap_c_%d.txt`, js2), []byte(strings.Replace(txt, "\\n", "\n", -1)))
		arrxml = append(arrxml, fmt.Sprintf(`%s/sitemap_c_%d.xml`, link, js2))
		arrtxt = append(arrtxt, fmt.Sprintf(`%s/sitemap_c_%d.txt`, link, js2))
	}
	js = 0
	js2 = 0
	xml = ""
	txt = ""
	//历遍文章
	article.data.Range(func(key, value interface{}) bool {
		js++
		aid := key.(string)
		asj := value.(map[string]string)
		if _, ok := jinyong[asj["topid"]]; ok {
			return true
		}
		txt += link + "/a/" + aid + "\n"
		xml += "<url>\n<loc>" + link + "/a/" + aid + "</loc>\n<lastmod>" + rq + "</lastmod>\n<changefreq>daily</changefreq>\n<priority>0.8</priority>\n</url>\n"
		html += `<p>文章：<a href="` + link + `/a/` + aid + `">` + asj["title"] + `</a></p>`
		if js == 500 {
			savefile(fmt.Sprintf(`./map/sitemap_a_%d.xml`, js2), []byte(strings.Replace(xmltou+xml+xmlwei, "\\n", "\n", -1)))
			savefile(fmt.Sprintf(`./map/sitemap_a_%d.txt`, js2), []byte(strings.Replace(txt, "\\n", "\n", -1)))
			arrxml = append(arrxml, fmt.Sprintf(`%s/sitemap_a_%d.xml`, link, js2))
			arrtxt = append(arrtxt, fmt.Sprintf(`%s/sitemap_a_%d.txt`, link, js2))
			js = 0
			js2++
			xml = ""
			txt = ""
		}
		return true
	})
	if xml != "" {
		savefile(fmt.Sprintf(`./map/sitemap_a_%d.xml`, js2), []byte(strings.Replace(xmltou+xml+xmlwei, "\\n", "\n", -1)))
		savefile(fmt.Sprintf(`./map/sitemap_a_%d.txt`, js2), []byte(strings.Replace(txt, "\\n", "\n", -1)))
		arrxml = append(arrxml, fmt.Sprintf(`%s/sitemap_a_%d.xml`, link, js2))
		arrtxt = append(arrtxt, fmt.Sprintf(`%s/sitemap_a_%d.txt`, link, js2))
	}
	js = 0
	js2 = 0
	xml = xmltou + xmlhome
	txt = ""
	html += "</body></html>"
	for _, v := range arrxml {
		xml += "<url>\n<loc>" + v + "</loc>\n<lastmod>" + rq + "</lastmod>\n<changefreq>daily</changefreq>\n<priority>0.9</priority>\n</url>\n"
	}
	xml += xmlwei
	for _, v := range arrtxt {
		txt += v + "\n"
	}
	savefile("./map/sitemap.xml", []byte(strings.Replace(xml, "\\n", "\n", -1)))
	savefile("./map/sitemap.txt", []byte(strings.Replace(txt, "\\n", "\n", -1)))
	savefile("./map/sitemap.html", []byte(html))
	//更新robots
	txt = ""
	txt += "User-agent: * \n"
	txt += "Allow: / \n"
	txt += "Sitemap: " + link + "/sitemap.xml \n"
	txt += "Sitemap: " + link + "/sitemap.txt \n"
	txt = strings.Replace(txt, "\\n", "\n", -1)
	savefile("./map/robots.txt", []byte(txt))
	html = ""
	xml = ""
	txt = ""
	jinyong = map[string]string{}
}

// 判断字符串是否在切片中
func existsInSlice(slice []string, value string) bool {
	for _, item := range slice {
		if item == value {
			return true
		}
	}
	return false
}

// 判断字符串是否包含在切片中 关键词 搜索用
func containsValue(str string, keys []string) int {
	i := 0
	for _, value := range keys {
		if strings.Contains(str, value) {
			i++
		}
	}
	return i
}

// 将搜索结果关键词加红显示
func addtags(str string, values []string) string {
	for _, value := range values {
		str = strings.ReplaceAll(str, value, `<font  style="color:red;">`+value+`</font >`)
	}
	return str
}

// 获取切片指定值的前一个和后一个值
func getPrevAndNext(slice []string, target string) (string, string) {
	var prev, next string
	for i, v := range slice {
		if v == target {
			if i > 0 {
				prev = slice[i-1]
			} else {
				prev = ""
			}
			if i < len(slice)-1 {
				next = slice[i+1]
			} else {
				next = ""
			}
			return prev, next
		}
	}
	return "", "" // 如果未找到目标值，返回空 表示不存在
}

// 获取导航 wid网站id row数量 noid排除id muban顶级栏目模板 muban2二级栏目模板
func getnavigation(wid, cid, row, noid, muban, muban2 string) template.HTML {
	num, ok := strconv.Atoi(row)
	if ok != nil {
		num = 100
	}
	noids := strings.Split(noid, ",")
	var neirong string = ""
	daohang := topchannel.R("1")
	topid := channel.R(cid)["topid"]
	if len(daohang) > 0 {
		i := 0
		for _, cid1 := range daohang {
			if i >= num {
				break
			}
			if existsInSlice(noids, cid1) {
				continue
			}
			csj := channel.R(cid1)
			if csj["lx"] == "3" {
				continue
			}
			mb := ""
			mb = strings.ReplaceAll(muban, "[c_id]", cid1)
			for k, v2 := range csj {
				mb = strings.ReplaceAll(mb, "[c_"+k+"]", v2)
			}
			mb2 := ""
			erjidaohang := strings.Split(csj["subid"], ",") //转切片
			if len(erjidaohang) > 0 && erjidaohang[0] != "" {
				for _, cid2 := range erjidaohang {
					csj2 := channel.R(cid2)
					mb3 := strings.ReplaceAll(muban2, "[c_id]", cid2)
					for k, v2 := range csj2 {
						mb3 = strings.ReplaceAll(mb3, "[c_"+k+"]", v2)
					}
					//匹配专属cid属性
					re := regexp.MustCompile(`\{([^}]+)\}`)
					matches := re.FindAllStringSubmatch(mb3, -1)
					for _, match := range matches {
						if cid2 == cid {
							mb3 = strings.ReplaceAll(mb3, match[0], match[1])
						} else {
							mb3 = strings.ReplaceAll(mb3, match[0], "")
						}
					}
					mb2 += mb3
				}
			}
			mb = strings.ReplaceAll(mb, "{erji}", mb2)
			//匹配专属cid属性
			re := regexp.MustCompile(`\{([^}]+)\}`)
			matches := re.FindAllStringSubmatch(mb, -1)
			for _, match := range matches {
				if cid1 == cid || cid1 == topid {
					mb = strings.ReplaceAll(mb, match[0], match[1])
				} else {
					mb = strings.ReplaceAll(mb, match[0], "")
				}
			}
			neirong += mb
			i++
		}
	}
	return template.HTML(neirong)
}

// 获取相关栏目wid网站id cid栏目id row数量 noid排除id muban顶级栏目模板
func getgxlanmu(wid, cid, row, noid, muban string) template.HTML {
	var neirong string
	num, ok := strconv.Atoi(row)
	if ok != nil {
		num = 100
	}
	noids := strings.Split(noid, ",")
	i := 0
	csj := channel.R(cid)
	var strsubid string
	if csj["topid"] == "0" {
		strsubid = csj["subid"]
	} else {
		if csj["subid"] != "" {
			strsubid = csj["subid"]
		} else {
			csj := channel.R(csj["topid"])
			strsubid = csj["subid"]
		}
	}
	if strsubid != "" {
		lanmus := strings.Split(strsubid, ",") //转切片
		if len(lanmus) > 0 && lanmus[0] != "" {
			for _, lanmu := range lanmus {
				if i >= num {
					break
				}
				if existsInSlice(noids, lanmu) {
					continue
				}
				csj := channel.R(lanmu)
				mb := strings.ReplaceAll(muban, "[c_id]", lanmu)
				for k, v := range csj {
					mb = strings.ReplaceAll(mb, "[c_"+k+"]", v)
				}
				//匹配专属cid属性
				re := regexp.MustCompile(`\{([^}]+)\}`)
				matches := re.FindAllStringSubmatch(mb, -1)
				for _, match := range matches {
					if lanmu == cid {
						mb = strings.ReplaceAll(mb, match[0], match[1])
					} else {
						mb = strings.ReplaceAll(mb, match[0], "")
					}
				}
				neirong += mb
				i++
			}
		}
	}
	return template.HTML(neirong)
}

// 获取文章列表 wid网站id cid栏目id row数量 yema页码 muban顶级栏目模板
func getarticle(wid, cid, row, yema, muban string) Artlist {
	num, ok := strconv.Atoi(row)
	if ok != nil {
		num = 20
	}
	yemai, err := strconv.Atoi(yema)
	if err != nil {
		yemai = 1
	}
	if yemai < 1 {
		yemai = 1
	}
	ksid := (yemai - 1) * num
	jsid := ksid + num
	i := 0
	var neirong string = ""
	var neirong2 string = ""
	if cid == "" {
		asjs := newarticle.R(wid)
		zsl := len(asjs)
		if zsl > 0 {
			if ksid >= zsl {
				ksid = zsl
			}
			if jsid > zsl {
				jsid = zsl
			}
			for _, id := range asjs[ksid:jsid] {
				if i >= num {
					break
				}
				asj := article.R(id)
				y, m, d, h, m2, s := timefenjie(asj["time"])
				mb := strings.ReplaceAll(muban, "[a_id]", id)
				mb = strings.ReplaceAll(mb, "[y]", y)
				mb = strings.ReplaceAll(mb, "[m]", m)
				mb = strings.ReplaceAll(mb, "[d]", d)
				mb = strings.ReplaceAll(mb, "[h]", h)
				mb = strings.ReplaceAll(mb, "[i]", m2)
				mb = strings.ReplaceAll(mb, "[s]", s)
				for k, v3 := range asj {
					mb = strings.ReplaceAll(mb, "[a_"+k+"]", v3)
				}
				csj := channel.R(asj["topid"])
				for k, v3 := range csj {
					mb = strings.ReplaceAll(mb, "[c_"+k+"]", v3)
				}
				neirong += mb
				i++
			}
		} else {
			neirong = "暂无相关文章"
		}
	} else {
		csj := channel.R(cid)
		artids := strings.Split(csj["artid"], ",") //转切片
		zsl := len(artids)
		if ksid >= zsl {
			ksid = zsl
		}
		if jsid > zsl {
			jsid = zsl
		}
		if zsl > 0 && artids[0] != "" {
			for _, id := range artids[ksid:jsid] {
				if i >= num {
					break
				}
				asj := article.R(id)
				y, m, d, h, m2, s := timefenjie(asj["time"])
				mb := strings.ReplaceAll(muban, "[a_id]", id)
				mb = strings.ReplaceAll(mb, "[y]", y)
				mb = strings.ReplaceAll(mb, "[m]", m)
				mb = strings.ReplaceAll(mb, "[d]", d)
				mb = strings.ReplaceAll(mb, "[h]", h)
				mb = strings.ReplaceAll(mb, "[i]", m2)
				mb = strings.ReplaceAll(mb, "[s]", s)
				for k, v3 := range asj {
					mb = strings.ReplaceAll(mb, "[a_"+k+"]", v3)
				}
				if asj["topid"] == cid {
					for k, v3 := range csj {
						mb = strings.ReplaceAll(mb, "[c_"+k+"]", v3)
					}
				} else {
					csj2 := channel.R(asj["topid"])
					for k, v3 := range csj2 {
						mb = strings.ReplaceAll(mb, "[c_"+k+"]", v3)
					}
				}
				neirong += mb
				i++
			}
			yes := math.Ceil(float64(zsl) / float64(num))
			if yes > 1 {
				for y := 1; y <= int(yes); y++ {
					if y == yemai {
						neirong2 += `<a href="/c/` + cid + `_` + strconv.Itoa(y) + `"><b>` + strconv.Itoa(y) + `</b></a>`
					} else {
						neirong2 += `<a href="/c/` + cid + `_` + strconv.Itoa(y) + `">` + strconv.Itoa(y) + `</a>`
					}
				}
			}
		} else {
			neirong = "暂无相关文章"
		}
	}
	return Artlist{
		List: template.HTML(neirong),
		Page: template.HTML(neirong2),
	}
}

// 获取友情连接
func getflink(wid, row, muban string) template.HTML {
	num, ok := strconv.Atoi(row)
	if ok != nil {
		num = 20
	}
	i := 0
	var neirong string = ""
	flinks := friendlinks.R("1")
	for _, v2 := range flinks {
		if i >= num {
			break
		}
		mb := strings.ReplaceAll(muban, "[title]", v2.N)
		mb = strings.ReplaceAll(mb, "[link]", v2.V)
		neirong += mb
		i++
	}
	return template.HTML(neirong)
}

// 获取指定栏目title
func getchanneltitle(wid, cid string) string {
	return channel.R(cid)["title"]
}

// 获取搜索数据
func getsearchlist(wid, key, row, yema, muban string) Artlist {
	keys := strings.Split(key, ",") //转切片
	num, ok := strconv.Atoi(row)
	if ok != nil {
		num = 20
	}
	yemai, err := strconv.Atoi(yema)
	if err != nil {
		yemai = 1
	}
	if yemai < 1 {
		yemai = 1
	}

	var neirong string = ""
	var neirong2 string = ""
	list := []Searchlist{}
	listmap := make(map[string]map[string]string)
	lcsj := make(map[string]string)
	article.data.Range(func(key, value interface{}) bool {
		if asj, ok := value.(map[string]string); ok {
			if lcsj[asj["topid"]] == "" {
				csj := channel.R(asj["topid"])
				lcsj[asj["topid"]] = csj["lx"]
			}
			if lcsj[asj["topid"]] == "1" {
				nums := containsValue(asj["title"], keys) + containsValue(asj["keywords"], keys) + containsValue(asj["description"], keys)
				if nums > 0 {
					id := key.(string)
					listmap[id] = asj
					list = append(list, Searchlist{I: id, N: nums})
				}
			}
		}
		return true
	})
	zsl := len(list)
	ksid := (yemai - 1) * num
	jsid := ksid + num
	i := 0
	if ksid >= zsl {
		ksid = zsl
	}
	if jsid > zsl {
		jsid = zsl
	}
	if zsl > 0 && ksid < zsl && jsid <= zsl {
		// 按值排序
		sort.Slice(list, func(i, j int) bool {
			return list[i].N > list[j].N
		})
		//历遍
		for _, v := range list[ksid:jsid] {
			if i >= num {
				break
			}
			asj := listmap[v.I]
			y, m, d, h, m2, s := timefenjie(asj["time"])
			mb := strings.ReplaceAll(muban, "[a_id]", v.I)
			mb = strings.ReplaceAll(mb, "[y]", y)
			mb = strings.ReplaceAll(mb, "[m]", m)
			mb = strings.ReplaceAll(mb, "[d]", d)
			mb = strings.ReplaceAll(mb, "[h]", h)
			mb = strings.ReplaceAll(mb, "[i]", m2)
			mb = strings.ReplaceAll(mb, "[s]", s)
			for k, v3 := range asj {
				if k == "title" || k == "keywords" || k == "description" {
					mb = strings.ReplaceAll(mb, "[a_"+k+"]", addtags(v3, keys)) //加红
					continue
				}
				mb = strings.ReplaceAll(mb, "[a_"+k+"]", v3)
			}
			neirong += mb
			i++
		}
		yes := math.Ceil(float64(zsl) / float64(num))
		if yes > 1 {
			for y := 1; y <= int(yes); y++ {
				if y == yemai {
					neirong2 += fmt.Sprintf(`<a href="/s/%s_%d"><b>%d</b></a>`, key, y, y)
				} else {
					neirong2 += fmt.Sprintf(`<a href="/s/%s_%d">%d</a>`, key, y, y)
				}
			}
		}
	} else {
		neirong = "没有相关内容"
	}
	return Artlist{
		List: template.HTML(neirong),
		Page: template.HTML(neirong2),
	}
}

// 获取查询数据
func get_art2(wid, title string) map[string]string {
	var sj2 = make(map[string]string)
	lcsj := make(map[string]string)
	you := false
	article.data.Range(func(key, value interface{}) bool {
		if asj, ok := value.(map[string]string); ok {
			if lcsj[asj["topid"]] == "" {
				csj := channel.R(asj["topid"])
				lcsj[asj["topid"]] = csj["lx"]
			}
			if lcsj[asj["topid"]] == "3" && asj["title"] == title {
				you = true
				for k, v2 := range asj {
					sj2["a_"+k] = html.UnescapeString(v2)
				}
				//获取所属栏目数据
				csj := channel.R(asj["topid"])
				for k, v4 := range csj {
					sj2["c_"+k] = html.UnescapeString(v4)
				}
				//获取网站数据
				webzd := webfield.R("1")
				for _, v := range webzd {
					sj2["w_"+v.K] = v.V
				}
				//获取当前位置
				sj2["position"] = ""
				sj2["position"] += `<a href="` + sj2["w_link"] + `">` + sj2["w_homename"] + `</a> > `
				if sj2["c_topid"] == "0" {
					sj2["position"] += `<a href="` + sj2["w_link"] + `/c/` + asj["topid"] + `">` + sj2["c_title"] + `</a> >`
				} else {
					csj5 := channel.R(sj2["c_topid"])
					sj2["position"] += `<a href="` + sj2["w_link"] + `/c/` + sj2["c_topid"] + `">` + csj5["title"] + `</a> > `
					sj2["position"] += `<a href="` + sj2["w_link"] + `/c/` + asj["topid"] + `">` + sj2["c_title"] + `</a> >`
				}
				sj2["w_id"] = wid
				return false
			}
		}
		return true
	})
	if !you {
		return nil
	}
	sj2["z_muban"] = miscellaneous.R("1")["muban"]
	return sj2
}

// 将字符串转为html
func tohtml(str string) template.HTML {
	return template.HTML(str)
}

// 时间转换
func totime(str, muban string) string {
	t, _ := time.Parse("2006-01-02 15:04:05.999999999 -0700 MST", str)
	return t.Format(muban)
}

// 时间分解
func timefenjie(str string) (string, string, string, string, string, string) {
	t, _ := time.Parse("2006-01-02 15:04:05.999999999 -0700 MST", str)
	return t.Format("2006"), t.Format("01"), t.Format("02"), t.Format("15"), t.Format("04"), t.Format("05")
}

// 获取网站信息
func get_info(wid string) map[string]string {
	webzd := webfield.R("1")
	if webzd == nil {
		return nil
	}
	var sj2 = make(map[string]string)
	for _, v := range webzd {
		sj2["w_"+v.K] = v.V
	}
	sj2["w_id"] = wid
	sj2["c_id"] = "a"
	sj2["z_muban"] = miscellaneous.R("1")["muban"]
	return sj2
}

// 获取栏目信息
func get_list(wid, cid2 string) map[string]string {
	qp := strings.Split(cid2, "_") //转切片
	if qp[0] == "" {
		return nil
	}
	cid := qp[0]
	yema := 1

	if len(qp) > 1 && qp[1] != "" {
		yema2, err := strconv.Atoi(qp[1])
		if err == nil {
			yema = yema2
		}
	}
	csj := channel.R(cid)
	if csj["title"] == "" {
		return nil
	}
	var sj2 = make(map[string]string)
	for k, v2 := range csj {
		sj2["c_"+k] = html.UnescapeString(v2)
	}
	sj2["c_id"] = cid
	sj2["c_yema"] = strconv.Itoa(yema)
	if yema > 1 {
		sj2["c_yema2"] = ` 第` + strconv.Itoa(yema) + `页`
	} else {
		sj2["c_yema2"] = ``
	}
	//获取网站数据
	webzd := webfield.R("1")
	for _, v := range webzd {
		sj2["w_"+v.K] = v.V
	}
	//获取当前位置
	sj2["position"] = ""
	sj2["position"] += `<a href="` + sj2["w_link"] + `">` + sj2["w_homename"] + `</a> > `
	if csj["topid"] == "0" {
		sj2["position"] += `<a href="` + sj2["w_link"] + `/c/` + cid + `">` + sj2["c_title"] + `</a> >`
	} else {
		csj5 := channel.R(sj2["c_topid"])
		sj2["position"] += `<a href="` + sj2["w_link"] + `/c/` + csj["topid"] + `">` + csj5["title"] + `</a> > `
		sj2["position"] += `<a href="` + sj2["w_link"] + `/c/` + cid + `">` + sj2["c_title"] + `</a> >`
	}
	sj2["w_id"] = wid
	sj2["z_muban"] = miscellaneous.R("1")["muban"]
	return sj2
}

// 获取文章信息
func get_art(wid, aid string) map[string]string {
	asj := article.R(aid)
	if asj["title"] == "" {
		return nil
	}
	var sj2 = make(map[string]string)
	looks, err := strconv.Atoi(asj["looks"])
	if err != nil {
		looks = 0
	}
	looks++
	asj["looks"] = strconv.Itoa(looks)
	article.W(aid, asj) //更新浏览量
	for k, v2 := range asj {
		sj2["a_"+k] = html.UnescapeString(v2)
	}
	sj2["y"], sj2["m"], sj2["d"], sj2["h"], sj2["i"], sj2["s"] = timefenjie(asj["time"])
	sj2["a_id"] = aid
	sj2["c_id"] = asj["topid"]
	//获取所属栏目数据
	csj := channel.R(asj["topid"])
	for k, v4 := range csj {
		sj2["c_"+k] = html.UnescapeString(v4)
	}
	artids := strings.Split(csj["artid"], ",") //转切片
	previd, nextid := getPrevAndNext(artids, aid)
	sj2["previd"] = ""
	sj2["prevtitle"] = ""
	sj2["prev"] = `上一篇:没有了`
	sj2["nextid"] = ""
	sj2["nexttitle"] = ""
	sj2["next"] = `下一篇:没有了`
	if previd != "" {
		lsasj := article.R(previd)
		if lsasj != nil {
			sj2["previd"] = previd
			sj2["prevtitle"] = lsasj["title"]
			sj2["prev"] = `上一篇:<a href="/a/` + previd + `">` + lsasj["title"] + `</a>`
		}
	}
	if nextid != "" {
		lsasj := article.R(nextid)
		if lsasj != nil {
			sj2["nextid"] = nextid
			sj2["nexttitle"] = lsasj["title"]
			sj2["next"] = `下一篇:<a href="/a/` + nextid + `">` + lsasj["title"] + `</a>`
		}
	}
	sj2["a_tags"] = ""
	if asj["tags"] != "" {
		arrtsgs := strings.Split(asj["tags"], ",")
		for _, v := range arrtsgs {
			if v != "" {
				sj2["a_tags"] += fmt.Sprintf(`<a href="/s/%s">%s</a> `, v, v)
			}
		}
	}
	//获取网站数据
	webzd := webfield.R("1")
	for _, v := range webzd {
		sj2["w_"+v.K] = v.V
	}
	//获取当前位置
	sj2["position"] = ""
	sj2["position"] += `<a href="` + sj2["w_link"] + `">` + sj2["w_homename"] + `</a> > `
	if sj2["c_topid"] == "0" {
		sj2["position"] += `<a href="` + sj2["w_link"] + `/c/` + asj["topid"] + `">` + sj2["c_title"] + `</a> >`
	} else {
		csj5 := channel.R(sj2["c_topid"])
		sj2["position"] += `<a href="` + sj2["w_link"] + `/c/` + sj2["c_topid"] + `">` + csj5["title"] + `</a> > `
		sj2["position"] += `<a href="` + sj2["w_link"] + `/c/` + asj["topid"] + `">` + sj2["c_title"] + `</a> >`
	}
	sj2["w_id"] = wid
	sj2["z_muban"] = miscellaneous.R("1")["muban"]
	return sj2
}

// 获取远程网址内容
func fetchHttpsContent(url, pcm string) string {
	client := &http.Client{
		Timeout: 10 * time.Second, // 设置 10 秒超时
	}
	req, err := http.NewRequest("GET", url, nil)
	if err != nil {
		return ""
	}
	if pcm == "m" {
		req.Header.Set("User-Agent", "Mozilla/5.0 (Linux; Android 13; Pixel 7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/116.0.0.0 Mobile Safari/537.36") // 模拟手机的 User-Agent
	} else {
		req.Header.Set("User-Agent", "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.0.0 Safari/537.36 Edg/131.0.0.0") // 模拟电脑的 User-Agent
	}
	//req.Header.Set("User-Agent", "YiBaoCMS") // 设置 User-Agent
	resp, err := client.Do(req)
	if err != nil {
		return ""
	}
	defer resp.Body.Close()
	body, err := io.ReadAll(resp.Body)
	if err != nil {
		return ""
	}
	enc, _, _ := charset.DetermineEncoding(body, resp.Header.Get("Content-Type"))           // 获取编码
	if strings.Contains(fmt.Sprintf("%v", enc), fmt.Sprintf("%v", simplifiedchinese.GBK)) { // 判断是否为 GBK 编码
		reader := transform.NewReader(bytes.NewReader(body), enc.NewDecoder())
		decodedBody, err := io.ReadAll(reader)
		if err != nil {
			return string(body)
		}
		return string(decodedBody)
	}
	return string(body)
}

// 获取css js文件
func modifylinks(htmlContent, h2, h4, stdir, mbn, scheme, pcm string, caijiurled map[string]string) (string, map[string]string) {
	var title, keywords, description, canonical string
	if mbn == "index.htm" || mbn == "index_m.htm" {
		title = "{{.w_title}}"
		keywords = "{{.w_keywords}}"
		description = "{{.w_description}}"
		canonical = "{{.w_link}}"
	} else if mbn == "c_index.htm" || mbn == "c_images.htm" || mbn == "c_list.htm" || mbn == "c_index_m.htm" || mbn == "c_images_m.htm" || mbn == "c_list_m.htm" {
		title = "{{.c_seotitle}}-{{.w_ftitle}}{{.c_yema2}}"
		keywords = "{{.c_keywords}}"
		description = "{{.c_description}}"
		canonical = "{{.w_link}}/c/{{.c_id}}"
	} else if mbn == "a_images.htm" || mbn == "a_article.htm" || mbn == "a_images_m.htm" || mbn == "a_article_m.htm" {
		title = "{{.a_seotitle}}-{{.w_ftitle}}"
		keywords = "{{.a_keywords}}"
		description = "{{.a_description}}"
		canonical = "{{.w_link}}/a/{{.a_id}}"
	} else if mbn == "search.htm" || mbn == "search_m.htm" {
		title = "{{.s_key}}-{{.w_ftitle}}{{.s_yema2}}"
		keywords = "{{.s_key}}"
		description = "{{.s_key}}"
		canonical = "{{.w_link}}/c/{{.s_key}}"
	}
	doc, _ := html.Parse(strings.NewReader(htmlContent))
	var f func(*html.Node)
	f = func(n *html.Node) {
		if n.Type == html.ElementNode && (n.Data == "a" || n.Data == "link" || n.Data == "script" || n.Data == "img" || n.Data == "meta") {
			for i, attr := range n.Attr {
				if n.Data == "a" {
					for i, a := range n.Attr {
						if a.Key == "href" {
							n.Attr[i].Val = ""
						}
					}
				} else if n.Data == "link" || n.Data == "script" {
					if attr.Key == "rel" {
						if attr.Val == "canonical" {
							for i, a := range n.Attr {
								if a.Key == "href" {
									n.Attr[i].Val = canonical
								}
							}
						} else if attr.Val == "archives" || attr.Val == "alternate" {
							for i, a := range n.Attr {
								if a.Key == "href" {
									n.Attr[i].Val = "{{.w_link}}/sitemap.xml"
								} else if a.Key == "title" {
									n.Attr[i].Val = "{{.w_title}}"
								}
							}
						} else if strings.Contains(attr.Val, "Icon") || strings.Contains(attr.Val, "icon") {
							for i, a := range n.Attr {
								if a.Key == "href" {
									n.Attr[i].Val = "{{.w_link}}/favicon.ico"
								}
							}
						} else if attr.Val == "dns-prefetch" {
							for i, a := range n.Attr {
								if a.Key == "href" {
									n.Attr[i].Val = ""
								}
							}
						} else if attr.Val == "pingback" {
							for i, a := range n.Attr {
								if a.Key == "href" {
									n.Attr[i].Val = "/"
								}
							}
						} else if attr.Val == "shortlink" {
							for i, a := range n.Attr {
								if a.Key == "href" {
									n.Attr[i].Val = "{{.w_link}}/"
								}
							}
						} else if attr.Val == "preload" {
							for i, a := range n.Attr {
								if a.Key == "href" {
									var cssurl, newcssurl string
									oldcssurl := n.Attr[i].Val
									oldpatharr := strings.Split(oldcssurl, "?") //去掉版本号
									oldpath2 := oldpatharr[0]
									oldpath3 := ""
									if len(oldpatharr) > 1 {
										oldpath3 = "?" + oldpatharr[1]
									}
									s, h, p, _ := parseURL(oldpath2)
									if s == "" {
										if h == "" {
											if p == "" {
												cssurl = ""
											} else {
												if string(p[0]) == "/" {
													cssurl = h4 + p + oldpath3
												} else {
													cssurl = h2 + p + oldpath3
												}
											}
										} else {
											cssurl = scheme + "://" + h + p + oldpath3
										}
									} else {
										cssurl = oldcssurl
									}
									if cssurl != "" && caijiurled[cssurl] == "" {
										neirong := fetchHttpsContent(cssurl, pcm)
										if neirong != "" {
											name := oldcssurl[strings.LastIndex(oldcssurl, "/")+1:]
											name = strings.Split(name, "?")[0] //去掉版本号
											if caijiurled[name] != "" {
												name = "a" + name
											}
											nh2 := strings.ReplaceAll(cssurl, name, "")
											path := stdir + "/" + name // 文件保存地址
											newcssurl = path[1:]       // 去掉开头的 .
											neirong, caijiurled = modifyAndReturnUrls(neirong, nh2, h4, stdir, scheme, pcm, caijiurled)
											savefile(path, []byte(neirong)) //	保存文件
											caijiurled[cssurl] = newcssurl  //添加到caijiurled
											caijiurled[name] = "1"          //添加到caijiurled
										}
									}
									n.Attr[i].Val = caijiurled[cssurl]
								}
							}
						}
					}
					if (attr.Key == "href" && (strings.HasSuffix(attr.Val, ".css") || strings.Contains(attr.Val, ".css?") || strings.Contains(attr.Val, "css"))) || (attr.Key == "src" && (strings.HasSuffix(attr.Val, ".js") || strings.Contains(attr.Val, ".js?"))) {
						var cssurl, newcssurl string
						oldcssurl := attr.Val
						oldpatharr := strings.Split(oldcssurl, "?") //去掉版本号
						oldpath2 := oldpatharr[0]
						oldpath3 := ""
						if len(oldpatharr) > 1 {
							oldpath3 = "?" + oldpatharr[1]
						}
						s, h, p, _ := parseURL(oldpath2)
						if s == "" {
							if h == "" {
								if p == "" {
									cssurl = ""
								} else {
									if string(p[0]) == "/" {
										cssurl = h4 + p + oldpath3
									} else {
										cssurl = h2 + p + oldpath3
									}
								}
							} else {
								cssurl = scheme + "://" + h + p + oldpath3
							}
						} else {
							cssurl = oldcssurl
						}
						if cssurl != "" && caijiurled[cssurl] == "" {
							neirong := fetchHttpsContent(cssurl, pcm)
							if neirong != "" {
								name := oldcssurl[strings.LastIndex(oldcssurl, "/")+1:]
								name = strings.Split(name, "?")[0] //去掉版本号
								if caijiurled[name] != "" {
									name = "a" + name
								}
								nh2 := strings.ReplaceAll(cssurl, name, "")
								nh2 = strings.Split(nh2, "?")[0] //去掉版本号
								path := stdir + "/" + name       // 文件保存地址
								newcssurl = path[1:]             // 去掉开头的 .
								neirong, caijiurled = modifyAndReturnUrls(neirong, nh2, h4, stdir, scheme, pcm, caijiurled)
								savefile(path, []byte(neirong)) //	保存文件
								caijiurled[cssurl] = newcssurl  //添加到caijiurled
								caijiurled[name] = "1"          //添加到caijiurled
							}
						}
						n.Attr[i].Val = caijiurled[cssurl]
					}
				} else if n.Data == "meta" {
					if attr.Key == "name" {
						if attr.Val == "keywords" {
							for i, a := range n.Attr {
								if a.Key == "content" {
									n.Attr[i].Val = keywords
								}
							}
						} else if attr.Val == "description" {
							for i, a := range n.Attr {
								if a.Key == "content" {
									n.Attr[i].Val = description
								}
							}
						} else if attr.Val == "author" || attr.Val == "generator" {
							for i, a := range n.Attr {
								if a.Key == "content" {
									n.Attr[i].Val = "YiBaoCMS"
								}
							}
						} else if attr.Val == "theme - color" {
							for i, a := range n.Attr {
								if a.Key == "content" {
									n.Attr[i].Val = "rgb(240, 235, 204)"
								}
							}
						} else if attr.Val == "page-topic" {
							for i, a := range n.Attr {
								if a.Key == "content" {
									n.Attr[i].Val = "{{.w_title}}"
								}
							}
						} else if attr.Val == "copyright" {
							for i, a := range n.Attr {
								if a.Key == "content" {
									n.Attr[i].Val = "Copyright {{.w_title}}"
								}
							}
						} else if attr.Val == "apple-mobile-web-app-title" || attr.Val == "msapplication-TileTitle" || attr.Val == "application-name" || attr.Val == "msapplication-tooltip" {
							for i, a := range n.Attr {
								if a.Key == "content" {
									n.Attr[i].Val = "{{.w_ftitle}}"
								}
							}
						} else if attr.Val == "msapplication-TileImage" || strings.Contains(attr.Val, "msapplication-square") || strings.Contains(attr.Val, "msapplication-wide") {
							for i, a := range n.Attr {
								if a.Key == "content" {
									n.Attr[i].Val = "{{.w_link}}/favicon.ico"
								}
							}
						} else if attr.Val == "msapplication-starturl" {
							for i, a := range n.Attr {
								if a.Key == "content" {
									n.Attr[i].Val = "{{.w_link}}"
								}
							}
						} else if attr.Val == "applicable-device" {
							for i, a := range n.Attr {
								if a.Key == "content" {
									n.Attr[i].Val = "pc,mobile"
								}
							}
						} else if attr.Val == "mobile-agent" {
							for i, a := range n.Attr {
								if a.Key == "content" {
									n.Attr[i].Val = "format=html5; url=" + canonical
								}
							}
						}
					} else if attr.Key == "http-equiv" {
						if attr.Val == "Content-Type" {
							for i, a := range n.Attr {
								if a.Key == "content" {
									n.Attr[i].Val = "text/html;charset=utf-8"
								}
							}
						} else if attr.Val == "mobile-agent" {
							for i, a := range n.Attr {
								if a.Key == "content" {
									n.Attr[i].Val = "format=html5; url=" + canonical
								}
							}
						}

					}
				} else if n.Data == "img" && attr.Key == "src" {
					oldpath := attr.Val
					var imgurl, newpath string
					s, h, p, _ := parseURL(oldpath)
					if s == "" {
						if h == "" {
							if p == "" {
								imgurl = ""
							} else {
								if string(p[0]) == "/" {
									imgurl = h4 + p
								} else {
									imgurl = h2 + p
								}
							}
						} else {
							imgurl = h4 + "/" + p
						}
					} else {
						imgurl = oldpath
					}
					if imgurl != "" && caijiurled[imgurl] == "" {
						neirong := fetchHttpsContent(imgurl, pcm)
						if neirong != "" {
							name := imgurl[strings.LastIndex(imgurl, "/")+1:]
							name = strings.Split(name, "?")[0] //去掉版本号
							if caijiurled[name] != "" {
								name = "a" + name
							}
							path := stdir + "/static/" + name // 文件保存地址
							newpath = path[1:]                // 去掉开头的 .
							savefile(path, []byte(neirong))   //	保存文件
							caijiurled[imgurl] = newpath      //添加到caijiurled
							caijiurled[name] = "1"            //添加到caijiurled
						}
					}
					n.Attr[i].Val = caijiurled[imgurl]
				}
			}
		} else if n.Type == html.ElementNode && n.Data == "title" {
			// 找到 <title> 标签的子节点（即文本节点）
			for c := n.FirstChild; c != nil; c = c.NextSibling {
				if c.Type == html.TextNode {
					c.Data = title
				}
			}
		}
		for c := n.FirstChild; c != nil; c = c.NextSibling {
			f(c)
		}
	}
	f(doc)
	var newHTML strings.Builder
	html.Render(&newHTML, doc)
	return newHTML.String(), caijiurled
}

// 获取内容中的url()
func modifyAndReturnUrls(neirong, h2, h4, stdir, scheme, pcm string, caijiurled map[string]string) (string, map[string]string) {
	//re := regexp.MustCompile(`url\(['"]?(.*?)['"]?\)`)
	re := regexp.MustCompile(`url\((['"]*)(.*?)(['"]*)\)`)
	matches := re.FindAllStringSubmatch(neirong, -1)
	for _, match := range matches {
		if len(match) > 1 {
			oldpath := match[2]
			var url, newpath string
			oldpatharr := strings.Split(oldpath, "?") //去掉版本号
			oldpath2 := oldpatharr[0]
			oldpath3 := ""
			if len(oldpatharr) > 1 {
				oldpath3 = "?" + oldpatharr[1]
			}
			s, h, p, _ := parseURL(oldpath2)
			if (s == "" || h == "" || p == "") && (strings.Contains(oldpath, "data:") || strings.Contains(oldpath, "+") || strings.Contains(oldpath, "#")) {
				continue
			}
			if s == "" {
				if h == "" {
					if p == "" {
						url = ""
					} else {
						if string(p[0]) == "/" {
							url = h4 + p + oldpath3
						} else {
							//url = h4 + "/" + p + oldpath3
							url = h2 + p + oldpath3
						}
					}
				} else {
					url = scheme + "://" + h + p + oldpath3
				}
			} else {
				url = oldpath
			}
			if url != "" && caijiurled[url] == "" {
				b := fetchHttpsContent(url, pcm)
				if b != "" {
					name := oldpath[strings.LastIndex(oldpath, "/")+1:]
					name = strings.Split(name, "?")[0] //去掉版本号
					if caijiurled[name] != "" {
						name = "a" + name
					}
					newurl := stdir + "/static/" + name                                            // 文件保存地址
					newpath = newurl[1:]                                                           // 去掉开头的 .
					b, caijiurled = modifyAndReturnUrls(b, h2, h4, stdir, scheme, pcm, caijiurled) //递归
					savefile(newurl, []byte(b))                                                    //保存文件
					caijiurled[url] = newpath                                                      //添加到caijiurled
					caijiurled[name] = "1"                                                         //添加到caijiurled
				} else {
					log.Println(url)
				}
			}
			//ret := regexp.MustCompile(`\b` + oldpath + `\b`)
			//neirong = ret.ReplaceAllString(neirong, caijiurled[url])
			//neirong = strings.ReplaceAll(neirong, oldpath, caijiurled[url])
			neirong = strings.ReplaceAll(neirong, match[0], `url(`+caijiurled[url]+`)`)
		}
	}
	return neirong, caijiurled
}

// 开始采集
func caijistart(caijiurl map[string]map[string]string, dir string, conn *Conn) {
	time := time.Now().Format("2006-01-02_15-04-05")
	mbdir := "./templates/" + dir + "/" + time //模板路径
	stdir := "./static/" + dir + "/" + time    //静态文件路径
	msg := map[string]string{"infos": "开始采集..."}
	msgchannel[conn] <- msg
	var caijiurled = map[string]string{} //已经采集的网址
	for pcm, caijiurl2 := range caijiurl {
		for mbn, h := range caijiurl2 {
			if h != "" {
				//h网址 h2网址带目录部分 h3域名 h4协议带域名
				msg := map[string]string{"infos": "开始采集:" + h}
				msgchannel[conn] <- msg
				scheme, host, path, _ := parseURL(h)
				h2 := scheme + "://" + host + path[:strings.LastIndex(path, "/")+1] //h2网址带目录部分
				h2 = strings.Split(h2, "?")[0]                                      //去掉版本号
				//h3 := host                                                          //域名
				h4 := scheme + "://" + host              //h4协议带域名
				htmlContent := fetchHttpsContent(h, pcm) // 获取页面内容
				if htmlContent == "" {
					msg := map[string]string{"infos": h + " 采集失败！"}
					msgchannel[conn] <- msg
				} else {
					msg = map[string]string{"infos": h + " 模板采集成功！<br>开始采集css js img文件...."}
					msgchannel[conn] <- msg
					htmlContent, caijiurled = modifyAndReturnUrls(htmlContent, h2, h4, stdir, scheme, pcm, caijiurled) //修改url()
					htmlContent, caijiurled = modifylinks(htmlContent, h2, h4, stdir, mbn, scheme, pcm, caijiurled)    // 修改 获取css js
					msg = map[string]string{"infos": h + " 模板采集完成！"}
					msgchannel[conn] <- msg
				}
				newdata := `{{define "` + dir + `/` + time + `/` + mbn + `"}}<!--模板标识 请勿删除这行-->\n`
				newdata += htmlContent
				newdata += `\n{{end}}<!--模板标识结束 请勿删除这行-->`
				newdata = strings.Replace(newdata, "\\n", "\n", -1)
				savefile(mbdir+"/"+mbn, []byte(newdata)) //保存模板文件
			}
		}
		var hn, fn string
		if pcm == "pc" {
			hn = "head.htm"
			fn = "footer.htm"
		} else {
			hn = "head_m.htm"
			fn = "footer_m.htm"
		}
		//创建空的head.htm和footer.htm
		newdata := `{{define "` + dir + `/` + time + `/` + hn + `"}}<!--模板标识 请勿删除这行 -->\n\n`
		newdata += `\n{{end}}<!--模板标识结束 请勿删除这行-->`
		newdata = strings.Replace(newdata, "\\n", "\n", -1)
		savefile(mbdir+"/"+hn, []byte(newdata)) //保存模板文件
		newdata = `{{define "` + dir + `/` + time + `/` + fn + `"}}<!--模板标识 请勿删除这行-->\n\n`
		newdata += `\n{{end}}<!--模板标识结束 请勿删除这行-->`
		newdata = strings.Replace(newdata, "\\n", "\n", -1)
		savefile(mbdir+"/"+fn, []byte(newdata)) //保存模板文件
	}
	updateTemplate()
}

// 开始采集 单页模板
func caijistart2(mubanname, pcm, h, dir, mubandir string, conn *Conn) {
	houzui := ""
	if pcm == "m" {
		houzui = "_m"
	}
	mbdir := "./templates/" + dir + "/" + mubandir                //模板路径
	stdir := "./static/" + dir + "/" + mubandir + "/" + mubanname //静态文件路径
	var caijiurled = map[string]string{}                          //已经采集的网址
	//h网址 h2网址带目录部分 h3域名 h4协议带域名
	msg := map[string]string{"infos": "开始采集:" + h}
	msgchannel[conn] <- msg
	scheme, host, path, _ := parseURL(h)
	h2 := scheme + "://" + host + path[:strings.LastIndex(path, "/")+1] //h2网址带目录部分
	h2 = strings.Split(h2, "?")[0]                                      //去掉版本号
	//h3 := host                                                          //域名
	h4 := scheme + "://" + host              //h4协议带域名
	htmlContent := fetchHttpsContent(h, pcm) // 获取页面内容
	if htmlContent == "" {
		msg := map[string]string{"infos": h + " 采集失败！"}
		msgchannel[conn] <- msg
	} else {
		msg = map[string]string{"infos": h + " 模板采集成功！<br>开始采集css js img文件...."}
		msgchannel[conn] <- msg
		htmlContent, caijiurled = modifyAndReturnUrls(htmlContent, h2, h4, stdir, scheme, pcm, caijiurled) //修改url()
		htmlContent, _ = modifylinks(htmlContent, h2, h4, stdir, mubanname, scheme, pcm, caijiurled)       // 修改 获取css js
		msg = map[string]string{"infos": h + " 模板采集完成！"}
		msgchannel[conn] <- msg
		newdata := `{{define "` + dir + `/` + mubandir + `/` + mubanname + houzui + `.htm"}}<!--模板标识 请勿删除这行-->\n`
		newdata += htmlContent
		newdata += `\n{{end}}<!--模板标识结束 请勿删除这行-->`
		newdata = strings.Replace(newdata, "\\n", "\n", -1)
		savefile(mbdir+"/"+mubanname+houzui+".htm", []byte(newdata)) //保存模板文件
		updateTemplate()
	}
}

// 外链推送
func pushlinks(url string) {
	//获取推送网址列表
	lb := tuisong.R("1")
	if len(lb) > 0 {
		for _, l := range lb {
			if l != "" {
				l = strings.ReplaceAll(l, "{url}", url)
				go pushlink(l)
			}
		}
	}
}
func pushlink(url string) {
	client := &http.Client{
		Timeout: 10 * time.Second, // 设置 10 秒超时
	}
	req, err := http.NewRequest("GET", url, nil)
	if err != nil {
		return
	}
	req.Header.Set("User-Agent", "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.0.0 Safari/537.36 Edg/131.0.0.0") // 模拟电脑的 User-Agent
	//req.Header.Set("User-Agent", "Mozilla/5.0 (Linux; Android 13; Pixel 7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/116.0.0.0 Mobile Safari/537.36") // 模拟手机的 User-Agent
	resp, err := client.Do(req)
	if err != nil {
		return
	}
	defer resp.Body.Close()
	_, err = io.ReadAll(resp.Body)
	if err != nil {
		return
	}
}
