package main

import (
	"crypto/md5"
	"encoding/base64"
	"encoding/json"
	"fmt"

	//"html"
	"io"
	"log"
	"math"
	"math/rand"
	"os"
	"path"
	"path/filepath"
	"regexp"
	"strconv"
	"strings"
	"time"

	"github.com/google/uuid"
	"github.com/skip2/go-qrcode"
	"golang.org/x/net/html"
)

func readMessages(conn *Conn) {
	defer func() {
		if r := recover(); r != nil {
			log.Println("异常:", r)
			hfmsg := make(map[string]string) //初始化回复数据 map
			hfmsg["main"] = fmt.Sprintf(`数据发生异常:%s！<br><a onclick=shuaxin()>刷新</a>`, r)
			msgchannel[conn] <- hfmsg
			readMessages(conn)
			//saveData() //保存数据
		} else {
			close(msgchannel[conn]) //关闭消息通道
		}
	}()
	var dianjicmd = make(map[int]map[string]string)       //初始化点击对照
	suijishuyuan := rand.NewSource(time.Now().UnixNano()) // 创建一个新的基于时间的随机源
	suijishu := rand.New(suijishuyuan)                    // 使用该随机源创建一个新的随机数生成器
	var uid string = conn.Uid
	var homeurl string = ""
	var k string = ""
	// 循环读取消息
	for {
		_, msg, err := conn.ReadMessage() // 读取消息
		if err != nil {
			if !strings.Contains(err.Error(), "websocket: close") {
				log.Println("读取消息时出错,uid:", uid, "错误:", err)
			}
			return
		}
		//log.Println("收到消息,uid:", uid, "消息:", string(msg))
		var data Data // 给传输来的数据定义一个结构体
		//if err := json.Unmarshal([]byte(msg), &data); err != nil { // 反序列化成结构体
		if err := json.Unmarshal(jieya(msg), &data); err != nil { // 反序列化成结构体
			log.Println("消息序列化时出错,uid:", uid, "错误:", err)
			data.Sid = ""
			data.Cid = 1
		}
		//大数据分块传输
		if data.K != "" {
			k += data.K
			if data.K2 != "" {
				json.Unmarshal([]byte(k), &data)
				k = ""
			} else {
				continue
			}
		}
		if data.Ping == "ping" {
			continue
		}
		hfmsg := make(map[string]string) //初始化回复数据 map
		var neirong string = ""          //初始化主要返回内容
		//后台交互逻辑
		if uid == "" {
			if data.N != "" && data.P != "" {
				if data.N == safeuser && data.P == safepass {
					var lssid string                     //初始化sid
					uuid := uuid.New()                   // 生成一个新的 UUID
					lssid = uuid.String()                //将uuid转为字符串
					hasher := md5.New()                  // 创建一个新的 MD5 哈希对象
					io.WriteString(hasher, lssid)        // 写入数据到哈希对象
					hashBytes := hasher.Sum(nil)         // 计算哈希并获取结果
					lssid = fmt.Sprintf("%x", hashBytes) // 将字节数组转换为十六进制字符串
					uid = lssid
					conn.Uid = uid
				} else {
					hfmsg["main"] = `<div class="container mt-3"><center><h6>账号或者密码错误！</h6><h2>请输入账户和密码</h2></center><div class="mb-3 mt-3"><label for="email" class="form-label">账户:</label><input type="email" class="form-control" id="n" name="n"></div><div class="mb-3"><label for="pwd" class="form-label">密码:</label><input type="password" class="form-control" id="p"  name="p"></div><button onclick=dl() type="submit" class="btn btn-primary">登录</button></div>`
					msgchannel[conn] <- hfmsg
					continue
				}
			} else {
				hfmsg["main"] = `<div class="container mt-3"><center><h2>请输入账户和密码</h2></center><div class="mb-3 mt-3"><label for="email" class="form-label">账户:</label><input type="email" class="form-control" id="n" name="n"></div><div class="mb-3"><label for="pwd" class="form-label">密码:</label><input type="password" class="form-control" id="p"  name="p"></div><button onclick=dl() type="submit" class="btn btn-primary">登录</button></div>`
				msgchannel[conn] <- hfmsg
				continue
			}
		}
		if homeurl == "" {
			sj := webfield.R("1")
			for _, v := range sj {
				if v.K == "link" {
					homeurl = v.V
					break
				}
			}
		}
		//检查标题是否存在
		if data.Key != "" {
			//历遍所有文章数据
			allwz := 0
			a := ""
			//历遍文章
			article.data.Range(func(key, value interface{}) bool {
				asj := value.(map[string]string)
				if asj["title"] == data.Key {
					allwz++
					csj := channel.R(asj["topid"])
					if csj["lx"] == "3" {
						a += "-" + csj["title"] + ":<a href='/q/" + asj["title"] + "' target='_blank'>" + asj["title"] + "</a><br>"
					} else {
						a += "-" + csj["title"] + ":<a href='/a/" + key.(string) + "' target='_blank'>" + asj["title"] + "</a><br>"
					}
				}
				return true
			})
			if allwz > 0 {
				hfmsg["title"] = fmt.Sprintf(`<span style="color:red;">有%d篇文章标题为:%s</span><br>%s`, allwz, data.Key, a)
				msgchannel[conn] <- hfmsg
			} else {
				hfmsg["title"] = ""
				msgchannel[conn] <- hfmsg
			}
			continue
		}
		var shuju = data.Shuju //获取数据
		//上传图片 音视频
		if data.Up != "" {
			if shuju["type"] != "" && shuju["msg"] != "" && shuju["name"] != "" {
				filedir := ""
				if shuju["type"] == "img" {
					filedir = "/static/up/images/"
				} else if shuju["type"] == "med" {
					filedir = "/static/up/media/"
				} else if shuju["type"] == "file" {
					filedir = "/static/up/files/"
				} else {
					hfmsg["error"] = "1"
					hfmsg[data.Up] = ""
					msgchannel[conn] <- hfmsg
					continue
				}
				binaryData, err := base64.StdEncoding.DecodeString(shuju["msg"])
				if err != nil {
					binaryData = []byte{}
				}
				filename := filedir + shuju["name"] // 定义要写入的文件名
				if savefile(filename, binaryData) {
					hfmsg["error"] = "0"
					hfmsg[data.Up] = filename
				}
			} else {
				hfmsg["error"] = "1"
				hfmsg[data.Up] = ""
			}
			msgchannel[conn] <- hfmsg
			continue
		}
		//上传多张图片
		if data.Ups != "" {
			fileList := []string{}
			if len(data.Imgs) > 0 {
				lsname := time.Now().Format("20060102150405") //获取时间YmdHis作为文件名称
				i := 0
				for _, v := range data.Imgs {
					var imgtype string
					if v["tp"] == "image/png" {
						imgtype = ".png"
					} else if v["tp"] == "image/jpeg" {
						imgtype = ".jpg"
					} else if v["tp"] == "image/gif" {
						imgtype = ".gif"
					} else if v["tp"] == "image/bmp" {
						imgtype = ".bmp"
					} else if v["tp"] == "image/tiff" {
						imgtype = ".tiff"
					}
					if imgtype != "" {
						binaryData, err := base64.StdEncoding.DecodeString(v["ab"])
						if err != nil {
							binaryData = []byte{}
						}
						i++
						filename := "/static/up/images/" + lsname + "_" + strconv.Itoa(i) + imgtype // 定义要写入的文件名
						if savefile(filename, binaryData) {
							fileList = append(fileList, filename)
						}
					}
				}
			}
			lsnr := strings.Join(fileList, ">") //转字符串
			if lsnr != "" {
				hfmsg["lookimgs"] = "1"
				hfmsg["imgurls"] = lsnr
			} else {
				hfmsg["lookimgs"] = "0"
			}
			msgchannel[conn] <- hfmsg
			continue
		}
		//文件空间
		if data.Look != "" {
			Lx := ""
			dir_str := ""
			onclick := ""
			switch data.Look {
			case "img":
				dir_str = "./static/up/images/"
				Lx = "imgurls"
				onclick = "lookimg"
			case "med":
				dir_str = "./static/up/media/"
				Lx = "medurls"
				onclick = "lookmed"
			case "file":
				dir_str = "./static/up/files/"
				Lx = "fileurls"
				onclick = "lookfile"
			}
			hfmsg["look"] = "0"
			if Lx != "" {
				yema := 1
				if data.Yema > 1 {
					yema = data.Yema
				}
				fs, _ := listFiles(dir_str)
				//imgType := []string{".gif", ".png", ".jpg", ".jpeg", ".bmp", ".tiff"}
				fileList := []string{}
				if len(fs) > 0 {
					for _, v := range fs {
						//if existsInSlice(imgType, filepath.Ext(v)) {
						fileList = append(fileList, "/"+strings.ReplaceAll(v, `\`, `/`))
						//}
					}
				}
				zsl := len(fileList)
				if zsl > 0 {
					lsyema := ""
					if yema > 1 {
						ls := yema - 1
						lsyema += "<a onclick=" + onclick + "(" + strconv.Itoa(ls) + ")>上页</a> "
					}
					if float64(zsl)/20.0 > float64(yema) {
						ls := yema + 1
						lsyema += "<a onclick=" + onclick + "(" + strconv.Itoa(ls) + ")>下页</a> "
					}
					ksid := (yema - 1) * 20
					jsid := ksid + 20
					if ksid > zsl {
						ksid = 0
					}
					if jsid > zsl {
						jsid = zsl
					}
					fs = fileList[ksid:jsid]
					imgsl := len(fs)
					lsnr := strings.Join(fs, ">") //转字符串
					if lsnr != "" {
						hfmsg["look"] = strconv.Itoa(imgsl)
						hfmsg[Lx] = lsnr
					} else {
						hfmsg["look"] = "0"
					}
				}
			}
			msgchannel[conn] <- hfmsg
			continue
		}

		var cid = data.Cid //获取点击数

		var cmds = make(map[string]string) //初始化当前点击对照
		//历遍点击对照表，获取当前点击对照
		for k, v := range dianjicmd[cid] {
			cmds[k] = v
		}
		var cmd = cmds["cmd"]
		if cmd == "" {
			cmd = "网站设置"
		}
		//保持cid在一个小范围
		if cid < 1000 {
			cid += suijishu.Intn(101) + 200 // 生成 200 到 300 之间的随机整数 101 是 300 - 200 + 1 的结果
		} else if cid > 1000 {
			cid -= suijishu.Intn(401) + 500 // 生成 500 到 900 之间的随机整数 401 是 900 - 500 + 1 的结果
		}
		dianjicmd = make(map[int]map[string]string) //初始化点击对照
		//历遍cmdlb 导航
		neirong += `<ul class="nav">`
		for _, v := range cmdlb {
			cid++
			if cmd == v {
				neirong += fmt.Sprintf(`<li class="nav-item"><b><a class="nav-link" onclick=cmd(%d)>%s</a></b></li>`, cid, v)
			} else {
				neirong += fmt.Sprintf(`<li class="nav-item"><a class="nav-link" onclick=cmd(%d)>%s</a></li>`, cid, v)
			}
			dianjicmd[cid] = map[string]string{"cmd": v}
		}
		neirong += "</ul><hr>"
		if cmd != "" {
			var cmd2 = cmds["cmd2"]
			var cmd3 = cmds["cmd3"]
			var cmd4 = cmds["cmd4"]
			var cmd5 = cmds["cmd5"]
			var lmid = cmds["lmid"]
			var yema = cmds["yema"]
			switch cmd {
			case "网站设置":
				//获取网站字段数据
				sj := webfield.R("1")
				if cmd2 != "" {
					shuju["addziduan"] = removeInvalidChars(shuju["addziduan"])      //删除不是中文、字母和数字的字符
					shuju["addziduan2"] = removeNonAlphanumeric(shuju["addziduan2"]) //删除非字母和数字的字符
					shuju["cdir"] = removeNonAlphanumeric(shuju["cdir"])             //删除非字母和数字的字符
					shuju["adir"] = removeNonAlphanumeric(shuju["adir"])             //删除非字母和数字的字符
					//更新
					if shuju["addziduan"] != "" && shuju["addziduan2"] != "" && shuju["addziduan3"] != "" {
						if shuju["addziduan2"] != "addziduan" && shuju["addziduan2"] != "addziduan2" && shuju["addziduan2"] != "addziduan3" && regexp.MustCompile(`^[a-zA-Z]`).MatchString(shuju["addziduan2"]) {
							ok := true
							for _, v := range sj {
								if v.K == shuju["addziduan2"] {
									ok = false
								}
							}
							if ok {
								if shuju["addziduan3"] != "2" && shuju["addziduan3"] != "3" {
									shuju["addziduan3"] = "1"
								}
								sj = append(sj, Ziduan{shuju["addziduan"], shuju["addziduan2"], "", shuju["addziduan3"]})
								neirong += "新增字段成功<br>"
							} else {
								neirong += "新增字段名称重复<br>"
							}
						} else {
							neirong += "新增字段名称不可以是addziduan、addziduan2、addziduan3,且需要时字母开头<br>"
						}
					}
					//先获取类型3的图片
					imgs := data.Imgs
					imglx := map[string]string{}
					if len(imgs) != 0 {
						//历遍imgs
						for imgkey, v2 := range imgs {
							if v2["tp"] != "" && v2["ab"] != "" {
								binaryData, err := base64.StdEncoding.DecodeString(v2["ab"])
								if err != nil {
									binaryData = []byte{}
								}
								var imgtype string
								if v2["tp"] != "" {
									if v2["tp"] == "image/png" {
										imgtype = ".png"
									} else if v2["tp"] == "image/jpeg" {
										imgtype = ".jpg"
									} else if v2["tp"] == "image/gif" {
										imgtype = ".gif"
									} else if v2["tp"] == "image/bmp" {
										imgtype = ".bmp"
									} else if v2["tp"] == "image/webp" {
										imgtype = ".webp"
									} else if v2["tp"] == "image/tiff" {
										imgtype = ".tiff"
									} else if v2["tp"] == "image/x-icon" {
										imgtype = ".ico"
									} else if v2["tp"] == "image/svg+xml" {
										imgtype = ".svg"
									} else if v2["tp"] == "image/x-ms-bmp" {
										imgtype = ".bmp"
									} else if v2["tp"] == "image/vnd.microsoft.icon" {
										imgtype = ".ico"
									} else if v2["tp"] == "image/x-rgb" {
										imgtype = ".rgb"
									}
								}
								if imgtype != "" {
									filename := "/static/up/web/" + imgkey + imgtype // 定义要写入的文件名
									if savefile(filename, binaryData) {
										imglx[imgkey] = filename
									}
								}
							}
						}
					}
					//历遍修改
					bianhua := false
					for lsid, v := range sj {
						if v.K != "dir" || v.T != "3" {
							if v.T == "3" {
								if imglx[v.K] != "" {
									sj[lsid].V = imglx[v.K]
								}
							} else {
								if v.V != shuju[v.K] {
									sj[lsid].V = shuju[v.K]
									if v.K == "link" {
										bianhua = true
										homeurl = shuju[v.K]
									}
								}
							}
						}
					}
					if bianhua {
						go upmap()           //更新地图
						go upqrcode(homeurl) //更新所有二维码
					}
					neirong += "修改成功<br>"
					webfield.W("1", sj)
				}
				if cmd3 != "" && cmds["ziduan"] != "" {
					var ziduan = cmds["ziduan"]
					if ziduan == "link" || ziduan == "wap" || ziduan == "dir" || ziduan == "cdir" || ziduan == "adir" || ziduan == "title" || ziduan == "ftitle" || ziduan == "keywords" || ziduan == "homename" || ziduan == "description" || ziduan == "baidutoken" || ziduan == "beian" || ziduan == "copyright" {
						neirong += "link、wap、dir、cdir、adir、title、ftitle、keywords、homename、description、copyright、beian、baidutoken字段不可以删除！<br>"
					} else {
						if cmd4 != "" {
							var weizhi int
							//历遍获取字段位置
							for lsid, v := range sj {
								if v.K == ziduan {
									weizhi = lsid
									break
								}

							}
							sj = append(sj[:weizhi], sj[weizhi+1:]...)
							webfield.W("1", sj)
							neirong += "成功删除 " + ziduan + " 字段!<br>"
						} else {
							neirong += "确定删除 " + ziduan + " 字段？<br>"
							cid++
							neirong += fmt.Sprintf("<br><a style='color:red;' onclick=cmd(%d)>[确定删除]</a><br><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": cmd3, "cmd4": "删除", "ziduan": ziduan}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd(%d)>[取消删除]</a><br><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd}
							break
						}
					}
				}
				//历遍显示
				imglx := ""
				for _, v := range sj {
					cid++
					neirong += fmt.Sprintf("<p>"+v.N+" {{.w_"+v.K+"}}：<a onclick=cmd(%d)>[删除]</a><br>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": "删除", "ziduan": v.K}
					if v.T == "1" {
						neirong += "<input type=text id='" + v.K + "' name='" + v.K + "' size='60' value='" + v.V + "'></p>"
					} else if v.T == "2" {
						neirong += "<textarea placeholder='请输入" + v.N + "'  rows='3' cols='60' id='" + v.K + "' name='" + v.K + "'>" + v.V + "</textarea></p>"
					} else if v.T == "3" {
						imglx += v.K + "*"
						if v.V != "" {
							neirong += "<a href='" + v.V + "' target='_blank'><img src='" + v.V + "' width='100'></a><br>"
						}
						neirong += "<input type='file' id='" + v.K + "' name='" + v.K + "' accept='image/*' required></p>"
					}
				}
				if imglx != "" {
					imglx = imglx[:len(imglx)-1]
					hfmsg["imglx"] = imglx
				}
				neirong += "<p>---<br>添加字段："
				neirong += "<br>字段说明(如:网站地址): <input type=text name='addziduan' size='30' value=''>"
				neirong += "<br>字段名称(如:links):<input type=text name='addziduan2' size='35' value=''>"
				neirong += "<br>字段类型(如:1代表单行文本、2代表多行文本、3代表图片): <input type=text name='addziduan3' size='7' value=''>"
				neirong += "<br>---</p>"
				cid++
				neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd3(%d) required>", cid)
				dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "更新"}
			case "栏目管理":
				topcid := topchannel.R("1")
				hfmsg["up"] = ""
				if cmd2 != "" {
					if cmd2 == "添加栏目" {
						if cmds["lmlx"] != "" {
							if cmd3 != "" {
								if shuju["title"] != "" {
									zx := miscellaneous.R("1")
									vid := zx["vid"]
									vid2, ok := strconv.Atoi(vid)
									if ok != nil {
										vid2 = 0
									}
									vid2++
									vid3 := strconv.Itoa(vid2)
									zx["vid"] = vid3
									miscellaneous.W("1", zx)
									var csj = make(map[string]string)   //初始化栏目信息
									czd := channelfield.R(cmds["lmlx"]) //获取栏目字段
									for _, v := range czd {
										if v.K == "neirong" {
											csj[v.K] = html.EscapeString(shuju[v.K]) //转义
										} else if v.K == "img" {
											if shuju[v.K] != "" {
												binaryData, err := base64.StdEncoding.DecodeString(shuju[v.K])
												if err != nil {
													binaryData = []byte{}
												}
												var imgtype string
												if data.Imgtp != "" {
													if data.Imgtp == "image/png" {
														imgtype = ".png"
													} else if data.Imgtp == "image/jpeg" {
														imgtype = ".jpg"
													} else if data.Imgtp == "image/gif" {
														imgtype = ".gif"
													} else if data.Imgtp == "image/bmp" {
														imgtype = ".bmp"
													} else if data.Imgtp == "image/webp" {
														imgtype = ".webp"
													} else if data.Imgtp == "image/tiff" {
														imgtype = ".tiff"
													}
												}
												if imgtype != "" {
													filename := "/static/up/channel/" + vid3 + imgtype // 定义要写入的文件名
													if savefile(filename, binaryData) {
														csj[v.K] = filename
													} else {
														csj[v.K] = "/static/nopic.png"
													}
												} else {
													csj[v.K] = "/static/nopic.png"
												}
											} else {
												csj[v.K] = "/static/nopic.png"
											}
										} else {
											csj[v.K] = html.EscapeString(shuju[v.K]) //转义
										}
									}
									csj["mx"] = cmds["lmlx"]
									if csj["topid"] == "0" {
										tc := topchannel.R("1")
										tc = append(tc, vid3) //保存到顶级栏目列表
										topchannel.W("1", tc) //保存
									} else {
										//在上级栏目中添加下级栏目id
										csj2 := channel.R(csj["topid"]) //获取上级栏目
										if csj2["subid"] == "" {
											csj2["subid"] = vid3
										} else {
											csj2["subid"] = csj2["subid"] + "," + vid3
										}
										channel.W(csj["topid"], csj2) //更新栏目
									}
									csj["subid"] = ""
									csj["artid"] = ""
									channel.W(vid3, csj) //添加栏目
									go upmap()           //更新地图
									neirong = "栏目添加成功!<br>"
									generateqrcode(homeurl, "c", vid3) // 生成二维码
								} else {
									neirong += "栏目名称不能为空！"
								}
							} else {
								//获取并历遍栏目字段
								lmzd := channelfield.R(cmds["lmlx"])
								for _, v := range lmzd {
									if v.K == "subid" || v.K == "artid" || v.K == "mx" {
										continue
									}
									neirong += "<p>" + v.N + "{{.c_" + v.K + "}}：<br>"
									if v.K == "lx" {
										neirong += "1代表列表/2代表单页/3查询数据<br>"
									}
									if v.T == "1" {
										neirong += "<input type=text name='" + v.K + "' size='60' value='" + v.V + "'></p>"
									} else if v.T == "2" {
										neirong += "<textarea placeholder='请输入" + v.N + "'  rows='3' cols='60' name='" + v.K + "'></textarea></p>"
									} else if v.T == "4" {
										hfmsg["c"] = ""
									} else if v.T == "9" {
										if lmid == "" {
											lmid = "0"
										}
										neirong += "<input onfocus=this.blur() name='" + v.K + "' size='60' value='" + lmid + "'></p>"
									} else if v.T == "10" {
										neirong += "<input type='file' id='" + v.K + "' name='" + v.K + "' >"
										hfmsg["i"] = "1"
									}
								}
								cid++
								hfmsg["up"] += fmt.Sprintf("<p><input type='button' value='点击提交' onclick=cmd2(%d) required></p>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd, "lmlx": cmds["lmlx"]}
							}
						} else {
							lmid := cmds["lmid"]
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[1]文章模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "lmlx": "1"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[2]单页模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "lmlx": "2"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[3]图片模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "lmlx": "3"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[4]附件模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "lmlx": "4"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[5]视频模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "lmlx": "5"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[6]音频模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "lmlx": "6"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[7]链接模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "lmlx": "7"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[8]自定义模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "lmlx": "8"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[9]自定义模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "lmlx": "9"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[10]自定义模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "lmlx": "10"}
							cid++
						}
					} else if cmd2 == "删除栏目" {
						if lmid != "" {
							//获取栏目信息
							csj := channel.R(lmid)
							if csj["title"] != "" {
								if cmd3 != "" {
									Deletechannel([]string{lmid}) //删除栏目
									go upmap()                    //更新地图
									neirong += "删除成功!<br>"
								} else {
									neirong += "<p>确定删除栏目：" + csj["title"] + "以及栏目下所有文章?</p>"
									cid++
									hfmsg["up"] += fmt.Sprintf("<p><input type='button' value='确认删除' onclick=cmd(%d) required> ", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "删除栏目", "lmid": lmid}
									cid++
									hfmsg["up"] += fmt.Sprintf("<p><input type='button' value='取消删除' onclick=cmd(%d) required> ", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd}
								}
							} else {
								neirong += "栏目不存在！<br>"
							}
						} else {
							neirong += "栏目不存在！<br>"
						}
					} else if cmd2 == "修改栏目" {
						if lmid != "" {
							//获取栏目字段
							csj := channel.R(lmid)
							czd := channelfield.R(csj["mx"])
							if cmd3 != "" {
								if shuju["title"] != "" {
									for _, v := range czd {
										if v.K == "topid" || v.K == "subid" || v.K == "artid" || v.K == "mx" {
											continue
										}
										if v.K == "neirong" {
											csj[v.K] = html.EscapeString(shuju[v.K]) //转义
										} else if v.K == "img" {
											if shuju[v.K] != "" {
												binaryData, err := base64.StdEncoding.DecodeString(shuju[v.K])
												if err != nil {
													binaryData = []byte{}
												}
												var imgtype string
												if data.Imgtp != "" {
													if data.Imgtp == "image/png" {
														imgtype = ".png"
													} else if data.Imgtp == "image/jpeg" {
														imgtype = ".jpg"
													} else if data.Imgtp == "image/gif" {
														imgtype = ".gif"
													} else if data.Imgtp == "image/bmp" {
														imgtype = ".bmp"
													} else if data.Imgtp == "image/webp" {
														imgtype = ".webp"
													} else if data.Imgtp == "image/tiff" {
														imgtype = ".tiff"
													}
												}
												if imgtype != "" {
													filename := "/static/up/channel/" + lmid + imgtype // 定义要写入的文件名
													if savefile(filename, binaryData) {
														csj[v.K] = filename
													}
												}
											}
										} else {
											csj[v.K] = html.EscapeString(shuju[v.K]) //转义
										}
									}
									neirong += "栏目修改成功!<br>"
									channel.W(lmid, csj)
									generateqrcode(homeurl, "c", lmid) // 生成二维码
								} else {
									neirong += "请输入栏目名称！<br>"
								}
							} else {
								for _, v := range czd {
									if v.K == "subid" || v.K == "artid" || v.K == "mx" {
										continue
									}
									neirong += "<p>" + v.N + "{{.c_" + v.K + "}}：<br>"
									if v.K == "lx" {
										neirong += "1代表列表/2代表单页/3查询数据<br>"
									}
									if v.T == "1" {
										neirong += "<input type=text name='" + v.K + "' size='60' value='" + csj[v.K] + "'></p>"
									} else if v.T == "2" {
										neirong += "<textarea placeholder='请输入" + v.N + "'  rows='3' cols='60' name='" + v.K + "'>" + csj[v.K] + "</textarea></p>"
									} else if v.T == "4" {
										hfmsg["c"] = html.UnescapeString(csj[v.K]) //反转义
									} else if v.T == "9" {
										neirong += csj[v.K] + "</p>"
									} else if v.T == "10" {
										if csj[v.K] != "" {
											neirong += "<img src='" + homeurl + csj[v.K] + "' width='200'  ><br>"
										}
										neirong += "<input type='file' id='" + v.K + "' name='" + v.K + "' value='" + csj[v.K] + "'>"
										hfmsg["i"] = "1"
									}
								}
								cid++
								hfmsg["up"] += fmt.Sprintf("<input type='button' value='提交修改' onclick=cmd2(%d) required>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd, "lmid": lmid}
							}
						}
					} else if cmd2 == "查看栏目" {
						if lmid != "" {
							//获取栏目信息
							csj := channel.R(lmid)
							neirong += "<p>栏目：" + csj["title"] + "</p>"
							if cmd3 != "" {
								if cmd3 == "添加文章" {
									//获取文章字段
									azd := articlefield.R(csj["mx"])
									if cmd4 != "" {
										if shuju["title"] != "" {
											zx := miscellaneous.R("1")
											aid := zx["aid"]
											aid2, ok := strconv.Atoi(aid)
											if ok != nil {
												aid2 = 0
											}
											aid2++
											aid3 := strconv.Itoa(aid2)
											zx["aid"] = aid3
											miscellaneous.W("1", zx)
											//初始化文章数据
											var asj = make(map[string]string)
											for _, v := range azd {
												if v.K == "neirong" {
													asj[v.K] = html.EscapeString(shuju[v.K]) //转义
												} else if v.K == "img" {
													if shuju[v.K] != "" {
														binaryData, err := base64.StdEncoding.DecodeString(shuju[v.K])
														if err != nil {
															binaryData = []byte{}
														}
														var imgtype string
														if data.Imgtp != "" {
															if data.Imgtp == "image/png" {
																imgtype = ".png"
															} else if data.Imgtp == "image/jpeg" {
																imgtype = ".jpg"
															} else if data.Imgtp == "image/gif" {
																imgtype = ".gif"
															} else if data.Imgtp == "image/bmp" {
																imgtype = ".bmp"
															} else if data.Imgtp == "image/webp" {
																imgtype = ".webp"
															} else if data.Imgtp == "image/tiff" {
																imgtype = ".tiff"
															}
														}
														if imgtype != "" {
															filename := "/static/up/article/" + aid3 + imgtype // 定义要写入的文件名
															if savefile(filename, binaryData) {
																asj[v.K] = filename
															} else {
																asj[v.K] = "/static/nopic.png"
															}
														} else {
															asj[v.K] = "/static/nopic.png"
														}
													} else {
														asj[v.K] = "/static/nopic.png"
													}
												} else if v.K == "imgs" {
													var img_list []string
													imgs := data.Imgs
													if len(imgs) != 0 {
														//历遍imgs
														for _, v2 := range imgs {
															if v2["tp"] != "" && v2["ab"] != "" {
																binaryData, err := base64.StdEncoding.DecodeString(v2["ab"])
																if err != nil {
																	binaryData = []byte{}
																}
																var imgtype string
																if v2["tp"] != "" {
																	if v2["tp"] == "image/png" {
																		imgtype = ".png"
																	} else if v2["tp"] == "image/jpeg" {
																		imgtype = ".jpg"
																	} else if v2["tp"] == "image/gif" {
																		imgtype = ".gif"
																	} else if v2["tp"] == "image/bmp" {
																		imgtype = ".bmp"
																	} else if v2["tp"] == "image/webp" {
																		imgtype = ".webp"
																	} else if v2["tp"] == "image/tiff" {
																		imgtype = ".tiff"
																	}
																}
																if imgtype != "" {
																	filename := "/static/up/article/" + aid3 + "_" + getrand(8) + imgtype // 定义要写入的文件名
																	if savefile(filename, binaryData) {
																		img_list = append(img_list, filename)
																	}
																}
															}
														}
													}
													asj[v.K] = strings.Join(img_list, ",")
												} else if v.K == "time" {
													asj[v.K] = strings.Split(html.EscapeString(shuju[v.K]), " m=")[0]
												} else {
													asj[v.K] = html.EscapeString(shuju[v.K]) //转义
												}
											}
											asj["topid"] = lmid
											if asj["tsgs"] != "" {
												arrtsgs := strings.Split(asj["tsgs"], ",")
												for _, v := range arrtsgs {
													if v != "" {
														tag.Add("1", v)
													}
												}
											}
											article.W(aid3, asj) //保存文章
											addartid(aid3, lmid) //将文章id添加到所属栏目下
											if csj["lx"] == "3" {
												generateqrcode3(homeurl, asj["title"], aid3) // 生成二维码
											} else {
												newarticle.Add("1", aid3)          //添加到最新文章
												go upmap()                         //更新地图
												generateqrcode(homeurl, "a", aid3) // 生成二维码
												pushlinks(homeurl + "/a/" + aid3)  //推送链接
											}
											neirong = "文章添加成功!<br>"
										} else {
											neirong += "文章标题不能为空！"
										}
									} else {
										//历遍文章字段
										for _, v := range azd {
											neirong += "<p>" + v.N + "{{.a_" + v.K + "}}：<br>"
											if v.T == "1" {
												if v.K == "title" {
													neirong += "<input onkeyup='jianchatitle(this.value)' type=text name='" + v.K + "' size='60' value='" + v.V + "'></p>"
													neirong += "<div id='jianchatitlejieguo'></div>"
												} else {
													neirong += "<input type=text name='" + v.K + "' size='60' value='" + v.V + "'></p>"
												}
											} else if v.T == "2" {
												neirong += "<textarea placeholder='请输入" + v.N + "'  rows='3' cols='60' name='" + v.K + "'></textarea></p>"
											} else if v.T == "4" {
												hfmsg["c"] = ""
												neirong += "</p>"
											} else if v.T == "5" {
												neirong += "<input onfocus=this.blur() name='" + v.K + "' value='" + lmid + "' /></p>"
											} else if v.T == "6" {
												neirong += fmt.Sprintf("<input type=text name='"+v.K+"' size='60' value='%s'></p>", time.Now())
											} else if v.T == "7" {
												neirong += "<input type=text name='" + v.K + "' size='60' value='0'></p>"
											} else if v.T == "9" {
												if lmid == "" {
													lmid = "0"
												}
												neirong += "<input onfocus=this.blur() name='" + v.K + "' size='60' value='" + lmid + "'></p>"
											} else if v.T == "10" {
												neirong += "<input type='file' id='" + v.K + "' name='" + v.K + "' >"
												hfmsg["i"] = "1"
											} else if v.T == "11" {
												neirong += "<input type='file' id='" + v.K + "' name='" + v.K + "' multiple='multiple'>"
												hfmsg["i"] = "1"
											}
										}
										cid++
										hfmsg["up"] += fmt.Sprintf("<p><input type='button' value='点击提交' onclick=cmd2(%d) required></p>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd, "lmid": lmid}
									}
								} else if cmd3 == "修改文章" {
									if cmds["wzid"] != "" {
										wzid := cmds["wzid"]
										//获取文章信息
										asj := article.R(wzid)
										azd := articlefield.R(csj["mx"])
										if cmd4 != "" {
											if shuju["title"] != "" {
												for _, v := range azd {
													if v.K == "time" || v.K == "topid" {
														continue
													}
													if v.K == "neirong" {
														asj[v.K] = html.EscapeString(shuju[v.K]) //转义
													} else if v.K == "img" {
														if shuju[v.K] != "" {
															binaryData, err := base64.StdEncoding.DecodeString(shuju[v.K])
															if err != nil {
																binaryData = []byte{}
															}
															var imgtype string
															if data.Imgtp != "" {
																if data.Imgtp == "image/png" {
																	imgtype = ".png"
																} else if data.Imgtp == "image/jpeg" {
																	imgtype = ".jpg"
																} else if data.Imgtp == "image/gif" {
																	imgtype = ".gif"
																} else if data.Imgtp == "image/bmp" {
																	imgtype = ".bmp"
																} else if data.Imgtp == "image/webp" {
																	imgtype = ".webp"
																} else if data.Imgtp == "image/tiff" {
																	imgtype = ".tiff"
																}
															}
															if imgtype != "" {
																filename := "/static/up/article/" + wzid + imgtype // 定义要写入的文件名
																if savefile(filename, binaryData) {
																	asj[v.K] = filename
																}
															}
														}
													} else if v.K == "imgs" {
														img_list := strings.Split(asj["imgs"], ",") //转切片
														if img_list[0] == "" {
															img_list = []string{}
														}
														imgs := data.Imgs
														if len(imgs) != 0 {
															//历遍imgs
															for _, v2 := range imgs {
																if v2["tp"] != "" && v2["ab"] != "" {
																	binaryData, err := base64.StdEncoding.DecodeString(v2["ab"])
																	if err != nil {
																		binaryData = []byte{}
																	}
																	var imgtype string
																	if v2["tp"] != "" {
																		if v2["tp"] == "image/png" {
																			imgtype = ".png"
																		} else if v2["tp"] == "image/jpeg" {
																			imgtype = ".jpg"
																		} else if v2["tp"] == "image/gif" {
																			imgtype = ".gif"
																		} else if v2["tp"] == "image/bmp" {
																			imgtype = ".bmp"
																		} else if v2["tp"] == "image/webp" {
																			imgtype = ".webp"
																		} else if v2["tp"] == "image/tiff" {
																			imgtype = ".tiff"
																		}
																	}
																	if imgtype != "" {
																		filename := "/static/up/article/" + wzid + "_" + getrand(8) + imgtype // 定义要写入的文件名
																		if savefile(filename, binaryData) {
																			img_list = append(img_list, filename)
																		}
																	}
																}
															}
														}
														asj[v.K] = strings.Join(img_list, ",")
													} else {
														asj[v.K] = html.EscapeString(shuju[v.K]) //转义
													}
												}
												article.W(wzid, asj)
												neirong = "文章修改成功!<br>"
											} else {
												neirong += "文章标题不能为空！"
											}
										} else {
											if cmd5 != "" && cmds["imgid"] != "" {
												imgid, _ := strconv.Atoi(cmds["imgid"])
												//删除图集
												imgs := strings.Split(asj["imgs"], ",") //转切片
												if imgid <= len(imgs) {
													imgs = append(imgs[:imgid], imgs[imgid+1:]...)
													asj["imgs"] = strings.Join(imgs, ",")
													article.W(wzid, asj)
												}
											}
											neirong += "<p>修改文章：" + asj["title"] + "</p>"
											//历遍文章字段
											for _, v := range azd {
												neirong += "<p>" + v.N + "{{.a_" + v.K + "}}：<br>"
												if v.T == "1" {
													if v.K == "title" {
														neirong += "<input onkeyup='jianchatitle(this.value)' type=text name='" + v.K + "' size='60' value='" + asj[v.K] + "'></p>"
														neirong += "<div id='jianchatitlejieguo'></div>"
													} else {
														neirong += "<input type=text name='" + v.K + "' size='60' value='" + asj[v.K] + "'></p>"
													}

												} else if v.T == "2" {
													neirong += "<textarea placeholder='请输入" + v.N + "'  rows='3' cols='60' name='" + v.K + "'>" + asj[v.K] + "</textarea></p>"
												} else if v.T == "4" {
													hfmsg["c"] = html.UnescapeString(asj[v.K]) //反转义
													neirong += "</p>"
												} else if v.T == "5" {
													neirong += asj[v.K] + "</p>"
												} else if v.T == "6" {
													neirong += fmt.Sprintf("<input onfocus=this.blur() name='"+v.K+"' size='60' value='%s'></p>", asj[v.K])
												} else if v.T == "7" {
													neirong += "<input type=text name='" + v.K + "' size='60' value='" + asj[v.K] + "'></p>"
												} else if v.T == "10" {
													neirong += "<img src='" + homeurl + asj[v.K] + "' width='200'  ><br>"
													neirong += "<input type='file' id='" + v.K + "' name='" + v.K + "' >"
													hfmsg["i"] = "1"
												} else if v.T == "11" {
													imgs := strings.Split(asj["imgs"], ",") //转切片
													if imgs[0] != "" {
														i := 0
														for ii, img := range imgs {
															i++
															neirong += fmt.Sprintf("%d.<img src='"+homeurl+img+"' width='200'  >", i)
															cid++
															neirong += fmt.Sprintf("[<a onclick=cmd(%d)>删除</a>]<br>", cid)
															dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd5": cmd, "lmid": lmid, "wzid": wzid, "imgid": strconv.Itoa(ii)}
														}
													}
													neirong += "<input type='file' id='" + v.K + "' name='" + v.K + "' multiple='multiple'>"
													hfmsg["i"] = "1"
												}
											}
											cid++
											hfmsg["up"] += fmt.Sprintf("<p><input type='button' value='提交修改' onclick=cmd2(%d) required></p>", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd, "lmid": lmid, "wzid": wzid}
										}
									}
								} else if cmd3 == "删除文章" {
									if cmds["wzid"] != "" {
										wzid := cmds["wzid"]
										asj := article.R(wzid)
										if cmd4 != "" {
											Deletecontent([]string{wzid}, asj["topid"]) // 删除文章
											go upmap()                                  //更新地图
											neirong += "删除成功!<br>"
										} else {
											//获取文章信息
											neirong += "<p>确定删除文章：" + asj["title"] + "?</p>"
											cid++
											neirong += fmt.Sprintf("<p><input type='button' value='确认删除' onclick=cmd2(%d) required></p>", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd, "lmid": lmid, "wzid": wzid, "yema": yema}
											cid++
											neirong += fmt.Sprintf("<p><input type='button' value='取消删除' onclick=cmd2(%d) required></p>", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "wzid": wzid, "yema": yema}
										}
									}
								} else if cmd3 == "链接" {
									if cmds["wzid"] != "" {
										lslink := homeurl + "/a/" + cmds["wzid"]
										if csj["lx"] == "3" {
											asj := article.R(cmds["wzid"])
											lslink = homeurl + "/q/" + asj["title"]
										}
										neirong += "链接：<br>"
										neirong += "<p><input id='mubanneirong' name='mubanneirong' size='60' value='" + lslink + "'><br></p>"
										neirong += `<p><button onclick="fuzhidaima()">复制</button><br></p><p><a id="mubanneirong2" style="display:none;">复制成功!</a></p>`
									}
								}
								cid++
								hfmsg["up"] += fmt.Sprintf("<p>[<a onclick=cmd(%d) required>返回上一级</a>]</p>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "yema": yema}
							} else {
								//if csj["lx"] == "2" {
								//neirong += "单页栏目不能发布文章!<br>"
								//} else {
								cid++
								neirong += fmt.Sprintf("<p>[<a onclick=cmd(%d)>添加文章</a>]</p>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "添加文章", "lmid": lmid}
								var artid = strings.Split(csj["artid"], ",") //转切片
								var lsyema int
								if yema != "" {
									lsyema, _ = strconv.Atoi(yema)
								} else {
									lsyema = 1
								}
								var zsl = len(artid)                          //总数量
								var zyema = int(math.Ceil(float64(zsl) / 20)) //总页码
								//当前页码
								if lsyema > zyema && zyema > 0 {
									lsyema = zyema
								}
								var yemax = lsyema + 1 //下一页
								if yemax < 0 {
									yemax = 1
								}
								var yemas = lsyema - 1 //上一页
								if yemas < 0 {
									yemas = 1
								}
								kaishiid := (lsyema - 1) * 20 //开始id
								jieshuid := lsyema * 20       //结束id
								if kaishiid > zsl {
									kaishiid = zsl
								}
								if jieshuid > zsl {
									jieshuid = zsl
								}
								i := kaishiid
								//截取artid
								artid = artid[kaishiid:jieshuid]
								if len(artid) > 0 && artid[0] != "" {
									for _, v := range artid {
										//获取文章数据
										asj := article.R(v)
										i++
										cid++
										t, _ := time.Parse("2006-01-02 15:04:05.999999999 -0700 MST", asj["time"])
										if asj["topid"] == lmid {
											neirong += fmt.Sprintf("%d.<a onclick=cmd(%d)>"+asj["title"]+"</a> [%s]", i, cid, t.Format("2006-01-02 15:04:05"))
										} else {
											//获取topid栏目数据
											tcsj := channel.R(asj["topid"])
											neirong += fmt.Sprintf("%d.<a onclick=cmd(%d)>"+asj["title"]+"</a> [%s] [%s]", i, cid, tcsj["title"], t.Format("2006-01-02 15:04:05"))
										}
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "修改文章", "lmid": lmid, "wzid": v, "yema": yema}
										cid++
										neirong += fmt.Sprintf(" [<a onclick=cmd(%d)>删除</a>] ", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "删除文章", "lmid": lmid, "wzid": v, "yema": yema}
										cid++
										neirong += fmt.Sprintf("[<a onclick=cmd(%d)>链接</a>] ", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "链接", "lmid": lmid, "wzid": v, "yema": yema}
										neirong += `[<a href="./static/qrcode/a/` + v + `.png" target="_blank">二维码</a>]<br><br>`
									}
									//创建页码
									ymif := ""
									if lsyema > 1 {
										cid++
										ymif += fmt.Sprintf("<a onclick=cmd(%d)>上页</a> ", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "yema": strconv.Itoa(yemas)}

									}
									if jieshuid < zsl {
										cid++
										ymif += fmt.Sprintf("<a onclick=cmd(%d)>下.页</a> ", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "yema": strconv.Itoa(yemax)}
									}
									if lsyema > 2 {
										cid++
										ymif += fmt.Sprintf("<a onclick=cmd(%d)>首页</a> ", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "yema": "1"}
									}
									if zyema-lsyema > 1 {
										cid++
										ymif += fmt.Sprintf("<a onclick=cmd(%d)>末页</a> ", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "lmid": lmid, "yema": strconv.Itoa(zyema)}
									}
									if ymif != "" {
										neirong += "<br>" + ymif + "<br>"
									}
								} else {
									neirong += "暂无文章!<br>"
								}
								//}
							}
						}
					} else if cmd2 == "栏目字段" {
						if cmds["zdlx"] != "" {
							//获取栏目字段
							czd := channelfield.R(cmds["zdlx"])
							var bianhua = false
							//添加字段
							if cmd3 != "" {
								shuju["addziduan"] = removeInvalidChars(shuju["addziduan"])      //删除不是中文、字母和数字的字符
								shuju["addziduan2"] = removeNonAlphanumeric(shuju["addziduan2"]) //删除非字母和数字的字符
								if shuju["addziduan"] != "" && shuju["addziduan2"] != "" && shuju["addziduan3"] != "" {
									if shuju["addziduan2"] != "addziduan" && shuju["addziduan2"] != "addziduan2" && shuju["addziduan2"] != "addziduan3" && regexp.MustCompile(`^[a-zA-Z]`).MatchString(shuju["addziduan2"]) {
										ok := true
										var nid int
										for i, v := range czd {
											if v.K == shuju["addziduan2"] {
												ok = false
											}
											if v.K == "neirong" {
												nid = i
											}
										}
										if ok {
											if shuju["addziduan3"] != "2" {
												shuju["addziduan3"] = "1"
											}
											newData := make([]Ziduan, len(czd)+1)                                                   // 创建一个新的切片，长度比原来的切片多1
											copy(newData, czd[:nid])                                                                // 复制前半部分
											newData[nid] = Ziduan{shuju["addziduan"], shuju["addziduan2"], "", shuju["addziduan3"]} // 插入新元素
											copy(newData[nid+1:], czd[nid:])                                                        // 复制后半部分
											czd = newData
											neirong += "新增字段成功<br>"
											bianhua = true
										} else {
											neirong += "新增字段名称重复<br>"
										}
									} else {
										neirong += "新增字段名称不可以是addziduan、addziduan2、addziduan3,且需要时字母开头<br>"
									}
								}
							}
							//删除字段
							if cmd4 != "" && cmds["ziduan"] != "" {
								var ziduan = cmds["ziduan"]
								ok := true
								//循环判断是否为栏目默认字段
								for _, v := range channelzd {
									if v.K == ziduan {
										ok = false
									}
								}
								if !ok {
									neirong += "栏目自带字段不可以删除！<br>"
								} else {
									if cmd5 != "" {
										var nid int
										//历遍获取字段位置
										for i, v := range czd {
											if v.K == ziduan {
												nid = i
												break
											}
										}
										czd = append(czd[:nid], czd[nid+1:]...)
										bianhua = true
										neirong += "成功删除 " + ziduan + " 字段!<br>"
									} else {
										neirong += "确定删除 " + ziduan + " 字段？<br>"
										cid++
										neirong += fmt.Sprintf("<br><a style='color:red;' onclick=cmd(%d)>[确定删除]</a><br><br>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd4, "cmd5": "删除", "ziduan": ziduan, "zdlx": cmds["zdlx"]}
										cid++
										neirong += fmt.Sprintf("<a onclick=cmd(%d)>[取消删除]</a><br><br>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": cmds["zdlx"]}
										break
									}
								}
							}
							if bianhua {
								channelfield.W(cmds["zdlx"], czd)
							}
							for _, v := range czd {
								cid++
								neirong += fmt.Sprintf(v.N+" {{.c_"+v.K+"}}：<a onclick=cmd(%d)>[删除]</a><br>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd4": "删除", "ziduan": v.K, "zdlx": cmds["zdlx"]}
							}
							neirong += "<p>---<br>添加字段："
							neirong += "<br>字段说明(如:栏目标题): <input type=text name='addziduan' size='30' value=''>"
							neirong += "<br>字段名称(如:title):<input type=text name='addziduan2' size='35' value=''>"
							neirong += "<br>字段类型(如:1代表单行文本、2代表多行文本): <input type=text name='addziduan3' size='7' value=''>"
							neirong += "<br>---</p>"
							cid++
							neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "添加字段", "zdlx": cmds["zdlx"]}
						} else {
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[1]文章模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "1"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[2]单页模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "2"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[3]图片模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "3"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[4]附件模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "4"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[5]视频模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "5"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[6]音频模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "6"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[7]链接模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "7"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[8]自定义模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "8"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[9]自定义模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "9"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[10]自定义模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "10"}
							cid++
						}
					} else if cmd2 == "文章字段" {
						if cmds["zdlx"] != "" {
							//获取文章
							azd := articlefield.R(cmds["zdlx"])
							var bianhua = false
							//添加字段
							if cmd3 != "" {
								shuju["addziduan"] = removeInvalidChars(shuju["addziduan"])      //删除不是中文、字母和数字的字符
								shuju["addziduan2"] = removeNonAlphanumeric(shuju["addziduan2"]) //删除非字母和数字的字符
								if shuju["addziduan"] != "" && shuju["addziduan2"] != "" && shuju["addziduan3"] != "" {
									if shuju["addziduan2"] != "addziduan" && shuju["addziduan2"] != "addziduan2" && shuju["addziduan2"] != "addziduan3" && regexp.MustCompile(`^[a-zA-Z]`).MatchString(shuju["addziduan2"]) {
										ok := true
										var nid int
										for i, v := range azd {
											if v.K == shuju["addziduan2"] {
												ok = false
											}
											if v.K == "neirong" {
												nid = i
											}
										}
										if ok {
											if shuju["addziduan3"] != "2" {
												shuju["addziduan3"] = "1"
											}
											newData := make([]Ziduan, len(azd)+1)                                                   // 创建一个新的切片，长度比原来的切片多1
											copy(newData, azd[:nid])                                                                // 复制前半部分
											newData[nid] = Ziduan{shuju["addziduan"], shuju["addziduan2"], "", shuju["addziduan3"]} // 插入新元素
											copy(newData[nid+1:], azd[nid:])                                                        // 复制后半部分
											azd = newData
											neirong += "新增字段成功<br>"
											bianhua = true
										} else {
											neirong += "新增字段名称重复<br>"
										}
									} else {
										neirong += "新增字段名称不可以是addziduan、addziduan2、addziduan3,且需要时字母开头<br>"
									}
								}
							}
							//删除字段
							if cmd4 != "" && cmds["ziduan"] != "" {
								var ziduan = cmds["ziduan"]
								ok := true
								//循环判断是否为文章默认字段
								for _, v := range articlezd {
									if v.K == ziduan {
										ok = false
									}
								}
								if !ok {
									neirong += "文章自带字段不可以删除！<br>"
								} else {
									if cmd5 != "" {
										var nid int
										//历遍获取字段位置
										for i, v := range azd {
											if v.K == ziduan {
												nid = i
												break
											}
										}
										azd = append(azd[:nid], azd[nid+1:]...)
										bianhua = true
										neirong += "成功删除 " + ziduan + " 字段!<br>"
									} else {
										neirong += "确定删除 " + ziduan + " 字段？<br>"
										cid++
										neirong += fmt.Sprintf("<br><a style='color:red;' onclick=cmd(%d)>[确定删除]</a><br><br>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd4, "cmd5": "删除", "ziduan": ziduan, "zdlx": cmds["zdlx"]}
										cid++
										neirong += fmt.Sprintf("<a onclick=cmd(%d)>[取消删除]</a><br><br>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": cmds["zdlx"]}
										break
									}
								}
							}
							if bianhua {
								articlefield.W(cmds["zdlx"], azd)
							}
							for _, v := range azd {
								cid++
								neirong += fmt.Sprintf(v.N+" {{.a_"+v.K+"}}：<a onclick=cmd(%d)>[删除]</a><br>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd4": "删除", "ziduan": v.K, "zdlx": cmds["zdlx"]}
							}
							neirong += "<p>---<br>添加字段："
							neirong += "<br>字段说明(如:文章标题): <input type=text name='addziduan' size='30' value=''>"
							neirong += "<br>字段名称(如:title):<input type=text name='addziduan2' size='35' value=''>"
							neirong += "<br>字段类型(如:1代表单行文本、2代表多行文本): <input type=text name='addziduan3' size='7' value=''>"
							neirong += "<br>---</p>"
							cid++
							neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "添加字段", "zdlx": cmds["zdlx"]}
						} else {
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[1]文章模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "1"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[2]单页模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "2"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[3]图片模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "3"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[4]附件模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "4"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[5]视频模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "5"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[6]音频模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "6"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[7]链接模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "7"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[8]自定义模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "8"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[9]自定义模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "9"}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd2(%d)>[10]自定义模型</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "zdlx": "10"}
							cid++
						}
					} else if cmd2 == "链接" {
						if cmds["lmid"] != "" {
							neirong += "链接：<br>"
							neirong += "<p><input id='mubanneirong' name='mubanneirong' size='60' value='" + homeurl + "/c/" + cmds["lmid"] + "'><br></p>"
							neirong += `<p><button onclick="fuzhidaima()">复制</button><br></p><p><a id="mubanneirong2" style="display:none;">复制成功!</a></p>`
						}
					}
					cid++
					hfmsg["up"] += fmt.Sprintf("<p><a onclick=cmd(%d)>[返回栏目]</a></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd}
				} else {
					cid++
					neirong += fmt.Sprintf("<p><a onclick=cmd(%d)>[添加栏目]</a> ", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "添加栏目"}
					cid++
					neirong += fmt.Sprintf("<a onclick=cmd(%d)>[栏目字段]</a> ", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "栏目字段"}
					cid++
					neirong += fmt.Sprintf("<a onclick=cmd(%d)>[文章字段]</a></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "文章字段"}
					zsl := len(topcid)
					if cmd3 != "" && cmds["chid"] != "" {
						//将cmds["chid"]转int
						id, _ := strconv.Atoi(cmds["chid"])
						if cmd3 == "向上" && id > 0 {
							topcid[id], topcid[id-1] = topcid[id-1], topcid[id]
							topchannel.W("1", topcid)
						} else if cmd3 == "向下" && id < zsl-1 {
							topcid[id], topcid[id+1] = topcid[id+1], topcid[id]
							topchannel.W("1", topcid)
						}
					}
					if zsl > 0 {
						var i = 0
						for id, v := range topcid {
							//获取顶级栏目信息
							csj := channel.R(v)
							//历遍获取栏目title、下属栏目、下属文章
							var title string = csj["title"]
							var subid []string = strings.Split(csj["subid"], ",")
							//var artid []string = strings.Split(csj["artid"], ",")
							var lx string = csj["lx"]
							i++
							cid++
							if lx == "2" {
								lx = "单页"
								neirong += fmt.Sprintf("%d. <a onclick=cmd(%d)>"+title+"</a>[id:"+v+"]["+lx+"] ", i, cid)
							} else if lx == "3" {
								lx = "列表"
								var artid []string = strings.Split(csj["artid"], ",")
								wzsl := len(artid)
								if artid[0] == "" {
									wzsl = 0
								}
								neirong += fmt.Sprintf(`%d. <span style="color:red;">[查]</span><a onclick=cmd(%d)>%s</a>[id:%s][%s][%d] `, i, cid, title, v, lx, wzsl)
							} else {
								lx = "列表"
								var artid []string = strings.Split(csj["artid"], ",")
								wzsl := len(artid)
								if artid[0] == "" {
									wzsl = 0
								}
								neirong += fmt.Sprintf("%d. <a onclick=cmd(%d)>"+title+"</a>[id:"+v+"]["+lx+"][%d] ", i, cid, wzsl)
							}
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "查看栏目", "lmid": v}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>修改</a>]", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "修改栏目", "lmid": v}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>删除</a>]", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "删除栏目", "lmid": v}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>添加</a>] ", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "添加栏目", "lmid": v}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>向上</a>] ", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": "向上", "chid": strconv.Itoa(id)}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>向下</a>] ", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": "向下", "chid": strconv.Itoa(id)}
							if csj["lx"] == "3" {
								neirong += "<br>"
							} else {
								cid++
								neirong += fmt.Sprintf("[<a onclick=cmd(%d)>链接</a>] ", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "链接", "lmid": v}
								neirong += `[<a href="./static/qrcode/c/` + v + `.png" target="_blank">二维码</a>]<br>`
							}
							//获取二级栏目列表
							if len(subid) > 0 && subid[0] != "" {
								for _, v3 := range subid {
									//获取二级栏目信息
									csj := channel.R(v3)
									//历遍获取栏目title、下属栏目、下属文章
									var title string = csj["title"]
									//var subid []string = strings.Split(csj["subid"], ",")
									//var artid []string = strings.Split(csj["artid"], ",")
									var lx string = csj["lx"]
									cid++
									if lx == "1" {
										lx = "列表"
										var artid []string = strings.Split(csj["artid"], ",")
										wzsl := len(artid)
										if artid[0] == "" {
											wzsl = 0
										}
										neirong += fmt.Sprintf(" &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;-<a onclick=cmd(%d)>"+title+"</a>[id:"+v3+"]["+lx+"][%d] ", cid, wzsl)
									} else {
										lx = "单页"
										neirong += fmt.Sprintf(" &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;-<a onclick=cmd(%d)>"+title+"</a>[id:"+v3+"]["+lx+"] ", cid)
									}
									dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "查看栏目", "lmid": v3}
									cid++
									neirong += fmt.Sprintf("[<a onclick=cmd(%d)>修改</a>]", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "修改栏目", "lmid": v3}
									cid++
									neirong += fmt.Sprintf("[<a onclick=cmd(%d)>删除</a>] ", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "删除栏目", "lmid": v3}
									if csj["lx"] == "3" {
										neirong += "<br>"
									} else {
										cid++
										neirong += fmt.Sprintf("[<a onclick=cmd(%d)>链接</a>] ", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "链接", "lmid": v3}
										neirong += `[<a href="./static/qrcode/c/` + v3 + `.png" target="_blank">二维码</a>]<br>`
									}
									// cid++
									// neirong += fmt.Sprintf("[<a onclick=cmd(%d)>添加子栏目</a>]", cid)
									// dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "添加栏目", "lmid": v}
								}
							}
							neirong += "<br>"
						}
					}
				}
			case "友情链接":
				//获取友情连接
				flinks := friendlinks.R("1")
				if cmd3 != "" {
					if cmds["finkid"] != "" {
						finkid, _ := strconv.Atoi(cmds["finkid"])
						if cmd3 == "删除链接" {
							if cmd4 != "" {
								if finkid <= len(flinks) {
									flinks = append(flinks[:finkid], flinks[finkid+1:]...)
									friendlinks.W("1", flinks)
								}
								neirong += "友情链接删除功!<br>"
							} else {
								neirong += "<p>确定删除：" + flinks[finkid].N + flinks[finkid].V + "?</p>"
								cid++
								neirong += fmt.Sprintf("<input type='button' value='确定删除' onclick=cmd(%d) required></p>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": cmd3, "cmd4": cmd, "finkid": fmt.Sprintf("%d", finkid)}
								cid++
								neirong += fmt.Sprintf("<input type='button' value='取消删除' onclick=cmd(%d) required></p>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd}
							}
						} else if cmd3 == "修改链接" {
							if cmd4 != "" {
								if shuju["title"] != "" && shuju["url"] != "" {
									flinks[finkid].N = shuju["title"]
									flinks[finkid].V = shuju["url"]
									neirong += "友情链接修改成功!<br>"
									friendlinks.W("1", flinks)
								} else {
									neirong += "友情链接名称不能为空!<br>"
								}
							} else {
								neirong += "<p>网站名称：<input type='text' name='title' value='" + flinks[finkid].N + "'></p>"
								neirong += "<p>网站地址：<input type='text' name='url' value='" + flinks[finkid].V + "'></p>"
								cid++
								neirong += fmt.Sprintf("<input type='button' value='修改友情链接' onclick=cmd2(%d) required></p>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": cmd3, "cmd4": cmd, "finkid": fmt.Sprintf("%d", finkid)}
							}
						}
					}
				} else {
					if cmd2 != "" {
						if shuju["title"] != "" && shuju["url"] != "" {
							flinks = append(flinks, Ziduan{N: shuju["title"], V: shuju["url"]})
							friendlinks.W("1", flinks)
						} else {
							neirong += "友情链接名称不能为空!<br>"
						}
					}
					neirong += "<p>网站名称：<input type='text' name='title'></p>"
					neirong += "<p>网站地址：<input type='text' name='url'></p>"
					cid++
					neirong += fmt.Sprintf("<input type='button' value='添加友情链接' onclick=cmd2(%d) required></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd}
					//历遍友情连接
					if len(flinks) > 0 {
						i := 0
						for ii, v := range flinks {
							i++
							cid++
							neirong += fmt.Sprintf("%d. 名称：%s  链接：[%s] [<a onclick=cmd(%d)>修改</a>]", i, v.N, v.V, cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": "修改链接", "finkid": fmt.Sprintf("%d", ii)}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>删除</a>]<br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd3": "删除链接", "finkid": fmt.Sprintf("%d", ii)}
						}
					}
				}
			case "数据备份":
				if cmd2 != "" {
					neirong += backup_data()
				}
				cid++
				neirong += fmt.Sprintf("<p><a onclick=cmd(%d) required>新建备份</a></p>", cid)
				dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "新建备份"}
			case "数据还原":
				backupdir := "./backup/back" //备份目录
				files, err := listFiles(backupdir)
				if err != nil {
					neirong += "没有备份文件<br>"
				}
				if cmd2 != "" && cmds["filename"] != "" {
					filename := cmds["filename"]
					if cmd2 == "还原" {
						if cmd3 != "" {
							neirong += restore_data(filename)
						} else {
							neirong += "确定还原备份数据：" + filename + "?<br>"
							cid++
							neirong += fmt.Sprintf("<br><a style='color:red;' onclick=cmd(%d)>[确定还原]</a><br><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "还原", "filename": filename, "yema": yema}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd(%d)>[取消还原]</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "yema": yema}
						}
					} else if cmd2 == "删除" {
						if cmd3 != "" {
							err := os.Remove(filename)
							if err != nil {
								neirong += "备份数据：" + filename + "删除失败<br>"
							} else {
								neirong += "备份数据：" + filename + "删除成功<br>"
							}
							neirong += fmt.Sprintf("<a onclick=cmd(%d)>[返回上级]</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "yema": yema}
						} else {
							neirong += "确定删除备份数据：" + filename + "?<br>"
							cid++
							neirong += fmt.Sprintf("<br><a style='color:red;' onclick=cmd(%d)>[确定删除]</a><br><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "删除", "filename": filename, "yema": yema}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd(%d)>[取消删除]</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "yema": yema}
						}
					} else if cmd2 == "下载" {
						fileN, content := unzip(filename) //解压
						if fileN != "" {
							hfmsg["downneirong"] = content
							hfmsg["downname"] = fileN
							neirong += "<button id='downloadBtn'>下载</button>"
						} else {
							neirong += "文件不存在！<br>"
						}
					} else if cmd2 == "重命名" {
						if cmd3 != "" {
							newfilename := removeNonAlphanumeric(shuju["addziduan"])
							if newfilename != "" {
								ext := path.Ext(newfilename)
								if ext != ".json" {
									newfilename = backupdir + "/" + newfilename + ".json"
								} else {
									newfilename = backupdir + "/" + newfilename
								}
								err := os.Rename(filename, newfilename)
								if err != nil {
									neirong += "备份数据：" + filename + "重命名失败<br>"
								} else {
									neirong += "备份数据：" + filename + "重命名成功<br>"
								}
							} else {
								neirong += "新名称只能由字母和数字组成<br>"
							}
							cid++
							neirong += fmt.Sprintf("<a onclick=cmd(%d)>[返回上级]</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "yema": yema}
						} else {
							neirong += "<p>---<br>重命名：<br>"
							neirong += "旧名称：" + filename + "<br>新名称：<input type=text name='addziduan' size='30' value=''>"
							neirong += "<br>---</p>"
							cid++
							neirong += fmt.Sprintf("<input type='button' value='重命名' onclick=cmd2(%d) required>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "重命名", "filename": filename, "yema": yema}
						}
					}
				} else {
					zsl := len(files)
					if zsl > 0 {
						//页码
						var lsyema int
						if yema != "" {
							lsyema, _ = strconv.Atoi(yema)
						} else {
							lsyema = 1
						}
						ymif := ""
						if lsyema > 1 {
							ls := lsyema - 1
							cid++
							ymif += fmt.Sprintf("<a onclick=cmd(%d) required>上页</a> ", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "yema": strconv.Itoa(ls)}
						}
						if zsl > lsyema*20 {
							ls := lsyema + 1
							cid++
							ymif += fmt.Sprintf("<a onclick=cmd(%d) required>下页</a></br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "yema": strconv.Itoa(ls)}
						}
						kaishiid := (lsyema - 1) * 20
						jieshuid := lsyema * 20 //结束id
						if jieshuid > zsl {
							jieshuid = zsl
						}
						lsfileList := files[kaishiid:jieshuid]
						if len(lsfileList) > 0 && lsfileList[0] != "" {
							for _, v := range lsfileList {
								cid++
								kaishiid++
								size, _ := getFileSize("./" + v)
								neirong += fmt.Sprintf("%d.%s [%.2f KB]<a onclick=cmd(%d) required>[还原]</a> ", kaishiid, v, size, cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "还原", "filename": v, "yema": yema}
								cid++
								neirong += fmt.Sprintf("<a onclick=cmd(%d) required>[删除]</a> ", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "删除", "filename": v, "yema": yema}
								cid++
								neirong += fmt.Sprintf("<a onclick=cmd(%d) required>[下载]</a> ", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "下载", "filename": v, "yema": yema}
								cid++
								neirong += fmt.Sprintf("<a onclick=cmd(%d) required>[重命名]</a></br>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "重命名", "filename": v, "yema": yema}
							}
						}
						if ymif != "" {
							neirong += ymif
						}
					} else {
						neirong += "没有任何备份！<br>"
					}
				}
			case "网站更新":
				if cmd2 != "" {
					if cmd2 == "一键更新地图" {
						go upmap()
						neirong += "./sitemap.xml<br>./sitemap.txt<br>./sitemap.html<br>更新地图完成！"
					}
					if cmd2 == "更新模板缓存" {
						fh := updateTemplate() //更新模板
						if fh != "1" {
							re := regexp.MustCompile(`template: ([^:]+):(\d+):`) // 定义正则表达式
							match := re.FindStringSubmatch(fh)                   // 查找匹配
							if match != nil {
								neirong += match[1] + "第" + match[2] + "行出错，模板新建失败！<br>"
							}
						} else {
							neirong += "更新模板缓存成功！<br>"
						}
					}
				} else {
					cid++
					neirong += fmt.Sprintf("<p><input type='button' value='一键更新地图' onclick=cmd(%d) required></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "一键更新地图"}
					cid++
					neirong += fmt.Sprintf("<p><input type='button' value='更新模板缓存' onclick=cmd(%d) required></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "更新模板缓存"}
				}
			case "系统维护":
				if cmd2 != "" {
					zaxiang := miscellaneous.R("1")
					if cmd2 == "网站模板管理" {
						if cmd3 != "" {
							if cmds["mubandir"] != "" {
								mubandir := cmds["mubandir"]
								if cmd3 == "查看模板" {
									if cmd4 != "" {
										if cmd4 == "新建模板" {
											if cmd5 != "" {
												if shuju["mubanming"] != "" && shuju["mubanneirong"] != "" {
													lsmbname := "./templates/index/" + mubandir + "/" + shuju["mubanming"] + ".htm"
													if !fileExists(lsmbname) && shuju["mubanming"] != "404" {
														newdata := `{{define "index/` + mubandir + `/` + shuju["mubanming"] + `.htm"}}<!--请勿删除这行-->\n`
														newdata += shuju["mubanneirong"]
														newdata += `\n{{end}}<!--请勿删除这行-->`
														newdata = strings.Replace(newdata, "\\n", "\n", -1)
														savefile(lsmbname, []byte(newdata))
														if mubandir == zaxiang["muban"] {
															fh := updateTemplate() //更新模板
															if fh != "1" {
																re := regexp.MustCompile(`template: ([^:]+):(\d+):`) // 定义正则表达式
																match := re.FindStringSubmatch(fh)                   // 查找匹配
																i, _ := strconv.Atoi(match[2])
																i--
																if match != nil {
																	neirong += match[1] + "第" + strconv.Itoa(i) + "行出错，模板新建失败！<br>"
																}
																os.Remove(lsmbname) //删除文件
																neirong += "将在index/" + mubandir + "/下新建模板：<br><p>"
																neirong += "<p>模板名(如：index)：<input type='text' name='mubanming' value='" + shuju["mubanming"] + "'><br></p>"
																neirong += `<p>模板内容：<button onclick="zidonghanhang()">自动换行</button> <button onclick="quxiaozidonghanhang()">不自动换行</button><br></p>`
																neirong += `<p><textarea id='mubanneirong' name='mubanneirong' style="width: 99%; overflow: auto; word-break: break-all;color:#CCCCCC;background-color:#1F1F1F;font-family:Consolas, &quot;font-size:14px;line-height:19px;white-space-collapse:preserve;" cols="60" rows="40">` + shuju["mubanneirong"] + `</textarea><br></p>`
																cid++
																neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required><br>", cid)
																dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd4, "cmd5": cmd4, "mubandir": mubandir}
															} else {
																neirong += shuju["mubanming"] + ".htm<br>模板新建成功！<br>"
															}
														}
													} else {
														neirong += shuju["mubanming"] + ".htm 模板已存在！<br>"
													}
												} else {
													neirong += "模板名称和内容不能为空！<br>"
												}
											} else {
												neirong += "将在index/" + mubandir + "/下新建模板：<br><p>"
												neirong += "<p>模板名(如：index)：<input type='text' name='mubanming' value=''><br></p>"
												neirong += `<p>模板内容：<button onclick="zidonghanhang()">自动换行</button> <button onclick="quxiaozidonghanhang()">不自动换行</button><br></p>`
												neirong += `<p><textarea id='mubanneirong' name='mubanneirong' style="width: 99%; overflow: auto; word-break: break-all;color:#CCCCCC;background-color:#1F1F1F;font-family:Consolas, &quot;font-size:14px;line-height:19px;white-space-collapse:preserve;" cols="60" rows="40"></textarea><br></p>`
												cid++
												neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required><br>", cid)
												dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd4, "cmd5": cmd4, "mubandir": mubandir}
											}
										} else if cmd4 == "修改模板" {
											if cmds["mubanname"] != "" {
												mubanname := cmds["mubanname"]
												lsmbname := "./templates/index/" + mubandir + "/" + mubanname
												odata, err := os.ReadFile(lsmbname)
												if cmd5 != "" {
													if shuju["mubanming"] != "" && shuju["mubanneirong"] != "" {
														savefile(lsmbname, []byte(html.UnescapeString(shuju["mubanneirong"])))
														fh := updateTemplate() //更新模板
														if fh != "1" {
															re := regexp.MustCompile(`template: ([^:]+):(\d+):`) // 定义正则表达式
															match := re.FindStringSubmatch(fh)                   // 查找匹配
															if match != nil {
																neirong += match[1] + "第" + match[2] + "行出错，修改失败！<br>"
															}
															savefile(lsmbname, []byte(odata)) //恢复
															neirong += "修改index/" + mubandir + "/" + mubanname + "：<br>"
															neirong += "<p>模板名：<input type='text' onfocus=this.blur() name='mubanming' value='" + mubanname + "'><br></p>"
															neirong += `<p>模板内容：<button onclick="zidonghanhang()">自动换行</button> <button onclick="quxiaozidonghanhang()">不自动换行</button><br></p>`
															neirong += `<p><textarea id='mubanneirong' name='mubanneirong' style="width: 99%; overflow: auto; word-break: break-all;color:#CCCCCC;background-color:#1F1F1F;font-family:Consolas, &quot;font-size:14px;line-height:19px;white-space-collapse:preserve;" cols="60" rows="40">` + string(shuju["mubanneirong"]) + `</textarea><br></p>`
															cid++
															neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required><br>", cid)
															dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd4, "cmd5": cmd4, "mubandir": mubandir, "mubanname": mubanname}
														} else {
															neirong += shuju["mubanming"] + "<br>模板修改成功！<br>"
														}
													} else {
														neirong += "模板名称和内容不能为空！<br>"
													}
												} else {
													if err != nil {
														neirong += "模板文件不存在！<br>"
													} else {
														neirong += "修改index/" + mubandir + "/" + mubanname + "：<br>"
														neirong += "<p>模板名：<input type='text' onfocus=this.blur() name='mubanming' value='" + mubanname + "'><br></p>"
														neirong += `<p>模板内容：<button onclick="zidonghanhang()">自动换行</button> <button onclick="quxiaozidonghanhang()">不自动换行</button><br></p>`
														neirong += `<p><textarea id='mubanneirong' name='mubanneirong' style="width: 99%; overflow: auto; word-break: break-all;color:#CCCCCC;background-color:#1F1F1F;font-family:Consolas, &quot;font-size:14px;line-height:19px;white-space-collapse:preserve;" cols="60" rows="40">` + html.EscapeString(string(odata)) + `</textarea><br></p>`
														cid++
														neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required><br>", cid)
														dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd4, "cmd5": cmd4, "mubandir": mubandir, "mubanname": mubanname}
													}
												}
											}
										} else if cmd4 == "删除模板" {
											if cmds["mubanname"] != "" {
												mubanname := cmds["mubanname"]
												if cmd5 != "" {
													path := "./templates/index/" + mubandir + "/" + mubanname
													os.Remove(path)                                                                                 //删除文件
													deleteDirectory("./static/index/" + mubandir + "/" + strings.ReplaceAll(mubanname, ".htm", "")) //删除单页采集的模板目录
													neirong += "删除成功<br>"
													fh := updateTemplate() //更新模板
													if fh != "1" {
														neirong += "模板错误，模板更新失败！<br>"
													}
												} else {
													neirong += "确定删除" + mubandir + "/" + mubanname + "？<br>"
													cid++
													neirong += fmt.Sprintf("<br><a style='color:red;' onclick=cmd(%d)>[确定删除]</a><br><br>", cid)
													dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd4, "cmd5": cmd4, "mubandir": mubandir, "mubanname": mubanname}
													cid++
													neirong += fmt.Sprintf("<a onclick=cmd(%d)>[取消删除]</a><br><br>", cid)
													dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "mubandir": mubandir}
												}
											}
										}
										cid++
										neirong += fmt.Sprintf("<a onclick=cmd(%d)>返回上一级</a><br>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "mubandir": mubandir}
									} else {
										cid++
										neirong += fmt.Sprintf(" [<a onclick=cmd(%d)>新建</a>]<br>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": "新建模板", "mubandir": mubandir}
										fs, _ := listFiles("./templates/index/" + mubandir)
										if len(fs) > 0 {
											i := 0
											for _, v := range fs {
												fileName := filepath.Base(v)
												i++
												cid++
												size, _ := getFileSize("./templates/index/" + mubandir + "/" + fileName)
												neirong += fmt.Sprintf("%d、%s (%.2f KB) [<a onclick=cmd(%d)>修改</a>] ", i, fileName, size, cid)
												dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": "修改模板", "mubandir": mubandir, "mubanname": fileName}
												cid++
												neirong += fmt.Sprintf(" [<a onclick=cmd(%d)>删除</a>]<br>", cid)
												dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": "删除模板", "mubandir": mubandir, "mubanname": fileName}
											}
										} else {
											neirong += "没有任何模板文件<br>"
										}
									}
								} else if cmd3 == "切换模板" {
									zaxiang["muban"] = cmds["mubandir"]
									miscellaneous.W("1", zaxiang)
									neirong += "切换模板成功！<br>"
								} else if cmd3 == "删除模板" {
									if cmd4 != "" {
										deleteDirectory("./templates/index/" + mubandir)
										deleteDirectory("./static/index/" + mubandir)
										neirong += "删除模板成功！<br>"
										fh := updateTemplate() //更新模板
										if fh != "1" {
											neirong += "模板错误，模板更新失败！<br>"
										}
									} else {
										neirong += "确定删除模板：" + mubandir + "?<br>"
										cid++
										neirong += fmt.Sprintf("<br><a style='color:red;' onclick=cmd(%d)>[确定删除]</a><br><br>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": "删除模板", "mubandir": mubandir}
										cid++
										neirong += fmt.Sprintf("<a onclick=cmd(%d)>[取消删除]</a><br>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2}
									}
								}
							}
							cid++
							neirong += fmt.Sprintf("<br><a onclick=cmd(%d)>[返回模板管理]</a><br><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2}
						} else {
							neirong += "当前使用的模板为：" + zaxiang["muban"] + "<br>"
							neirong += "当前网站模板有：<br>"
							mls, _ := getSubDirectories("./templates/index")
							if len(mls) == 0 {
								neirong += "没有模板文件！"
							} else {
								i := 0
								for _, v := range mls {
									i++
									if v == zaxiang["muban"] {
										neirong += fmt.Sprintf("%d、%s [正在使用]", i, v)
										cid++
										neirong += fmt.Sprintf("[<a onclick=cmd(%d)>查看</a>]<br>", cid)
										dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "查看模板", "mubandir": v}
									} else {
										if v == "default" {
											cid++
											neirong += fmt.Sprintf("%d、 %s  [<a onclick=cmd(%d)>查看</a>] ", i, v, cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "查看模板", "mubandir": v}
											cid++
											neirong += fmt.Sprintf("[<a onclick=cmd(%d)>使用</a>]<br>", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "切换模板", "mubandir": v}
										} else {
											cid++
											neirong += fmt.Sprintf("%d、 %s  [<a onclick=cmd(%d)>查看</a>] ", i, v, cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "查看模板", "mubandir": v}
											cid++
											neirong += fmt.Sprintf("[<a onclick=cmd(%d)>使用</a>] ", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "切换模板", "mubandir": v}
											cid++
											neirong += fmt.Sprintf("[<a onclick=cmd(%d)>删除</a>]<br>", cid)
											dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "删除模板", "mubandir": v}
										}
									}
								}
							}
						}
					} else if cmd2 == "网站模板采集" {
						neirong += "网站模板采集：<br>"
						neirong += "<div id='infos'></div>"
						if cmd3 != "" {
							if shuju["caiji"] == "1" || shuju["caiji"] == "2" {
								caijiurl := make(map[string]map[string]string)
								caijipczd := map[string]string{
									"caijipc1": "index.htm",
									"caijipc2": "c_index.htm",
									"caijipc3": "c_images.htm",
									"caijipc4": "c_list.htm",
									"caijipc5": "a_images.htm",
									"caijipc6": "a_article.htm",
									"caijipc7": "search.htm",
								}
								caijimzd := map[string]string{
									"caijim1": "index_m.htm",
									"caijim2": "c_index_m.htm",
									"caijim3": "c_images_m.htm",
									"caijim4": "c_list_m.htm",
									"caijim5": "a_images_m.htm",
									"caijim6": "a_article_m.htm",
									"caijim7": "search_m.htm",
								}
								if shuju["caiji"] == "1" {
									if isUrl(shuju["caijipc1"]) && isUrl(shuju["caijipc2"]) && isUrl(shuju["caijipc4"]) && isUrl(shuju["caijipc6"]) {
										caijiurl["pc"] = make(map[string]string)
										for k, v := range caijipczd {
											if isUrl(shuju[k]) {
												caijiurl["pc"][v] = shuju[k]
											}
										}
									} else {
										neirong += "采集电脑版网址出错！<br>"
									}
								} else if shuju["caiji"] == "2" {
									if isUrl(shuju["caijipc1"]) && isUrl(shuju["caijipc2"]) && isUrl(shuju["caijipc4"]) && isUrl(shuju["caijipc6"]) && isUrl(shuju["caijim1"]) && isUrl(shuju["caijim2"]) && isUrl(shuju["caijim4"]) && isUrl(shuju["caijim6"]) {
										caijiurl["pc"] = make(map[string]string)
										caijiurl["m"] = make(map[string]string)
										for k, v := range caijipczd {
											if isUrl(shuju[k]) {
												caijiurl["pc"][v] = shuju[k]
											}
										}
										for k, v := range caijimzd {
											if isUrl(shuju[k]) {
												caijiurl["m"][v] = shuju[k]
											}
										}
									} else {
										neirong += "采集电脑版和移动版网址出错！<br>"
									}
								}
								if len(caijiurl["pc"]) > 0 || len(caijiurl["m"]) > 0 {
									caijistart(caijiurl, "index", conn) //开始采集模板
									neirong += "模板采集完成！"
								}
							} else {
								neirong += "采集版本出错！<br>"
							}
						} else {
							neirong += "<p>采集版本(1:只采集电脑版/2:采集电脑版和移动版)<span style='color:#E53333;'>*</span>: <input type=text name='caiji' size='3' value=''>"
							neirong += "<br>---"
							neirong += "<br>电脑版首页网址<span style='color:#E53333;'>*</span>:<input type=text name='caijipc1' size='37' value=''>"
							neirong += "<br>电脑版栏目网址(单页)<span style='color:#E53333;'>*</span>:<input type=text name='caijipc2' size='31' value=''>"
							neirong += "<br>电脑版栏目网址(图片):<input type=text name='caijipc3' size='32' value=''>"
							neirong += "<br>电脑版栏目网址(文章)<span style='color:#E53333;'>*</span>:<input type=text name='caijipc4' size='31' value=''>"
							neirong += "<br>电脑版内页网址(图片):<input type=text name='caijipc5' size='32' value=''>"
							neirong += "<br>电脑版内页网址(文章)<span style='color:#E53333;'>*</span>:<input type=text name='caijipc6' size='31' value=''>"
							neirong += "<br>电脑版搜索网址:<input type=text name='caijipc7' size='38' value=''>"
							neirong += "<br>---"
							neirong += "<br>移动版首页网址<span style='color:#E53333;'>*</span>:<input type=text name='caijim1' size='37' value=''>"
							neirong += "<br>移动版栏目网址(单页)<span style='color:#E53333;'>*</span>:<input type=text name='caijim2' size='31' value=''>"
							neirong += "<br>移动版栏目网址(图片):<input type=text name='caijim3' size='32' value=''>"
							neirong += "<br>移动版栏目网址(文章)<span style='color:#E53333;'>*</span>:<input type=text name='caijim4' size='31' value=''>"
							neirong += "<br>移动版内页网址(图片):<input type=text name='caijim5' size='32' value=''>"
							neirong += "<br>移动版内页网址(文章)<span style='color:#E53333;'>*</span>:<input type=text name='caijim6' size='31' value=''>"
							neirong += "<br>移动版搜索网址:<input type=text name='caijim7' size='38' value=''>"
							neirong += "<br>---</p>"
							cid++
							neirong += fmt.Sprintf("<input type='button' value='开始采集' onclick=cmd2(%d) required>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "采集"}
							neirong += "<p><br>首页模板---index.htm<br>"
							neirong += "单页模板---channel_index.htm<br>"
							neirong += "栏目模板(图片)---channel_img.htm<br>"
							neirong += "栏目模板(文章)---channel_list.htm<br>"
							neirong += "内页模板(图片)---article_img.htm<br>"
							neirong += "内页模板(文章)---article_article.htm<br>"
							neirong += "搜索模板---search.htm<br></p>"
						}
					} else if cmd2 == "单页网站模板采集" {
						neirong += "单页网站模板采集：<br>"
						neirong += "<div id='infos'></div>"
						if cmd3 != "" {
							shuju["name"] = removeNonAlphanumericAndUnderscore(shuju["name"]) //删除所有不是字母、数字和_的字符
							if shuju["name"] != "" && shuju["url"] != "" && shuju["banben"] != "" {
								if shuju["name"] != "static" {
									houzui := ""
									if shuju["banben"] == "2" {
										shuju["banben"] = "m"
										houzui = "_m"
									} else {
										shuju["banben"] = "pc"
									}
									//检查模板文件是否存在
									if !fileExists("./templates/index/" + zaxiang["muban"] + "/" + shuju["name"] + houzui + ".htm") {
										if isUrl(shuju["url"]) {
											caijistart2(shuju["name"], shuju["banben"], shuju["url"], "index", zaxiang["muban"], conn) //开始采集模板
											neirong += "模板采集完成！"
										} else {
											neirong += "目标网址错误！<br>"
										}
									} else {
										neirong += "模板文件已经存在！<br>"
									}
								} else {
									neirong += `不能使用"static"作为模板名称！<br>`
								}
							} else {
								neirong += "自定义模板文件名称或目标网址不能为空！<br>"
							}
						} else {
							neirong += "<p>自定义模板文件名称(如:index)<span style='color:#E53333;'>*</span>: <input type=text name='name' size='20' value=''>"
							neirong += "<br>---"
							neirong += "<br>采集版本(1:电脑版/2:移动版)<span style='color:#E53333;'>*</span>:<input type=text name='banben' size='5' value=''>"
							neirong += "<br>---"
							neirong += "<br>目标网址<span style='color:#E53333;'>*</span>:<input type=text name='url' size='40' value=''>"
							neirong += "<br>---</p>"
							cid++
							neirong += fmt.Sprintf("<input type='button' value='开始采集' onclick=cmd2(%d) required>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "采集"}
							neirong += "<p><br>首页模板---index.htm<br>"
							neirong += "单页模板---channel_index.htm<br>"
							neirong += "栏目模板(图片)---channel_img.htm<br>"
							neirong += "栏目模板(文章)---channel_list.htm<br>"
							neirong += "内页模板(图片)---article_img.htm<br>"
							neirong += "内页模板(文章)---article_article.htm<br>"
							neirong += "搜索模板---search.htm<br></p>"
						}
					} else if cmd2 == "外链推送管理" {
						ts := tuisong.R("1")
						neirong += fmt.Sprintf("外链推送管理(%d)：<br>", len(ts))
						if cmd3 != "" {
							if cmd3 == "添加" {
								if shuju["url"] != "" {
									if isUrl(shuju["url"]) {
										ts = append(ts, shuju["url"])
										tuisong.W("1", ts)
										neirong += "添加成功！<br>"
									} else {
										neirong += "网址格式错误！<br>"
									}
								} else {
									neirong += "网址不能为空！<br>"
								}
							} else if cmd3 == "删除" {
								if cmds["i"] != "" {
									for i, v := range ts {
										if v == cmds["i"] {
											ts = append(ts[:i], ts[i+1:]...)
											tuisong.W("1", ts)
											neirong += "删除成功！<br>"
											break
										}
									}
								}
							}
						}
						for _, v := range ts {
							neirong += v
							cid++
							neirong += fmt.Sprintf(" [<a onclick=cmd(%d)>删除</a>]<br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "删除", "i": v}

						}
						neirong += "<p>---<br>添加外链地址(将你的网址换成{url})：<br>"
						neirong += "<input type=text name='url' size='50' value=''>"
						neirong += "<br>---</p>"
						cid++
						neirong += fmt.Sprintf("<input type='button' value='添加' onclick=cmd2(%d) required>", cid)
						dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "添加"}
					} else if cmd2 == "404页面修改" {
						lsmbname := "./templates/default/default/404.htm"
						odata, err := os.ReadFile(lsmbname)
						if cmd3 != "" {
							savefile(lsmbname, []byte(html.UnescapeString(shuju["mubanneirong"])))
							fh := updateTemplate() //更新模板
							if fh != "1" {
								re := regexp.MustCompile(`template: ([^:]+):(\d+):`) // 定义正则表达式
								match := re.FindStringSubmatch(fh)                   // 查找匹配
								if match != nil {
									neirong += match[1] + "第" + match[2] + "行出错，修改失败！<br>"
								}
								savefile(lsmbname, []byte(odata)) //恢复
								neirong += "修改404页面：<br>"
								neirong += "<p>模板名：404.htm<br></p>"
								neirong += `<p>模板内容：<button onclick="zidonghanhang()">自动换行</button> <button onclick="quxiaozidonghanhang()">不自动换行</button><br></p>`
								neirong += `<p><textarea id='mubanneirong' name='mubanneirong' style="width: 99%; overflow: auto; word-break: break-all;color:#CCCCCC;background-color:#1F1F1F;font-family:Consolas, &quot;font-size:14px;line-height:19px;white-space-collapse:preserve;" cols="60" rows="40">` + string(shuju["mubanneirong"]) + `</textarea><br></p>`
								cid++
								neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required><br>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3}
							} else {
								neirong += shuju["mubanming"] + "<br>模板修改成功！<br>"
							}
						} else {
							if err != nil {
								neirong += "模板文件不存在！<br>"
							} else {
								neirong += "修改404页面：<br>"
								neirong += "<p>模板名：404.htm<br></p>"
								neirong += `<p>模板内容：<button onclick="zidonghanhang()">自动换行</button> <button onclick="quxiaozidonghanhang()">不自动换行</button><br></p>`
								neirong += `<p><textarea id='mubanneirong' name='mubanneirong' style="width: 99%; overflow: auto; word-break: break-all;color:#CCCCCC;background-color:#1F1F1F;font-family:Consolas, &quot;font-size:14px;line-height:19px;white-space-collapse:preserve;" cols="60" rows="40">` + html.EscapeString(string(odata)) + `</textarea><br></p>`
								cid++
								neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required><br>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd2}
							}
						}
					}
				} else {
					neirong += "<div id='infos'></div>"
					cid++
					neirong += fmt.Sprintf("<p><input type='button' value='网站模板管理' onclick=cmd(%d) required></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "网站模板管理"}
					cid++
					neirong += fmt.Sprintf("<p><input type='button' value='404页面修改' onclick=cmd(%d) required></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "404页面修改"}
					cid++
					neirong += fmt.Sprintf("<p><input type='button' value='网站模板采集' onclick=cmd(%d) required></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "网站模板采集"}
					cid++
					neirong += fmt.Sprintf("<p><input type='button' value='网站模板采集(单页)' onclick=cmd(%d) required></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "单页网站模板采集"}
					cid++
					neirong += fmt.Sprintf("<p><input type='button' value='外链推送管理' onclick=cmd(%d) required></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "外链推送管理"}
					neirong += `<p><label for="color">背景色：</label></p>`
					neirong += `<input type="color" id="color" class="form-control form-control-color" value="#CCCCCC">`
					hfmsg["color"] = ""
				}
			case "留言管理":
				toppid := toppost.R("1")
				if cmds["tianjia"] != "" {
					if cmds["tianjia2"] != "" {
						name := removeInvalidChars(shuju["name"])
						if name != "" {
							zx := miscellaneous.R("1")
							bid := zx["bid"]
							bid2, ok := strconv.Atoi(bid)
							if ok != nil {
								bid2 = 0
							}
							bid2++
							bid3 := strconv.Itoa(bid2)
							zx["bid"] = bid3
							miscellaneous.W("1", zx)
							postfield.W(bid3, PostfieldaddData{N: name, L: []string{}, Zd: []Ziduan{}})
							tp := toppost.R("1")
							tp = append(tp, bid3)
							toppost.W("1", tp)
							neirong += "表单添加成功！<br>"
						} else {
							neirong += "表单名称不能为空！<br>"
						}
					} else {
						neirong += "<p>表单名称：<br>"
						neirong += "<input type=text name='name' size='30' value=''></p>"
						cid++
						hfmsg["up"] += fmt.Sprintf("<p><input type='button' value='点击提交' onclick=cmd2(%d) required></p>", cid)
						dianjicmd[cid] = map[string]string{"cmd": cmd, "tianjia": cmds["tianjia"], "tianjia2": cmds["tianjia"]}
					}
					if neirong != "" {
						hfmsg["main"] = neirong
					}
					msgchannel[conn] <- hfmsg
					continue
				}
				pdid := cmds["pdid"]
				if cmd2 != "" && pdid != "" {
					bsj := postfield.R(pdid)
					neirong += bsj.N + "<br>"
					if cmd2 == "查看表单" {
						if cmd3 != "" {
							if cmd3 == "删除" && cmds["postid"] != "" {
								bsj.L = removeString(bsj.L, cmds["postid"])
								post.D(cmds["postid"])
								postfield.W(pdid, bsj)
								neirong += "删除成功<br>"

							} else if cmd3 == "清空所有留言" {
								for _, v := range bsj.L {
									post.D(v)
								}
								bsj.L = []string{}
								postfield.W(pdid, bsj)
								neirong += "清空成功<br>"
							}
						}
						zsl := len(bsj.L)
						if zsl > 0 {
							var lsyema int
							if yema != "" {
								lsyema, _ = strconv.Atoi(yema)
							} else {
								lsyema = 1
							}
							if lsyema < 1 {
								lsyema = 1
							}
							ksid := (lsyema - 1) * 10
							jsid := ksid + 10
							if jsid >= zsl {
								jsid = zsl
							}
							if ksid < zsl {
								for _, v := range bsj.L[ksid:jsid] {
									ksid++
									bsj2 := post.R(v)
									neirong += strconv.Itoa(ksid) + ".[" + bsj2["time"]
									cid++
									neirong += fmt.Sprintf("] [<a onclick=cmd(%d)>删除</a>]<br>", cid)
									dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "删除", "postid": v, "yema": strconv.Itoa(lsyema), "pdid": pdid}
									for _, v2 := range bsj.Zd {
										neirong += v2.N + "：" + bsj2[v2.K] + "<br>"
									}
									neirong += "<br>"
								}
							}
							//创建页码
							ymif := ""
							if lsyema > 1 {
								cid++
								ymif += fmt.Sprintf("<a onclick=cmd(%d)>上页</a> ", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "yema": strconv.Itoa(lsyema - 1), "pdid": pdid}

							}
							if jsid < zsl {
								cid++
								ymif += fmt.Sprintf("<a onclick=cmd(%d)>下.页</a> ", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "yema": strconv.Itoa(lsyema + 1), "pdid": pdid}
							}
							if ymif != "" {
								neirong += "<br>" + ymif + "<br>"
							}
							cid++
							neirong += fmt.Sprintf("<br><a onclick=cmd(%d)>[清空所有留言]</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "清空所有留言", "pdid": pdid}
						} else {
							neirong += "暂无数据<br>"
						}

					} else if cmd2 == "修改表单" {
						if cmd3 != "" {
							name := removeInvalidChars(shuju["name"])
							if name != "" {
								bsj.N = name
								postfield.W(pdid, bsj)
								neirong += "表单添加成功！<br>"
							} else {
								neirong += "表单名称不能为空！<br>"
							}
						} else {
							neirong += "<p>表单名称：<br>"
							neirong += "<input type=text name='name' size='30' value='" + bsj.N + "'></p>"
							cid++
							hfmsg["up"] += fmt.Sprintf("<p><input type='button' value='点击提交' onclick=cmd2(%d) required></p>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd, "pdid": pdid}
						}
					} else if cmd2 == "删除表单" {
						if cmd3 != "" {
							for _, v := range bsj.L {
								post.D(v)
							}
							postfield.D(pdid)
							ps := toppost.R("1")
							ps = removeString(ps, pdid)
							toppost.W("1", ps)
							neirong += "删除成功!<br>"
						} else {
							neirong += "<p>确定删除：" + bsj.N + "以及其下所有留言?</p>"
							cid++
							hfmsg["up"] += fmt.Sprintf("<p><input type='button' value='确认删除' onclick=cmd(%d) required> ", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd2, "pdid": pdid}
							cid++
							hfmsg["up"] += fmt.Sprintf("<p><input type='button' value='取消删除' onclick=cmd(%d) required> ", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2}
						}
					} else if cmd2 == "表单代码" {
						code := `<form action="/p/" method="post">`
						for _, v := range bsj.Zd {
							code += `<label for="` + v.K + `">` + v.N + `:</label>`
							if v.T == "2" {
								code += `<textarea name="` + v.K + `" cols="60" rows="4" required=""></textarea><br>`
							} else {
								code += `<input type="text" name="` + v.K + `" required="" /><br>`
							}
						}
						code += `<input type="hidden" name="pdid" value="` + pdid + `" />`
						code += `<input type="submit" value="提交" />`
						code += `</form>`
						neirong += `<p>表单代码：<button onclick="zidonghanhang()">自动换行</button> <button onclick="quxiaozidonghanhang()">不自动换行</button> <button onclick="fuzhidaima()">复制代码</button><br></p><p><a id="mubanneirong2" style="display:none;">复制成功!</a></p>`
						neirong += `<p><textarea id='mubanneirong' name='mubanneirong' style="width: 99%; overflow: auto; word-break: break-all;color:#CCCCCC;background-color:#1F1F1F;font-family:Consolas, &quot;font-size:14px;line-height:19px;white-space-collapse:preserve;" cols="60" rows="40">` + html.EscapeString(code) + `</textarea><br></p>`
					} else if cmd2 == "表单字段" {
						var bianhua = false
						//添加字段
						if cmd3 != "" {
							shuju["addziduan"] = removeInvalidChars(shuju["addziduan"])      //删除不是中文、字母和数字的字符
							shuju["addziduan2"] = removeNonAlphanumeric(shuju["addziduan2"]) //删除非字母和数字的字符
							if shuju["addziduan"] != "" && shuju["addziduan2"] != "" && shuju["addziduan3"] != "" {
								if shuju["addziduan2"] != "addziduan" && shuju["addziduan2"] != "addziduan2" && shuju["addziduan2"] != "addziduan3" && regexp.MustCompile(`^[a-zA-Z]`).MatchString(shuju["addziduan2"]) {
									ok := true
									for _, v := range bsj.Zd {
										if v.K == shuju["addziduan2"] {
											ok = false
										}

									}
									if ok {
										if shuju["addziduan3"] != "2" {
											shuju["addziduan3"] = "1"
										}
										bsj.Zd = append(bsj.Zd, Ziduan{shuju["addziduan"], shuju["addziduan2"], "", shuju["addziduan3"]})
										neirong += "新增字段成功<br>"
										bianhua = true
									} else {
										neirong += "新增字段名称重复<br>"
									}
								} else {
									neirong += "新增字段名称不可以是addziduan、addziduan2、addziduan3,且需要时字母开头<br>"
								}
							}
						}
						//删除字段
						if cmd4 != "" && cmds["ziduan"] != "" {
							var ziduan = cmds["ziduan"]
							if cmd5 != "" {
								var nid int
								//历遍获取字段位置
								for i, v := range bsj.Zd {
									if v.K == ziduan {
										nid = i
										break
									}
								}
								bsj.Zd = append(bsj.Zd[:nid], bsj.Zd[nid+1:]...)
								bianhua = true
								neirong += "成功删除 " + ziduan + " 字段!<br>"
							} else {
								neirong += "确定删除 " + ziduan + " 字段？<br>"
								cid++
								neirong += fmt.Sprintf("<br><a style='color:red;' onclick=cmd(%d)>[确定删除]</a><br><br>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": cmd3, "cmd4": cmd4, "cmd5": "删除", "ziduan": ziduan, "pdid": pdid}
								cid++
								neirong += fmt.Sprintf("<a onclick=cmd(%d)>[取消删除]</a><br><br>", cid)
								dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "pdid": pdid}
								break
							}
						}
						if bianhua {
							postfield.W(pdid, bsj)
						}
						for _, v := range bsj.Zd {
							cid++
							neirong += fmt.Sprintf(v.N+" {{.c_"+v.K+"}}：<a onclick=cmd(%d)>[删除]</a><br>", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd4": "删除", "ziduan": v.K, "pdid": pdid}
						}
						neirong += "<p>---<br>添加字段："
						neirong += "<br>字段说明(如:栏目标题): <input type=text name='addziduan' size='30' value=''>"
						neirong += "<br>字段名称(如:title):<input type=text name='addziduan2' size='35' value=''>"
						neirong += "<br>字段类型(如:1代表单行文本、2代表多行文本): <input type=text name='addziduan3' size='7' value=''>"
						neirong += "<br>---</p>"
						cid++
						neirong += fmt.Sprintf("<input type='button' value='点击提交' onclick=cmd2(%d) required>", cid)
						dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": cmd2, "cmd3": "添加字段", "pdid": pdid}
					}
				} else {
					cid++
					neirong += fmt.Sprintf("<p><a onclick=cmd(%d)>[添加表单]</a></p>", cid)
					dianjicmd[cid] = map[string]string{"cmd": cmd, "tianjia": "添加表单"}
					//获取留言
					if len(toppid) > 0 {
						var i = 0
						for _, v := range toppid {
							psj := postfield.R(v)
							i++
							cid++
							neirong += fmt.Sprintf("%d. <a onclick=cmd(%d)>%s</a>[id:%s] [%d]", i, cid, psj.N, v, len(psj.L))
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "查看表单", "pdid": v}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>修改</a>]", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "修改表单", "pdid": v}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>删除</a>] ", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "删除表单", "pdid": v}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>字段</a>] ", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "表单字段", "pdid": v}
							cid++
							neirong += fmt.Sprintf("[<a onclick=cmd(%d)>代码</a>] ", cid)
							dianjicmd[cid] = map[string]string{"cmd": cmd, "cmd2": "表单代码", "pdid": v}
						}
					}
				}
			}
		}
		if neirong != "" {
			hfmsg["main"] = neirong
		}
		msgchannel[conn] <- hfmsg
	}
}
func generateqrcode(url, l, k string) {
	content := url + "/" + l + "/" + k
	qr, _ := qrcode.New(content, qrcode.Medium)          // 生成二维码
	qr.WriteFile(256, "./static/qrcode/"+l+"/"+k+".png") // 以 PNG 格式保存二维码图片
}
func generateqrcode2(url string) {
	content := url + "/"
	qr, _ := qrcode.New(content, qrcode.Medium) // 生成首页二维码
	qr.WriteFile(256, "./static/qrcode/1.png")  // 以 PNG 格式保存二维码图片
}
func generateqrcode3(url, title, aid string) {
	content := url + "/q/" + title
	qr, _ := qrcode.New(content, qrcode.Medium)        // 生成查询数据二维码
	qr.WriteFile(256, "./static/qrcode/a/"+aid+".png") // 以 PNG 格式保存二维码图片
}
