package main

import "sort"

// 网站字段
func (m *WebFieldData) R(key string) []Ziduan {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.([]Ziduan); ok {
			return value2
		}
	}
	return []Ziduan{}
}
func (m *WebFieldData) W(key string, value []Ziduan) {
	m.data.Store(key, value)
}
func (m *WebFieldData) D(key string) {
	m.data.Delete(key)
}

// 各栏目字段
func (m *ChannelFieldData) R(key string) []Ziduan {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.([]Ziduan); ok {
			return value2
		}
	}
	return []Ziduan{}
}
func (m *ChannelFieldData) W(key string, value []Ziduan) {
	m.data.Store(key, value)
}
func (m *ChannelFieldData) D(key string) {
	m.data.Delete(key)
}

// 各文章字段
func (m *ArticleFieldData) R(key string) []Ziduan {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.([]Ziduan); ok {
			return value2
		}
	}
	return []Ziduan{}
}
func (m *ArticleFieldData) W(key string, value []Ziduan) {
	m.data.Store(key, value)
}
func (m *ArticleFieldData) D(key string) {
	m.data.Delete(key)
}

// 表单字段
func (m *PostFieldData) R(key string) PostfieldaddData {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.(PostfieldaddData); ok {
			return value2
		}
	}
	return PostfieldaddData{}
}
func (m *PostFieldData) W(key string, value PostfieldaddData) {
	m.data.Store(key, value)
}
func (m *PostFieldData) D(key string) {
	m.data.Delete(key)
}

// 各栏目
func (m *ChannelData) R(key string) map[string]string {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.(map[string]string); ok {
			return value2
		}
	}
	return map[string]string{}
}
func (m *ChannelData) W(key string, value map[string]string) {
	m.data.Store(key, value)
}
func (m *ChannelData) D(key string) {
	m.data.Delete(key)
}

// 各文章
func (m *ArticleData) R(key string) map[string]string {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.(map[string]string); ok {
			return value2
		}
	}
	return map[string]string{}
}
func (m *ArticleData) W(key string, value map[string]string) {
	m.data.Store(key, value)
}
func (m *ArticleData) D(key string) {
	m.data.Delete(key)
}

// 杂项
func (m *MiscellaneousData) R(key string) map[string]string {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.(map[string]string); ok {
			return value2
		}
	}
	return map[string]string{}
}
func (m *MiscellaneousData) W(key string, value map[string]string) {
	m.data.Store(key, value)
}
func (m *MiscellaneousData) D(key string) {
	m.data.Delete(key)
}

// 友情链接
func (m *FriendLinksData) R(key string) []Ziduan {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.([]Ziduan); ok {
			return value2
		}
	}
	return []Ziduan{}
}
func (m *FriendLinksData) W(key string, value []Ziduan) {
	m.data.Store(key, value)
}
func (m *FriendLinksData) D(key string) {
	m.data.Delete(key)
}

// 表单
func (m *PostData) R(key string) map[string]string {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.(map[string]string); ok {
			return value2
		}
	}
	return map[string]string{}
}
func (m *PostData) W(key string, value map[string]string) {
	m.data.Store(key, value)
}
func (m *PostData) D(key string) {
	m.data.Delete(key)
}

// 顶级栏目
func (m *TopchannelData) R(key string) []string {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.([]string); ok {
			return value2
		}
	}
	return []string{}
}
func (m *TopchannelData) W(key string, value []string) {
	m.data.Store(key, value)
}
func (m *TopchannelData) D(key string) {
	m.data.Delete(key)
}

// 表单列表数据
func (m *ToppostData) R(key string) []string {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.([]string); ok {
			return value2
		}
	}
	return []string{}
}
func (m *ToppostData) W(key string, value []string) {
	m.data.Store(key, value)
}
func (m *ToppostData) D(key string) {
	m.data.Delete(key)
}

// 最新文章数据
func (m *NewarticleData) R(key string) []string {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.([]string); ok {
			return value2
		}
	}
	return []string{}
}
func (m *NewarticleData) W(key string, value []string) {
	m.data.Store(key, value)
}
func (m *NewarticleData) Add(key, aid string) {
	value, ok := m.data.Load(key)
	var aids []string
	if ok {
		if existingaids, ok := value.([]string); ok {
			aids = append([]string{aid}, existingaids...)
			if len(aids) > 100 {
				aids = aids[:10]
			}
		} else {
			aids = []string{aid}
		}
	} else {
		aids = []string{aid}
	}
	m.data.Store(key, aids)
}
func (m *NewarticleData) D(key string) {
	m.data.Delete(key)
}
func (m *NewarticleData) Del(key, aid string) {
	if value, ok := m.data.Load(key); ok {
		if existingaids, ok := value.([]string); ok {
			var aids []string
			for _, v := range existingaids {
				if v != aid {
					aids = append(aids, v)
				}
			}
			if len(aids) > 0 {
				m.data.Store(key, aids)
			} else {
				m.data.Delete(key)
			}
		}
	}
}

// 标签数据
func (m *TagData) R(key string) []string {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.([]string); ok {
			return value2
		}
	}
	return []string{}
}
func (m *TagData) W(key string, value []string) {
	m.data.Store(key, value)
}
func (m *TagData) Add(key, tag string) {
	value, ok := m.data.Load(key)
	var tags []string
	if ok {
		if existingaids, ok := value.([]string); ok {
			for _, v := range existingaids {
				if v == tag {
					return
				}
			}
			tags = append([]string{tag}, existingaids...)
		} else {
			tags = []string{tag}
		}
	} else {
		tags = []string{tag}
	}
	m.data.Store(key, tags)
}
func (m *TagData) Del(key, tag string) {
	if value, ok := m.data.Load(key); ok {
		if existingaids, ok := value.([]string); ok {
			var aids []string
			for _, v := range existingaids {
				if v != tag {
					aids = append(aids, v)
				}
			}
			if len(aids) > 0 {
				m.data.Store(key, aids)
			} else {
				m.data.Delete(key)
			}
		}
	}
}
func (m *TagData) D(key string) {
	m.data.Delete(key)
}

// 搜索数据
func (m *SearchData) R(key string) []Searchlist {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.([]Searchlist); ok {
			return value2
		}
	}
	return []Searchlist{}
}
func (m *SearchData) W(key string, value []Searchlist) {
	m.data.Store(key, value)
}
func (m *SearchData) U(key, tag string) {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.([]Searchlist); ok {
			if len(value2) > 0 {
				for i, v := range value2 {
					if v.I == tag {
						value2[i].N += 1
						m.data.Store(key, value2)
						break
					}
				}
			} else {
				value2 = append(value2, Searchlist{I: tag, N: 1})
			}
			// 按N值从到到小排序
			sort.Slice(value2, func(i, j int) bool {
				return value2[i].N > value2[j].N
			})
			m.data.Store(key, value2)
		}
	}
}
func (m *SearchData) Del(key, tag string) {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.([]Searchlist); ok {
			if len(value2) > 0 {
				lstags := []Searchlist{}
				for _, v := range value2 {
					if v.I != tag {
						lstags = append(lstags, v)
					}
				}
				m.data.Store(key, lstags)
			}
		}
	}
}
func (m *SearchData) D(key string) {
	m.data.Delete(key)
}

// 浏览量
func (m *PageviewData) R(key string) int64 {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.(int64); ok {
			return value2
		}
	}
	return 1
}
func (m *PageviewData) W(key string, value int64) {
	m.data.Store(key, value)
}
func (m *PageviewData) Add(key string) {
	if value, ok := m.data.Load(key); ok {
		if existing, ok := value.(int64); ok {
			m.data.Store(key, existing+1)
		}
	}
}
func (m *PageviewData) D(key string) {
	m.data.Delete(key)
}

// 推送列表数据
func (m *TuisongData) R(key string) []string {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.([]string); ok {
			return value2
		}
	}
	return []string{}
}
func (m *TuisongData) W(key string, value []string) {
	m.data.Store(key, value)
}
func (m *TuisongData) D(key string) {
	m.data.Delete(key)
}

// user
func (m *UserData) R(key string) (*Conn, bool) {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.(*Conn); ok {
			return value2, true
		}
	}
	return nil, false
}
func (m *UserData) W(key string, value *Conn) {
	m.data.Store(key, value)
}
func (m *UserData) D(key string) {
	m.data.Delete(key)
}

// ip记录
func (m *Ipjilu) R(key string) int64 {
	if value, ok := m.data.Load(key); ok {
		if value2, ok := value.(int64); ok {
			return value2
		}
	}
	return 0
}
func (m *Ipjilu) W(key string, value int64) {
	m.data.Store(key, value)
}
func (m *Ipjilu) D(key string) {
	m.data.Delete(key)
}
