// yibaocms 无锁版
package main

import (
	"encoding/json"
	"fmt"
	"html"
	"html/template"
	"log"
	"net/http"
	"os"
	"os/signal"
	"strconv"
	"strings"
	"syscall"
	"time"

	//"github.com/gin-contrib/gzip"
	"github.com/gin-gonic/gin"
	_ "github.com/go-sql-driver/mysql"
	"github.com/gorilla/websocket"
)

// var r = gin.Default() // 创建一个默认的路由实例
var r = gin.New() // 创建一个路由实例 没有日志
func main() {
	// 设置信号捕获
	c := make(chan os.Signal, 1)
	signal.Notify(c, syscall.SIGINT, syscall.SIGTERM)
	// 在一个新的 goroutine 中等待信号
	go func() {
		<-c        // 阻塞直到接收到信号
		savedata() //保存数据到数据库
		os.Exit(0) // 退出程序
	}()
	defer func() {
		if r := recover(); r != nil {
			log.Println("致命异常:", r)
			if jincheng == 2 { //运行期间 异常退出
				savedata() //保存数据到数据库
			}
			os.Exit(0) // 退出程序
		}
	}()
	go renwuday()                        //每天任务
	chushihua()                          //初始化
	jincheng = 2                         //用户全局判断当前程序状态 1为启动 2为运行时
	_ = os.Setenv("GIN_MODE", "release") // 设置 Gin 模式为 release
	//gin.SetMode(gin.ReleaseMode)         // 设置为生产模式
	r.Use(gin.Recovery()) // 开启异常恢复
	//r.Use(gin.Logger())   // 开启日志记录
	//r.Use(gzip.Gzip(gzip.DefaultCompression)) //开启gzip压缩
	r.Static("/static", "./static")                      // 设置静态文件目录
	r.Static("/map", "./map")                            // 设置静态文件目录
	r.StaticFile("/favicon.ico", "./static/favicon.ico") // 设置单个静态文件
	//r.LoadHTMLGlob("templates/*.htm")                    // 设置 HTML 模板路径
	// 解析模板
	updateTemplate()
	//var t = template.Must(template.ParseGlob("templates/**/**/*.htm"))
	// 将模板设置到 Gin 的默认渲染器
	//updateTemplate()
	//r.LoadHTMLGlob("templates/**/**/**/*")
	/* 	r.GET("/ping", func(c *gin.Context) {
		r.LoadHTMLGlob("templates/*")
		 c.JSON(http.StatusOK, gin.H{
			"message": "pong",
		})
		// 加载模板{{.title}} Hello World
		c.HTML(http.StatusOK, "index.htm", gin.H{
			"title": "Hello World!",
		})
	}) */
	//c.Data(http.StatusOK, "text/html; charset=utf-8", []byte(neirong))//直接返回html
	//r.Use(gzip.Gzip(gzip.DefaultCompression)) //使用gzip压缩 当使用nginx代理时无需启动压缩 因为nginx自带压缩
	//网站地图相关
	r.GET("/robots.txt", func(c *gin.Context) { c.File("./map/robots.txt") })
	r.GET("/sitemap:rest", func(c *gin.Context) {
		rest := html.EscapeString(c.Param("rest")) //转义
		filePath := fmt.Sprintf("./map/sitemap%s", rest)
		if _, err := os.Stat(filePath); os.IsNotExist(err) {
			c.String(http.StatusNotFound, "怡宝CMS")
			return
		}
		c.File(filePath)
	}) /*
		r.GET("/lanmu", func(c *gin.Context) {
			alltopid := []int{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 36, 44, 53}
			dsn := "root:MxDWLdNDM37FeDT3@tcp(127.0.0.1:3306)/cncarce"
			Db, _ := sql.Open("mysql", dsn)
			Db.SetMaxIdleConns(5)                  // 最大空闲连接数
			Db.SetMaxOpenConns(20)                 // 最大打开连接数
			Db.SetConnMaxLifetime(time.Minute * 3) // 连接的最大生命周期
			var tlsc = map[int]string{}
			var lsc = map[string]string{}
			var lsced = map[int]string{}
			var idid = map[int]string{}
			for _, i := range alltopid {
				lsced[i] = "1"
				sqlstr := "SELECT topid,typename,ispart,description,keywords,seotitle,content,dq FROM dede_arctype where id=?"
				row := Db.QueryRow(sqlstr, i)
				var topid, typename, ispart, description, keywords, seotitle, content, dq string
				err := row.Scan(&topid, &typename, &ispart, &description, &keywords, &seotitle, &content, &dq)
				if err == nil {
					lx := "2"
					if ispart == "2" {
						lx = "1"
					}
					czd := channelfield.R(lx) //获取栏目字段
					//if cid, ok := lsc[typename]; !ok {
					zx := miscellaneous.R("1")
					vid := zx["vid"]
					vid2, ok := strconv.Atoi(vid)
					if ok != nil {
						vid2 = 0
					}
					vid2++
					vid3 := strconv.Itoa(vid2)
					zx["vid"] = vid3
					miscellaneous.W("1", zx)
					tlsc[i] = vid3
					idid[i] = vid3
					var csj = make(map[string]string) //初始化栏目信息
					for _, v := range czd {
						if v.K == "neirong" {
							csj[v.K] = content
						} else if v.K == "img" {
							csj[v.K] = "/static/nopic.png"
						} else if v.K == "title" {
							csj[v.K] = typename
						} else if v.K == "seotitle" {
							csj[v.K] = seotitle
						} else if v.K == "keywords" {
							csj[v.K] = keywords
						} else if v.K == "description" {
							csj[v.K] = description
						} else if v.K == "lx" {
							csj[v.K] = lx
						} else if v.K == "topid" {
							csj[v.K] = topid
						} else if v.K == "mubanl" {
							csj[v.K] = "c_list.htm"
						} else if v.K == "mubani" {
							csj[v.K] = "c_index.htm"
						} else if v.K == "mubana" {
							csj[v.K] = "a_article.htm"
						} else if v.K == "mx" {
							csj[v.K] = "1"
						}
					}
					if csj["topid"] == "0" {
						tc := topchannel.R("1")
						tc = append(tc, vid3) //保存到顶级栏目列表
						topchannel.W("1", tc) //保存
					} else {
						//在上级栏目中添加下级栏目id
						csj2 := channel.R(csj["topid"]) //获取上级栏目
						if csj2["subid"] == "" {
							csj2["subid"] = vid3
						} else {
							csj2["subid"] = csj2["subid"] + "," + vid3
						}
						channel.W(csj["topid"], csj2) //更新栏目
					}
					csj["subid"] = ""
					csj["artid"] = ""
					channel.W(vid3, csj) //添加栏目
					lsc[typename] = vid3
					log.Println("栏目", i, "成功")
					// } else {
					// 	if seotitle != "" {
					// 		csj := channel.R(cid)
					// 		csj["neirong"] = content
					// 		csj["seotitle"] = seotitle
					// 		csj["keywords"] = keywords
					// 		csj["description"] = description
					// 		channel.W(cid, csj)
					// 	}
					// }
				} else {
					//log.Println("栏目", i, "失败2", err)
				}
			}

			for _, i := range alltopid {
				lsced[i] = "1"
				sqlstr := "SELECT topid,typename,ispart,description,keywords,seotitle,content,dq FROM dede_arctype where topid=?"
				rows, err := Db.Query(sqlstr, i) // 使用 Query 代替 QueryRow
				if err == nil {
					for rows.Next() {
						var topid, typename, ispart, description, keywords, seotitle, content, dq string
						err := rows.Scan(&topid, &typename, &ispart, &description, &keywords, &seotitle, &content, &dq)
						if err == nil {
							lx := "2"
							if ispart == "2" {
								lx = "1"
							}
							czd := channelfield.R(lx) //获取栏目字段
							if cid, ok := lsc[typename]; !ok {
								zx := miscellaneous.R("1")
								vid := zx["vid"]
								vid2, ok := strconv.Atoi(vid)
								if ok != nil {
									vid2 = 0
								}
								vid2++
								vid3 := strconv.Itoa(vid2)
								zx["vid"] = vid3
								idid[i] = vid3
								miscellaneous.W("1", zx)
								var csj = make(map[string]string) //初始化栏目信息
								for _, v := range czd {
									if v.K == "neirong" {
										csj[v.K] = content
									} else if v.K == "img" {
										csj[v.K] = "/static/nopic.png"
									} else if v.K == "title" {
										csj[v.K] = typename
									} else if v.K == "seotitle" {
										csj[v.K] = seotitle
									} else if v.K == "keywords" {
										csj[v.K] = keywords
									} else if v.K == "description" {
										csj[v.K] = description
									} else if v.K == "lx" {
										csj[v.K] = lx
									} else if v.K == "topid" {
										csj[v.K] = tlsc[i]
									} else if v.K == "mubanl" {
										csj[v.K] = "c_list.htm"
									} else if v.K == "mubani" {
										csj[v.K] = "c_index.htm"
									} else if v.K == "mubana" {
										csj[v.K] = "a_article.htm"
									} else if v.K == "mx" {
										csj[v.K] = "1"
									}
								}
								if csj["topid"] == "0" {
									tc := topchannel.R("1")
									tc = append(tc, vid3) //保存到顶级栏目列表
									topchannel.W("1", tc) //保存
								} else {
									//在上级栏目中添加下级栏目id
									csj2 := channel.R(csj["topid"]) //获取上级栏目
									if csj2["subid"] == "" {
										csj2["subid"] = vid3
									} else {
										csj2["subid"] = csj2["subid"] + "," + vid3
									}
									channel.W(csj["topid"], csj2) //更新栏目
								}
								csj["subid"] = ""
								csj["artid"] = ""
								channel.W(vid3, csj) //添加栏目
								lsc[typename] = vid3
								log.Println("栏目", i, "成功")
							} else {
								idid[i] = cid
								if seotitle != "" {
									csj := channel.R(cid)
									csj["neirong"] = content
									csj["seotitle"] = seotitle
									csj["keywords"] = keywords
									csj["description"] = description
									channel.W(cid, csj)
								}
							}
						}
					}
				} else {
					//log.Println("栏目", i, "失败2", err)
				}
				defer rows.Close() // 确保在函数结束时关闭 Rows
			}
			for i := 1; i <= 50000; i++ {
				if _, ok := lsced[i]; ok {
					continue
				}
				lsced[i] = "1"
				sqlstr := "SELECT topid,typename,ispart,description,keywords,seotitle,content,dq FROM dede_arctype where id=?"
				row := Db.QueryRow(sqlstr, i)
				var topid, typename, ispart, description, keywords, seotitle, content, dq string
				err := row.Scan(&topid, &typename, &ispart, &description, &keywords, &seotitle, &content, &dq)
				if err == nil {
					if cid, ok := lsc[typename]; !ok {
						continue
					} else {
						if dq != "" {
							idid[i] = cid
							csj := channel.R(cid)
							if content != "" {
								csj["neirong"] = content
							}
							if dq != "" && !strings.Contains(dq, "河北") && !strings.Contains(dq, "山西") && !strings.Contains(dq, "辽宁") && !strings.Contains(dq, "吉林") && !strings.Contains(dq, "黑龙江") && !strings.Contains(dq, "江苏") && !strings.Contains(dq, "浙江") && !strings.Contains(dq, "安徽") && !strings.Contains(dq, "福建") && !strings.Contains(dq, "江西") && !strings.Contains(dq, "山东") && !strings.Contains(dq, "河南") && !strings.Contains(dq, "湖北") && !strings.Contains(dq, "湖南") && !strings.Contains(dq, "广东") && !strings.Contains(dq, "海南") && !strings.Contains(dq, "四川") && !strings.Contains(dq, "贵州") && !strings.Contains(dq, "云南") && !strings.Contains(dq, "陕西") && !strings.Contains(dq, "甘肃") && !strings.Contains(dq, "青海") && !strings.Contains(dq, "台湾") && !strings.Contains(dq, "内蒙古") && !strings.Contains(dq, "广西") && !strings.Contains(dq, "西藏") && !strings.Contains(dq, "宁夏") && !strings.Contains(dq, "新疆") {
								csj["seotitle"] = fmt.Sprintf("%s24小时汽车救援服务中心", dq)
								csj["keywords"] = fmt.Sprintf("%s汽车救援,%s拖车,%s汽车救援公司", dq, dq, dq)
								csj["description"] = fmt.Sprintf("%s24小时汽车救援服务中心，为您提供拖车、车辆搭电、换胎、困境救援等服务。", dq)
							}
							channel.W(cid, csj)
						}
					}
				} else {
					//log.Println("栏目", i, "失败2", err)
				}
			}
			for i := 1; i <= 50000; i++ {
				sqlstr := "SELECT typeid,title,shorttitle,litpic,description,keywords FROM dede_archives where id=?"
				row := Db.QueryRow(sqlstr, i)
				var typeid, title, shorttitle, litpic, description, keywords, body string
				err := row.Scan(&typeid, &title, &shorttitle, &litpic, &description, &keywords)
				if err == nil {
					sqlstr2 := "SELECT body FROM dede_addonarticle where aid=?"
					row2 := Db.QueryRow(sqlstr2, i)
					err := row2.Scan(&body)
					if err == nil {
						if len(body) < 6 {
							continue
						}
						pid, err := strconv.Atoi(typeid)
						if err != nil {
							continue
						}
						tr := false
						for i2 := 1; i2 <= 5; i2++ {
							if lstypeid, ok := idid[pid]; ok {
								typeid = lstypeid
								tr = true
								break
							} else {
								sqlstr3 := "SELECT topid FROM dede_arctype where id=?"
								row3 := Db.QueryRow(sqlstr3, pid)
								var topid string
								err := row3.Scan(&topid)
								if err == nil {
									pid, _ = strconv.Atoi(topid)
								}
							}
						}
						if !tr {
							continue
						}
						csj := channel.R(typeid)
						if csj["lx"] != "" {
							azd := articlefield.R(csj["lx"])
							zx := miscellaneous.R("1")
							aid := zx["aid"]
							aid2, ok := strconv.Atoi(aid)
							if ok != nil {
								aid2 = 0
							}
							aid2++
							aid3 := strconv.Itoa(aid2)
							zx["aid"] = aid3
							miscellaneous.W("1", zx)
							//初始化文章数据
							var asj = make(map[string]string)
							title = strings.ReplaceAll(title, "，", ",")
							title = strings.ReplaceAll(title, "，", ",")
							for _, v := range azd {
								if v.K == "neirong" {
									body = removeBeforeAndInclude(body, "百度百科 ")
									body = removeBeforeAndInclude(body, "编辑 ")
									body = removeBeforeAndInclude(body, "赶紧来编辑吧！")
									body = removeBeforeAndInclude(body, "添加义项 ")
									body = removeBeforeAndInclude(body, "同义词 ")
									body = removeBeforeAndInclude(body, "欢迎您与百科地理组一起交流。 ")
									body = removeBetweenIncludingStart(body, "词条标签", "<div style")
									body = strings.ReplaceAll(body, `src="/`, `src="/static/`)
									asj[v.K] = body
								} else if v.K == "title" {
									if shorttitle != "" {
										asj[v.K] = shorttitle
									} else {
										asj[v.K] = title
									}
								} else if v.K == "seotitle" {
									asj[v.K] = title
								} else if v.K == "keywords" {
									asj[v.K] = title
								} else if v.K == "description" {
									description = removeBeforeAndInclude(description, "百度百科 ")
									description = removeBeforeAndInclude(description, "编辑 ")
									description = removeBeforeAndInclude(description, "赶紧来编辑吧！")
									description = removeBeforeAndInclude(description, "添加义项 ")
									description = removeBeforeAndInclude(description, "同义词 ")
									description = removeBeforeAndInclude(description, "欢迎您与百科地理组一起交流。 ")
									asj[v.K] = description
								} else if v.K == "img" {
									if litpic != "" {
										asj[v.K] = "/static" + litpic
									} else {
										asj[v.K] = "/static/nopic.png"
									}
								} else if v.K == "time" {
									asj[v.K] = strings.Split(time.Now().String(), " m=")[0]
								} else if v.K == "topid" {
									asj[v.K] = typeid
								} else if v.K == "looks" {
									asj[v.K] = "0"
								} else if v.K == "tags" {
									asj[v.K] = title
								}
							}
							if asj["tsgs"] != "" {
								arrtsgs := strings.Split(asj["tsgs"], ",")
								for _, v := range arrtsgs {
									if v != "" {
										tag.Add("1", v)
									}
								}
							}
							article.W(aid3, asj)      //保存文章
							addartid(aid3, typeid)    //将文章id添加到所属栏目下
							newarticle.Add("1", aid3) //添加到最新文章
							log.Println("文章", aid3, "添加成功")
						}
					} else {
						log.Println("文章", i, "失败2", err)
					}
				} else {
					log.Println("文章", i, "失败", err)
				}
			}
			c.String(http.StatusNotFound, "完成")
		})*/
	//首页
	r.GET("/", func(c *gin.Context) {
		var timedata = time.Now() //获取当前时间
		sj := get_info("1")       //网站数据
		if sj == nil {
			c.HTML(http.StatusNotFound, "404.htm", gin.H{"title": "404 - " + webname})
		} else {
			//判断是否开启移动端
			var mubanname string = "index.htm"
			if sj["w_wap"] == "1" {
				userAgent := c.Request.Header.Get("User-Agent")
				if strings.Contains(userAgent, "Mobile") || strings.Contains(userAgent, "Android") || strings.Contains(userAgent, "iPhone") {
					mubanname = strings.Replace(mubanname, ".htm", "_m.htm", 1)
				}
			}

			sj["w_time"] = time.Since(timedata).String()
			sj["w_looks"] = fmt.Sprintf("%d", pageview.R("1"))
			c.HTML(http.StatusOK, "index/"+sj["z_muban"]+"/"+mubanname, sj)
			pageview.Add("1")
		}
	})
	//栏目
	r.GET("/c/:rest", func(c *gin.Context) {
		var timedata = time.Now() //获取当前时间
		rest := removeNonNumericAnd_(c.Param("rest"))
		if rest != "" {
			sj := get_list("1", rest) //栏目数据
			if sj == nil || sj["c_lx"] == "3" {
				c.HTML(http.StatusNotFound, "404.htm", gin.H{"title": "404 - " + webname})
			} else {
				var mubanname string
				if sj["c_lx"] == "2" {
					mubanname = sj["c_mubani"]
				} else {
					mubanname = sj["c_mubanl"]
				}
				//判断是否开启移动端
				if sj["w_wap"] == "1" {
					userAgent := c.Request.Header.Get("User-Agent")
					if strings.Contains(userAgent, "Mobile") || strings.Contains(userAgent, "Android") || strings.Contains(userAgent, "iPhone") {
						mubanname = strings.Replace(mubanname, ".htm", "_m.htm", 1)
					}
				}
				sj["w_time"] = time.Since(timedata).String()
				sj["w_looks"] = fmt.Sprintf("%d", pageview.R("1"))
				c.HTML(http.StatusOK, "index/"+sj["z_muban"]+"/"+mubanname, sj)
				pageview.Add("1")
			}
		} else {
			c.HTML(http.StatusOK, "404.htm", gin.H{"title": "404 - " + webname})
		}

	})
	//文章
	r.GET("/a/:rest", func(c *gin.Context) {
		var timedata = time.Now() //获取当前时间
		rest := removeNonNumeric(c.Param("rest"))
		if rest != "" {
			sj := get_art("1", rest) //文章数据
			if sj == nil || sj["c_lx"] == "3" {
				c.HTML(http.StatusNotFound, "404.htm", gin.H{"title": "404 - " + webname})
			} else {
				var mubanname string = sj["c_mubana"]
				//判断是否开启移动端
				if sj["w_wap"] == "1" {
					userAgent := c.Request.Header.Get("User-Agent")
					if strings.Contains(userAgent, "Mobile") || strings.Contains(userAgent, "Android") || strings.Contains(userAgent, "iPhone") {
						mubanname = strings.Replace(mubanname, ".htm", "_m.htm", 1)
					}
				}
				sj["w_time"] = time.Since(timedata).String()
				sj["w_looks"] = fmt.Sprintf("%d", pageview.R("1"))
				c.HTML(http.StatusOK, "index/"+sj["z_muban"]+"/"+mubanname, sj)
				pageview.Add("1")
			}
		} else {
			c.HTML(http.StatusNotFound, "404.htm", gin.H{"title": "404 - " + webname})
		}
	})
	//搜索
	r.GET("/s/:rest", func(c *gin.Context) {
		var timedata = time.Now() //获取当前时间
		rest := removeNonChinese(c.Param("rest"))
		qp := strings.Split(rest, "_") //转切片
		yema := 1
		if len(qp) > 1 && qp[1] != "" {
			yema2, err := strconv.Atoi(qp[1])
			if err == nil {
				yema = yema2
				if yema < 1 {
					yema = 1
				}
			}
		}
		if qp[0] != "" {
			sj := get_info("1") //网站数据
			if sj == nil {
				c.HTML(http.StatusNotFound, "404.htm", gin.H{"title": "404 - " + webname})
			} else {
				sj["s_key"] = qp[0]
				sj["s_yema"] = strconv.Itoa(yema)
				sj["s_yema2"] = ""
				sj["c_id"] = ""
				if yema > 1 {
					sj["s_yema2"] = ` 第` + strconv.Itoa(yema) + `页`
				}
				var mubanname string = "search.htm"
				//判断是否开启移动端
				if sj["w_wap"] == "1" {
					userAgent := c.Request.Header.Get("User-Agent")
					if strings.Contains(userAgent, "Mobile") || strings.Contains(userAgent, "Android") || strings.Contains(userAgent, "iPhone") {
						mubanname = strings.Replace(mubanname, ".htm", "_m.htm", 1)
					}
				}
				sj["w_time"] = time.Since(timedata).String()
				sj["w_looks"] = fmt.Sprintf("%d", pageview.R("1"))
				c.HTML(http.StatusOK, "index/"+sj["z_muban"]+"/"+mubanname, sj)
			}
		} else {
			c.HTML(http.StatusNotFound, "404.htm", gin.H{"title": "404 - " + webname})
		}
	})
	//查询
	r.GET("/q/:rest", func(c *gin.Context) {
		var timedata = time.Now() //获取当前时间
		rest := removeNonChinese(c.Param("rest"))
		if rest != "" {
			sj := get_art2("1", rest) //文章数据
			if sj == nil {
				c.HTML(http.StatusNotFound, "404.htm", gin.H{"title": "所查不存在 - " + webname})
			} else {
				var mubanname string = "query.htm"
				//判断是否开启移动端
				if sj["w_wap"] == "1" {
					userAgent := c.Request.Header.Get("User-Agent")
					if strings.Contains(userAgent, "Mobile") || strings.Contains(userAgent, "Android") || strings.Contains(userAgent, "iPhone") {
						mubanname = strings.Replace(mubanname, ".htm", "_m.htm", 1)
					}
				}
				sj["w_time"] = time.Since(timedata).String()
				sj["w_looks"] = fmt.Sprintf("%d", pageview.R("1"))
				c.HTML(http.StatusOK, "index/"+sj["z_muban"]+"/"+mubanname, sj)
			}
		} else {
			c.HTML(http.StatusNotFound, "404.htm", gin.H{"title": "404 - " + webname})
		}
	})
	//表单
	r.POST("/p", func(c *gin.Context) {
		pdid := html.EscapeString(c.PostForm("pdid"))
		psj := postfield.R(pdid)
		postsj := map[string]string{}
		postsj["time"] = time.Now().Format("2006-01-02 15:04:05")
		for _, v := range psj.Zd {
			lssj := html.EscapeString(c.PostForm(v.K))
			if len(lssj) > 300 {
				lssj = lssj[:300]
			}
			postsj[v.K] = lssj
		}
		clientIP := c.Request.Header.Get("X-Real-IP") // 如果 X-Real-IP 头为空，获取 X-Forwarded-For
		if clientIP == "" {
			clientIP = c.Request.Header.Get("X-Forwarded-For") // 如果 X-Forwarded-For 头为空，获取 RemoteAddr
			if clientIP == "" {
				clientIP = c.Request.RemoteAddr // RemoteAddr
			}
		}
		//获取时间戳
		sjc := time.Now().Unix()
		sj := ipjilu.R(clientIP)
		if sj == 0 || sj < sjc-60 {
			ipjilu.W(clientIP, sjc)
			zx := miscellaneous.R("1")
			pid := zx["pid"]
			pid2, ok := strconv.Atoi(pid)
			if ok != nil {
				pid2 = 0
			}
			pid2++
			pid3 := strconv.Itoa(pid2)
			zx["pid"] = pid3
			miscellaneous.W("1", zx)
			post.W(pid3, postsj)
			psj.L = append(psj.L, pid3)
			postfield.W(pdid, psj)
			c.Data(http.StatusOK, "text/html; charset=utf-8", []byte(`<title>表单提交...</title><meta name="viewport" content="width=device-width,minimum-scale=1,initial-scale=1"><center><br><br>提交成功!</center><center><br><a href="/">返回首页</a><center><br><a href="javascript:history.back()">返回上页</a></center>`)) //直接返回html
		} else {
			t := 60 - (sjc - sj)
			c.Data(http.StatusOK, "text/html; charset=utf-8", []byte(`<title>表单提交...</title><meta name="viewport" content="width=device-width,minimum-scale=1,initial-scale=1"><center><br><br>提交频繁，请`+fmt.Sprint(t)+`秒后再试!</center><center><br><a href="/">返回首页</a><center><br><a href="javascript:history.back()">返回上页</a></center>`))
		}
	})
	//后台入口
	r.GET("/"+safeurl, func(c *gin.Context) {
		//host := c.Request.Host
		//fmt.Println(host)
		c.HTML(http.StatusOK, "houtai.htm", gin.H{
			"safeurl": safeurl,
			"title":   webname,
		})
	})
	r.GET("/ws"+safeurl, func(c *gin.Context) {
		wsHandler(c) //websocket 连接后台交互
	})
	// 处理未找到的路由
	r.NoRoute(func(c *gin.Context) {
		c.HTML(http.StatusNotFound, "404.htm", gin.H{
			"title": "404 - " + webname,
		})
	})
	r.Run("0.0.0.0:" + port) //端口访问
	//r.Run("goweb.com:8080") //绑定域名
	//r.RunTLS("your.domain.com:443", "path/to/your/cert.pem", "path/to/your/key.pem") //https

}

func wsHandler(c *gin.Context) {
	// 升级 HTTP 连接为 WebSocket 连接
	con, err := upgrader.Upgrade(c.Writer, c.Request, nil)
	if err != nil {
		//log.Println("Failed to set websocket upgrade:", err)
		return
	}
	// 创建连接实例并设置 UID sid
	conn := &Conn{
		Conn: con,
		Uid:  "",
		Cid:  "",
		Aid:  "",
	}
	defer func() {
		msgchanneld(conn)     //删除通道
		closeConnection(conn) //关闭连接
	}()
	msgchannelw(conn)                    //创建通道
	conn.SetReadLimit(1024 * 1024 * 100) // 设置消息读取限制 100MB
	go readMessages(conn)                // 启动 Goroutine 处理消息接收
	for hfmsg := range msgchannel[conn] {
		if hfmsg["chuli"] == "1" {
			if err := conn.WriteMessage(websocket.BinaryMessage, []byte(hfmsg["msg"])); err != nil {
				log.Println("推送消息时发送消息失败:", err, "uid:", conn.Uid)
				continue
			}
		} else {
			hfmsgBytes, err := json.Marshal(hfmsg) // 将修改后的数据转换为JSON字符串
			if err != nil {
				log.Println("回复给当前连接时序列化消息失败:", err, "uid:", conn.Uid)
				continue
			}
			len := len(hfmsgBytes)
			if len > 0 {
				if len > 100 {
					hfmsgBytes = yasuo(hfmsgBytes)
				}
				if err := conn.WriteMessage(websocket.BinaryMessage, hfmsgBytes); err != nil {
					log.Println("回复给当前连接时发送消息失败:", err, "uid:", conn.Uid)
					continue
				}
			}
		}
	}
}

// 关闭 WebSocket 连接
func closeConnection(conn *Conn) {
	if conn.Uid != "" {
		user.D(conn.Uid) //删除当前连接用户
	}
	err := conn.Close()
	if err != nil {
		//log.Println("关闭连接出错:", err)
	} else {
		//log.Printf("连接已关闭")
	}
}

// 更新模板
func updateTemplate() string {
	var result string
	defer func() {
		if rs := recover(); rs != nil {

		}
	}()
	var t *template.Template
	var err error
	t, err = template.New("").Funcs(template.FuncMap{
		"getnavigation":   getnavigation,
		"getarticle":      getarticle,
		"getflink":        getflink,
		"tohtml":          tohtml,
		"totime":          totime,
		"getchanneltitle": getchanneltitle,
		"getgxlanmu":      getgxlanmu,
		"getsearchlist":   getsearchlist,
	}).ParseGlob("templates/**/**/*.htm")
	if err != nil {
		result = fmt.Sprintf("模板解析失败: %v", err)
		return result
	}
	r.SetHTMLTemplate(t)
	result = "1"
	return result
}
func renwuday() {
	defer func() {
		if r := recover(); r != nil {
			renwuday()
		}
	}()
	for {
		time.Sleep(time.Hour * 24)
		ipjilu = &Ipjilu{}
	}
}
