package main

import (
	"html/template"
	"sync"

	"github.com/gorilla/websocket"
)

// 网站字段设置
type WebFieldData struct {
	data sync.Map
}

// 各栏目字段设置
type ChannelFieldData struct {
	data sync.Map
}

// 各栏目文章字段设置
type ArticleFieldData struct {
	data sync.Map
}

// 表单字段设置
type PostFieldData struct {
	data sync.Map
}

// 各栏目数据
type ChannelData struct {
	data sync.Map
}

// 各文章数据
type ArticleData struct {
	data sync.Map
	//lock sync.RWMutex
}

// 友情连接
type FriendLinksData struct {
	data sync.Map
}

// 杂项数据
type MiscellaneousData struct {
	data sync.Map
}

// 表单数据
type PostData struct {
	data sync.Map
}

// 顶级栏目数据
type TopchannelData struct {
	data sync.Map
}

// 表单列表数据
type ToppostData struct {
	data sync.Map
}

// 最新文章数据
type NewarticleData struct {
	data sync.Map
}

// 标签数据
type TagData struct {
	data sync.Map
}

// 标签搜索数据
type SearchData struct {
	data sync.Map
}

// 浏览量
type PageviewData struct {
	data sync.Map
}

// 推送列表
type TuisongData struct {
	data sync.Map
}

// IP记录
type Ipjilu struct {
	data sync.Map
}

// user
type UserData struct {
	data sync.Map
	//data map[string]*Conn
	//lock sync.RWMutex
}

// websocket
type Conn struct {
	*websocket.Conn `json:"conn"`
	Uid             string `json:"uid"`
	Cid             string `json:"cid"`
	Aid             string `json:"aid"`
}

// 接收的数据
type Data struct {
	N     string                       `json:"n"`
	P     string                       `json:"p"`
	Cmd   string                       `json:"cmd"`
	Sid   string                       `json:"s"`
	Cid   int                          `json:"c"`
	Shuru string                       `json:"m"`
	Shuju map[string]string            `json:"sj"`
	Ping  string                       `json:"ping"`
	Imgtp string                       `json:"imgtp"`
	Imgs  map[string]map[string]string `json:"imgs"`
	Up    string                       `json:"up"`
	Ab    string                       `json:"ab"`
	Ups   string                       `json:"ups"`
	Look  string                       `json:"look"`
	Yema  int                          `json:"yema"`
	Key   string                       `json:"key"`
	K     string                       `json:"k"`
	K2    string                       `json:"k2"`
}
type Shuju struct {
	Addziduan  string `json:"addziduan"`
	Addziduan2 string `json:"addziduan2"`
}

// 字段 网站 栏目 文章通用字段
type Ziduan struct {
	N string `json:"n"` // 名称
	K string `json:"k"` // 键名
	V string `json:"v"` // 值
	T string `json:"t"` // 类型
}

// 友情连接
type FriendLink struct {
	N string `json:"n"` // 名称
	U string `json:"u"` // 链接
}

// 表单
type ZiduanPost struct {
	N string `json:"n"` // 名称
	U string `json:"u"` // 链接
}

// 获取文章返回字段
type Artlist struct {
	List template.HTML
	Page template.HTML
}

// 搜索列表
type Searchlist struct {
	I string
	N int
}

// 搜索数据
type Search struct {
	Bh   []string          `json:"bh"`
	Data map[string]uint16 `json:"data"`
}

// 表单字段+数据
type PostfieldaddData struct {
	N  string   `json:"n"`  // 名称
	L  []string `json:"l"`  // 列表
	Zd []Ziduan `json:"zd"` // 字段
}

// 保存json文件
type Backjson struct {
	WebFieldData      []Ziduan                     `json:"WebFieldData"`      // 网站字段设置
	ChannelFieldData  map[string][]Ziduan          `json:"ChannelFieldData"`  // 各栏目字段设置
	ArticleFieldData  map[string][]Ziduan          `json:"ArticleFieldData"`  // 各栏目文章字段设置
	PostFieldData     map[string]PostfieldaddData  `json:"PostFieldData"`     // 表单字段设置
	ChannelData       map[string]map[string]string `json:"ChannelData"`       // 各栏目数据
	ArticleData       map[string]map[string]string `json:"ArticleData"`       // 各文章数据
	PostData          map[string]map[string]string `json:"PostData"`          // 表单数据
	MiscellaneousData map[string]string            `json:"MiscellaneousData"` // 杂项数据
	FriendLinksData   []Ziduan                     `json:"FriendLinksData"`   // 友情连接
	TopchannelData    []string                     `json:"TopchannelData"`    // 顶级栏目数据
	ToppostData       []string                     `json:"ToppostData"`       // 表单列表数据
	TuisongData       []string                     `json:"TuisongData"`       // 推送列表
	NewarticleData    []string                     `json:"NewarticleData"`    // 最新文章数据
	TagData           []string                     `json:"TagData"`           // 标签数据
	PageviewData      int64                        `json:"PageviewData"`      // 浏览量
}
