package main

import (
	"net/http"
	"sync"

	"github.com/gorilla/websocket"
)

// 全局变量
var port, safeurl, safeuser, safepass string
var webname string = "怡宝CMS"
var upgrader = websocket.Upgrader{
	ReadBufferSize:  1024 * 1024,
	WriteBufferSize: 1024 * 5,
	CheckOrigin:     func(r *http.Request) bool { return true }, // 允许所有来源的请求
}

var webfield = &WebFieldData{}
var channelfield = &ChannelFieldData{}
var articlefield = &ArticleFieldData{}
var postfield = &PostFieldData{}
var channel = &ChannelData{}
var article = &ArticleData{}
var miscellaneous = &MiscellaneousData{}
var friendlinks = &FriendLinksData{}
var post = &PostData{}
var topchannel = &TopchannelData{}
var toppost = &ToppostData{}
var newarticle = &NewarticleData{}
var tag = &TagData{}
var pageview = &PageviewData{}
var tuisong = &TuisongData{}
var user = &UserData{}
var ipjilu = &Ipjilu{}

// var search = &SearchData{}
var jincheng = 1                                        //用户全局判断当前程序状态 1为启动 2为运行时
var mumsgchannel sync.RWMutex                           //全局锁 用于 msgchannel 读写
var msgchannel = make(map[*Conn]chan map[string]string) //msg channel
var cmdlb = []string{
	"网站设置",
	"栏目管理",
	//"文章管理",
	//	"用户管理",
	//"系统设置",
	//"广告管理",
	"友情链接",
	"留言管理",
	//"评论管理",
	//"回收站",
	//"权限管理",
	"数据备份",
	"数据还原",
	//"数据库管理",
	//"日志管理",
	//"系统信息",
	"网站更新",
	"系统维护",
}

// 网站设置 默认字段
var webzd = []Ziduan{
	{N: "网站地址", K: "link", V: "http://127.0.0.1:18088", T: "1"},
	{N: "是否开启移动端(0关闭1开启)", K: "wap", V: "0", T: "1"},
	//{N: "网站保存目录", K: "dir", V: "", T: "1"},
	//{N: "栏目保存目录", K: "cdir", V: "channel", T: "1"},
	//{N: "文章保存目录", K: "adir", V: "article", T: "1"},
	{N: "网站标题", K: "title", V: "", T: "1"},
	{N: "网站副标题", K: "ftitle", V: "", T: "1"},
	{N: "网站关键词", K: "keywords", V: "", T: "1"},
	{N: "首页名称", K: "homename", V: "首页", T: "1"},
	{N: "网站描述", K: "description", V: "", T: "2"},
	{N: "网站版权", K: "copyright", V: "Copyright © 2022-现在 YiBaoCMS All Rights Reserved.", T: "1"},
	{N: "备案信息", K: "beian", V: "粤ICP备2024000000号", T: "1"},
	{N: "公司名称", K: "company", V: "", T: "1"},
	{N: "公司简介", K: "about", V: "", T: "2"},
	{N: "联 系 人", K: "contacts", V: "", T: "1"},
	{N: "联系电话", K: "tel", V: "", T: "1"},
	{N: "联系邮箱", K: "email", V: "", T: "1"},
	{N: "联系QQ", K: "qq", V: "", T: "1"},
	{N: "联系地址", K: "address", V: "", T: "1"},
	//{N: "百度token", K: "baidutoken", V: "", T: "1"},
}
var channelzd = []Ziduan{
	{N: "栏目标题", K: "title", V: "", T: "1"},
	{N: "栏目SEO标题", K: "seotitle", V: "", T: "1"},
	{N: "栏目关键词", K: "keywords", V: "", T: "1"},
	{N: "栏目描述", K: "description", V: "", T: "2"},
	{N: "栏目图片", K: "img", V: "", T: "10"},
	{N: "栏目模型", K: "mx", V: "1", T: "1"},
	{N: "栏目类型", K: "lx", V: "1", T: "1"},
	{N: "列表模板", K: "mubanl", V: "c_list.htm", T: "1"},
	{N: "单页模板", K: "mubani", V: "c_index.htm", T: "1"},
	{N: "文章模板", K: "mubana", V: "a_article.htm", T: "1"},
	{N: "所属目录", K: "topid", V: "", T: "9"},
	{N: "下属目录", K: "subid", V: "", T: "12"},
	{N: "下属文章", K: "artid", V: "", T: "12"},
	{N: "单页内容", K: "neirong", V: "", T: "4"},
}
var articlezd = []Ziduan{
	{N: "文章标题", K: "title", V: "", T: "1"},
	{N: "文章SEO标题", K: "seotitle", V: "", T: "1"},
	{N: "文章关键词", K: "keywords", V: "", T: "1"},
	{N: "文章标签", K: "tags", V: "", T: "1"},
	{N: "文章描述", K: "description", V: "", T: "2"},
	{N: "所属栏目", K: "topid", V: "", T: "5"},
	{N: "图    集", K: "imgs", V: "", T: "11"},
	{N: "缩 略 图", K: "img", V: "", T: "10"},
	{N: "添加时间", K: "time", V: "", T: "6"},
	{N: "浏览次数", K: "looks", V: "", T: "7"},
	{N: "文章内容", K: "neirong", V: "", T: "4"},
}
var zaxiangzd = map[string]string{
	"banben": "1",
	"muban":  "default",
	"vid":    "0", //栏目id
	"aid":    "0", //文章id
	"bid":    "0", //表单id
	"pid":    "0", //post表单id
}
var tuisonglist = []string{
	"https://www.sogou.com/web?query={url}",
	"https://www.so.com/s?q={url}",
	"https://cn.bing.com/search?q={url}",
	"https://www.baidu.com/s?wd={url}",
	"https://m.sm.cn/s?q={url}",
	"https://seo.chinaz.com/{url}",
	"https://m.baidu.com/s?word={url}",
	"https://so.toutiao.com/search?dvpf=pc&keyword={url}",
	"https://m.so.com/s?q={url}",
	"https://m.sogou.com/web/searchList.jsp?keyword={url}",
}
